/**********************************************************
OFDM_TIMER.C
The OFDM TIMER core serves as a replacement to the OPB_TIMER.
It allows for CSMA protocols.

Author: Chris Hunter 2/19/07
***********************************************************/

#include "ofdm_timer.h"
#include "xparameters.h"

void ofdm_timer_start(){
	*((volatile unsigned int *)(XPAR_OFDM_TIMER_OPBW_0_BASEADDR+ofdm_timer_timer_start_OFFSET)) = 1;
	*((volatile unsigned int *)(XPAR_OFDM_TIMER_OPBW_0_BASEADDR+ofdm_timer_timer_start_OFFSET)) = 0;
}

void ofdm_timer_stop(){
	*((volatile unsigned int *)(XPAR_OFDM_TIMER_OPBW_0_BASEADDR+ofdm_timer_timer_stop_OFFSET)) = 1;
	*((volatile unsigned int *)(XPAR_OFDM_TIMER_OPBW_0_BASEADDR+ofdm_timer_timer_stop_OFFSET)) = 0;
}

void ofdm_timer_setVal(unsigned int val){
	*((volatile unsigned int *)(XPAR_OFDM_TIMER_OPBW_0_BASEADDR+ofdm_timer_timer_countTo_OFFSET)) = val;
}

void ofdm_timer_setMode(unsigned char mode){
	*((volatile unsigned int *)(XPAR_OFDM_TIMER_OPBW_0_BASEADDR+ofdm_timer_timer_mode_OFFSET)) = mode;
}

void ofdm_timer_clearInterrupt(){
	*((volatile unsigned int *)(XPAR_OFDM_TIMER_OPBW_0_BASEADDR+ofdm_timer_timer_interruptReset_OFFSET)) = 1;
	*((volatile unsigned int *)(XPAR_OFDM_TIMER_OPBW_0_BASEADDR+ofdm_timer_timer_interruptReset_OFFSET)) = 0;
}

int ofdm_timer_timeLeft(){
	return *((volatile unsigned int *)(XPAR_OFDM_TIMER_OPBW_0_BASEADDR+ofdm_timer_timer_timeLeft_OFFSET));
}




