#include "xbasic_types.h"
#include "xstatus.h"
#include "xio.h"


#define OFDM_TXRX_MIMO_OFFSET (0x00000000)
//Gateways In

#define ofdm_txrx_mimo_Rx_ControlBits_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x0)
//tag name: in_0
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 0
#define ofdm_txrx_mimo_Rx_OFDM_SymbolCounts_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x4)
//tag name: in_1
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 0
#define ofdm_txrx_mimo_Rx_PktDet_Delay_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x8)
//tag name: in_2
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 0
#define ofdm_txrx_mimo_Rx_PktDet_LongCorr_Params_OFFSET (OFDM_TXRX_MIMO_OFFSET+0xC)
//tag name: in_3
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 0
#define ofdm_txrx_mimo_Rx_pktByteNums_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x10)
//tag name: in_4
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 0
#define ofdm_txrx_mimo_Rx_pktDet_Tresholds_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x14)
//tag name: in_5
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 0
#define ofdm_txrx_mimo_TxRx_FFT_Scaling_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x18)
//tag name: in_6
//arith_type = Unsigned
//num_bits = 12
//bin_pt = 0
#define ofdm_txrx_mimo_TxRx_Interrupt_PktBuf_Ctrl_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x1C)
//tag name: in_7
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 0
#define ofdm_txrx_mimo_Rx_FreqOffFilt_B_KI_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x20)
//tag name: in_8
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 32
#define ofdm_txrx_mimo_Rx_FreqOffFilt_B_KP_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x24)
//tag name: in_9
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 32
#define ofdm_txrx_mimo_Rx_PhaseNoiseTrack_K_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x28)
//tag name: in_10
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 26
#define ofdm_txrx_mimo_Rx_Constellation_Scaling_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x2C)
//tag name: in_11
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 0
#define ofdm_txrx_mimo_Tx_PreambleScaling_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x30)
//tag name: in_12
//arith_type = Unsigned
//num_bits = 16
//bin_pt = 16
#define ofdm_txrx_mimo_Tx_Pilots_Index1_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x34)
//tag name: in_13
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 0
#define ofdm_txrx_mimo_Tx_Pilots_Index2_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x38)
//tag name: in_14
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 0
#define ofdm_txrx_mimo_Tx_Pilots_Value1_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x3C)
//tag name: in_15
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 0
#define ofdm_txrx_mimo_Tx_Pilots_Value2_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x40)
//tag name: in_16
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 0
#define ofdm_txrx_mimo_Tx_OFDM_SymCounts_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x44)
//tag name: in_17
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 0
#define ofdm_txrx_mimo_Tx_PreambleMasking_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x48)
//tag name: in_18
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 0
#define ofdm_txrx_mimo_Tx_Start_Reset_Control_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x4C)
//tag name: in_19
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 0
#define ofdm_txrx_mimo_Tx_ControlBits_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x50)
//tag name: in_20
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 0

//Gateways Out

#define ofdm_txrx_mimo_Rx_Gains_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x54)
//tag name: out_21
#define ofdm_txrx_mimo_Rx_BER_Errors_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x58)
//tag name: out_22
#define ofdm_txrx_mimo_Rx_BER_TotalBits_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x5C)
//tag name: out_23
#define ofdm_txrx_mimo_Rx_packet_done_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x60)
//tag name: out_24
#define ofdm_txrx_mimo_Tx_PktRunning_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x64)
//tag name: out_25

//Shared Memory Address

#define ofdm_txrx_mimo_SMWO_PktBufferBER_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x10000)
#define ofdm_txrx_mimo_SMWO_RxModulation_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x20000)
#define ofdm_txrx_mimo_SMWO_TxModulation_OFFSET (OFDM_TXRX_MIMO_OFFSET+0x30000)


#define ofdm_txrx_mimo_WriteReg(BaseAddress, RegOffset, Data) \
	XIo_Out32((BaseAddress) + (RegOffset), (Xuint32)(Data))

#define ofdm_txrx_mimo_ReadReg(BaseAddress, RegOffset) \
	XIo_In32((BaseAddress) + (RegOffset))

//Write Reg Macro

#define ofdm_txrx_mimo_WriteReg_Rx_ControlBits(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Rx_ControlBits_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Rx_OFDM_SymbolCounts(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Rx_OFDM_SymbolCounts_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Rx_PktDet_Delay(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Rx_PktDet_Delay_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Rx_PktDet_LongCorr_Params(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Rx_PktDet_LongCorr_Params_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Rx_pktByteNums(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Rx_pktByteNums_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Rx_pktDet_Tresholds(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Rx_pktDet_Tresholds_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_TxRx_FFT_Scaling(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_TxRx_FFT_Scaling_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_TxRx_Interrupt_PktBuf_Ctrl(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_TxRx_Interrupt_PktBuf_Ctrl_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Rx_FreqOffFilt_B_KI(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Rx_FreqOffFilt_B_KI_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Rx_FreqOffFilt_B_KP(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Rx_FreqOffFilt_B_KP_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Rx_PhaseNoiseTrack_K(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Rx_PhaseNoiseTrack_K_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Rx_Constellation_Scaling(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Rx_Constellation_Scaling_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Tx_PreambleScaling(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Tx_PreambleScaling_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Tx_Pilots_Index1(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Tx_Pilots_Index1_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Tx_Pilots_Index2(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Tx_Pilots_Index2_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Tx_Pilots_Value1(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Tx_Pilots_Value1_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Tx_Pilots_Value2(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Tx_Pilots_Value2_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Tx_OFDM_SymCounts(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Tx_OFDM_SymCounts_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Tx_PreambleMasking(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Tx_PreambleMasking_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Tx_Start_Reset_Control(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Tx_Start_Reset_Control_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Tx_ControlBits(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Tx_ControlBits_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Rx_Gains(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Rx_Gains_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Rx_BER_Errors(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Rx_BER_Errors_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Rx_BER_TotalBits(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Rx_BER_TotalBits_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Rx_packet_done(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Rx_packet_done_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_Tx_PktRunning(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_Tx_PktRunning_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_SMWO_PktBufferBER(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_SMWO_PktBufferBER_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_SMWO_RxModulation(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_SMWO_RxModulation_OFFSET), (Xuint32)(Value))
#define ofdm_txrx_mimo_WriteReg_SMWO_TxModulation(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_txrx_mimo_SMWO_TxModulation_OFFSET), (Xuint32)(Value))


//Read Reg Macro

#define ofdm_txrx_mimo_ReadReg_Rx_ControlBits(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Rx_ControlBits_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Rx_OFDM_SymbolCounts(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Rx_OFDM_SymbolCounts_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Rx_PktDet_Delay(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Rx_PktDet_Delay_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Rx_PktDet_LongCorr_Params(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Rx_PktDet_LongCorr_Params_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Rx_pktByteNums(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Rx_pktByteNums_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Rx_pktDet_Tresholds(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Rx_pktDet_Tresholds_OFFSET))
#define ofdm_txrx_mimo_ReadReg_TxRx_FFT_Scaling(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_TxRx_FFT_Scaling_OFFSET))
#define ofdm_txrx_mimo_ReadReg_TxRx_Interrupt_PktBuf_Ctrl(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_TxRx_Interrupt_PktBuf_Ctrl_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Rx_FreqOffFilt_B_KI(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Rx_FreqOffFilt_B_KI_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Rx_FreqOffFilt_B_KP(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Rx_FreqOffFilt_B_KP_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Rx_PhaseNoiseTrack_K(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Rx_PhaseNoiseTrack_K_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Rx_Constellation_Scaling(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Rx_Constellation_Scaling_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Tx_PreambleScaling(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Tx_PreambleScaling_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Tx_Pilots_Index1(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Tx_Pilots_Index1_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Tx_Pilots_Index2(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Tx_Pilots_Index2_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Tx_Pilots_Value1(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Tx_Pilots_Value1_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Tx_Pilots_Value2(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Tx_Pilots_Value2_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Tx_OFDM_SymCounts(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Tx_OFDM_SymCounts_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Tx_PreambleMasking(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Tx_PreambleMasking_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Tx_Start_Reset_Control(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Tx_Start_Reset_Control_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Tx_ControlBits(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Tx_ControlBits_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Rx_Gains(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Rx_Gains_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Rx_BER_Errors(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Rx_BER_Errors_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Rx_BER_TotalBits(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Rx_BER_TotalBits_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Rx_packet_done(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Rx_packet_done_OFFSET))
#define ofdm_txrx_mimo_ReadReg_Tx_PktRunning(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_Tx_PktRunning_OFFSET))
#define ofdm_txrx_mimo_ReadReg_SMWO_PktBufferBER(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_SMWO_PktBufferBER_OFFSET))
#define ofdm_txrx_mimo_ReadReg_SMWO_RxModulation(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_SMWO_RxModulation_OFFSET))
#define ofdm_txrx_mimo_ReadReg_SMWO_TxModulation(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_txrx_mimo_SMWO_TxModulation_OFFSET))
