//-----------------------------------------------------------------------------
// clk_board_config_wrapper.v
//-----------------------------------------------------------------------------

module clk_board_config_wrapper
  (
    sys_clk,
    sys_rst,
    cfg_radio_dat_out,
    cfg_radio_csb_out,
    cfg_radio_en_out,
    cfg_radio_clk_out,
    cfg_logic_dat_out,
    cfg_logic_csb_out,
    cfg_logic_en_out,
    cfg_logic_clk_out,
    config_invalid
  );
  input sys_clk;
  input sys_rst;
  output cfg_radio_dat_out;
  output cfg_radio_csb_out;
  output cfg_radio_en_out;
  output cfg_radio_clk_out;
  output cfg_logic_dat_out;
  output cfg_logic_csb_out;
  output cfg_logic_en_out;
  output cfg_logic_clk_out;
  output config_invalid;

  defparam clk_board_config.fpga_radio_clk_source = 'h1AFF;
  defparam clk_board_config.fpga_logic_clk_source = 'h1AFF;
  defparam clk_board_config.sys_clk_freq_hz = 'h05f5e100;
  defparam clk_board_config.scp_min_freq_hz = 'h002625a0;
  defparam clk_board_config.scp_cyc_leng_a = 'h00000028;
  defparam clk_board_config.scp_cyc_leng_b = 'h00000028;
  defparam clk_board_config.scp_cyc_leng = 'h00000028;
  clock_board_config
    clk_board_config (
      .sys_clk ( sys_clk ),
      .sys_rst ( sys_rst ),
      .cfg_radio_dat_out ( cfg_radio_dat_out ),
      .cfg_radio_csb_out ( cfg_radio_csb_out ),
      .cfg_radio_en_out ( cfg_radio_en_out ),
      .cfg_radio_clk_out ( cfg_radio_clk_out ),
      .cfg_logic_dat_out ( cfg_logic_dat_out ),
      .cfg_logic_csb_out ( cfg_logic_csb_out ),
      .cfg_logic_en_out ( cfg_logic_en_out ),
      .cfg_logic_clk_out ( cfg_logic_clk_out ),
      .config_invalid ( config_invalid )
    );

endmodule

// synthesis attribute x_core_info of clock_board_config is clock_board_config_v1_02_a;

