library IEEE;                          
use IEEE.std_logic_1164.all;                          
use work.conv_pkg.all;                          
                          
entity ofdm_pktdetector_mimo_opbw is                          
  generic (                          
    C_BASEADDR: std_logic_vector(0 to 31) := X"00000000";                          
    C_HIGHADDR: std_logic_vector(0 to 31) := X"0000FFFF";                          
    C_OPB_AWIDTH: integer := 32;                          
    C_OPB_DWIDTH: integer := 32                          
  );                          
  port (                          
    ce: in std_logic;                          
    opb_abus: in std_logic_vector(0 to 31);                          
    opb_be: in std_logic_vector(0 to 3);                          
    opb_clk: in std_logic;                          
    opb_dbus: in std_logic_vector(0 to 31);                          
    opb_rnw: in std_logic;                          
    opb_rst: in std_logic;                          
    opb_select: in std_logic;                          
    opb_seqaddr: in std_logic;                          
    reset: in std_logic;                          
    rssi1: in std_logic_vector(0 to 9);                          
    rssi2: in std_logic_vector(0 to 9);                          
    rssi3: in std_logic_vector(0 to 9);                          
    rssi4: in std_logic_vector(0 to 9);                          
    avgrssi1: out std_logic_vector(0 to 15);                          
    avgrssi2: out std_logic_vector(0 to 15);                          
    avgrssi3: out std_logic_vector(0 to 15);                          
    avgrssi4: out std_logic_vector(0 to 15);                          
    debugbusy: out std_logic;                          
    debugidledifs: out std_logic;                          
    idlefordifs: out std_logic;                          
    mediumbusy: out std_logic;                          
    pktdet: out std_logic;                          
    rssi_clk_out: out std_logic;                          
    sgp_dbus: out std_logic_vector(0 to 31);                          
    sgp_errack: out std_logic;                          
    sgp_retry: out std_logic;                          
    sgp_toutsup: out std_logic;                          
    sgp_xferack: out std_logic                          
  );                          
end ofdm_pktdetector_mimo_opbw;                          
                          
architecture structural of ofdm_pktdetector_mimo_opbw is                          
  signal avgrssi1_x0: std_logic_vector(15 downto 0);                          
  signal avgrssi2_x0: std_logic_vector(15 downto 0);                          
  signal avgrssi3_x0: std_logic_vector(15 downto 0);                          
  signal avgrssi4_x0: std_logic_vector(15 downto 0);                          
  signal ce_x0: std_logic;                          
  signal clk: std_logic;                          
  signal debugbusy_x0: std_logic;                          
  signal debugidledifs_x0: std_logic;                          
  signal idlefordifs_x0: std_logic;                          
  signal mediumbusy_x0: std_logic;                          
  signal opb_abus_x0: std_logic_vector(31 downto 0);                          
  signal opb_be_x0: std_logic_vector(3 downto 0);                          
  signal opb_dbus_x0: std_logic_vector(31 downto 0);                          
  signal opb_rnw_x0: std_logic;                          
  signal opb_rst_x0: std_logic;                          
  signal opb_select_x0: std_logic;                          
  signal opb_seqaddr_x0: std_logic;                          
  signal pktdet_x0: std_logic;                          
  signal reset_x0: std_logic;                          
  signal rssi1_x0: std_logic_vector(9 downto 0);                          
  signal rssi2_x0: std_logic_vector(9 downto 0);                          
  signal rssi3_x0: std_logic_vector(9 downto 0);                          
  signal rssi4_x0: std_logic_vector(9 downto 0);                          
  signal rssi_clk_out_x0: std_logic;                          
  signal sgp_dbus_x0: std_logic_vector(31 downto 0);                          
  signal sgp_errack_x0: std_logic;                          
  signal sgp_retry_x0: std_logic;                          
  signal sgp_toutsup_x0: std_logic;                          
  signal sgp_xferack_x0: std_logic;                          
                          
begin                          
  ce_x0 <= ce;                          
  opb_abus_x0 <= opb_abus xor C_BASEADDR;
  opb_be_x0 <= opb_be;                          
  clk <= opb_clk;                          
  opb_dbus_x0 <= opb_dbus;                          
  opb_rnw_x0 <= opb_rnw;                          
  opb_rst_x0 <= opb_rst;                          
  opb_select_x0 <= opb_select;                          
  opb_seqaddr_x0 <= opb_seqaddr;                          
  reset_x0 <= reset;                          
  rssi1_x0 <= rssi1;                          
  rssi2_x0 <= rssi2;                          
  rssi3_x0 <= rssi3;                          
  rssi4_x0 <= rssi4;                          
  avgrssi1 <= avgrssi1_x0;                          
  avgrssi2 <= avgrssi2_x0;                          
  avgrssi3 <= avgrssi3_x0;                          
  avgrssi4 <= avgrssi4_x0;                          
  debugbusy <= debugbusy_x0;                          
  debugidledifs <= debugidledifs_x0;                          
  idlefordifs <= idlefordifs_x0;                          
  mediumbusy <= mediumbusy_x0;                          
  pktdet <= pktdet_x0;                          
  rssi_clk_out <= rssi_clk_out_x0;                          
  sgp_dbus <= sgp_dbus_x0;                          
  sgp_errack <= sgp_errack_x0;                          
  sgp_retry <= sgp_retry_x0;                          
  sgp_toutsup <= sgp_toutsup_x0;                          
  sgp_xferack <= sgp_xferack_x0;                          
                          
  sysgen_dut: entity work.ofdm_pktdetector_mimo_cw                          
    port map (                          
      ce => ce_x0,                          
      clk => clk,                          
      opb_abus => opb_abus_x0,                          
      opb_be => opb_be_x0,                          
      opb_dbus => opb_dbus_x0,                          
      opb_rnw => opb_rnw_x0,                          
      opb_rst => opb_rst_x0,                          
      opb_select => opb_select_x0,                          
      opb_seqaddr => opb_seqaddr_x0,                          
      reset => reset_x0,                          
      rssi1 => rssi1_x0,                          
      rssi2 => rssi2_x0,                          
      rssi3 => rssi3_x0,                          
      rssi4 => rssi4_x0,                          
      avgrssi1 => avgrssi1_x0,                          
      avgrssi2 => avgrssi2_x0,                          
      avgrssi3 => avgrssi3_x0,                          
      avgrssi4 => avgrssi4_x0,                          
      debugbusy => debugbusy_x0,                          
      debugidledifs => debugidledifs_x0,                          
      idlefordifs => idlefordifs_x0,                          
      mediumbusy => mediumbusy_x0,                          
      pktdet => pktdet_x0,                          
      rssi_clk_out => rssi_clk_out_x0,                          
      sgp_dbus => sgp_dbus_x0,                          
      sgp_errack => sgp_errack_x0,                          
      sgp_retry => sgp_retry_x0,                          
      sgp_toutsup => sgp_toutsup_x0,                          
      sgp_xferack => sgp_xferack_x0                          
    );                          
                          
end structural;                          
