library IEEE;                          
use IEEE.std_logic_1164.all;                          
use work.conv_pkg.all;                          
                          
entity ofdm_txrx_mimo_opbw is                          
  generic (                          
    C_BASEADDR: std_logic_vector(0 to 31) := X"00000000";                          
    C_HIGHADDR: std_logic_vector(0 to 31) := X"0003FFFF";                          
    C_OPB_AWIDTH: integer := 32;                          
    C_OPB_DWIDTH: integer := 32                          
  );                          
  port (                          
    bram_datain: in std_logic_vector(0 to 63);                          
    ce: in std_logic;                          
    debug_chipscopetrig1: in std_logic;                          
    opb_abus: in std_logic_vector(0 to 31);                          
    opb_be: in std_logic_vector(0 to 3);                          
    opb_clk: in std_logic;                          
    opb_dbus: in std_logic_vector(0 to 31);                          
    opb_rnw: in std_logic;                          
    opb_rst: in std_logic;                          
    opb_select: in std_logic;                          
    opb_seqaddr: in std_logic;                          
    rx_anta_adci_dv4: in std_logic_vector(0 to 13);                          
    rx_anta_adcq_dv4: in std_logic_vector(0 to 13);                          
    rx_anta_agc_done: in std_logic;                          
    rx_anta_gainbb: in std_logic_vector(0 to 4);                          
    rx_anta_gainrf: in std_logic_vector(0 to 1);                          
    rx_antb_adci_dv4: in std_logic_vector(0 to 13);                          
    rx_antb_adcq_dv4: in std_logic_vector(0 to 13);                          
    rx_antb_agc_done: in std_logic;                          
    rx_antb_gainbb: in std_logic_vector(0 to 4);                          
    rx_antb_gainrf: in std_logic_vector(0 to 1);                          
    rx_extpktdet: in std_logic;                          
    rx_reset: in std_logic;                          
    tx_reset: in std_logic;                          
    tx_starttransmit: in std_logic;                          
    bram_addr: out std_logic_vector(0 to 31);                          
    bram_dout: out std_logic_vector(0 to 63);                          
    bram_reset: out std_logic;                          
    bram_wen: out std_logic_vector(0 to 7);                          
    rx_debug_antsel: out std_logic;                          
    rx_debug_cfophasediff: out std_logic_vector(0 to 13);                          
    rx_debug_eq_i: out std_logic_vector(0 to 13);                          
    rx_debug_eq_q: out std_logic_vector(0 to 13);                          
    rx_debug_payload: out std_logic;                          
    rx_debug_phasecorrect: out std_logic_vector(0 to 13);                          
    rx_debug_phaseerror: out std_logic_vector(0 to 13);                          
    rx_debug_pktdone: out std_logic;                          
    rx_int_badpkt: out std_logic;                          
    rx_int_goodheader: out std_logic;                          
    rx_int_goodpkt: out std_logic;                          
    rx_pktdetreset: out std_logic;                          
    sgp_dbus: out std_logic_vector(0 to 31);                          
    sgp_errack: out std_logic;                          
    sgp_retry: out std_logic;                          
    sgp_toutsup: out std_logic;                          
    sgp_xferack: out std_logic;                          
    tx_anta_dac_i: out std_logic_vector(0 to 15);                          
    tx_anta_dac_q: out std_logic_vector(0 to 15);                          
    tx_antb_dac_i: out std_logic_vector(0 to 15);                          
    tx_antb_dac_q: out std_logic_vector(0 to 15);                          
    tx_debug_pktrunning: out std_logic;                          
    tx_int_pktdone: out std_logic                          
  );                          
end ofdm_txrx_mimo_opbw;                          
                          
architecture structural of ofdm_txrx_mimo_opbw is                          
  signal bram_addr_x0: std_logic_vector(31 downto 0);                          
  signal bram_datain_x0: std_logic_vector(63 downto 0);                          
  signal bram_dout_x0: std_logic_vector(63 downto 0);                          
  signal bram_reset_x0: std_logic;                          
  signal bram_wen_x0: std_logic_vector(7 downto 0);                          
  signal ce_x0: std_logic;                          
  signal clk: std_logic;                          
  signal debug_chipscopetrig1_x0: std_logic;                          
  signal opb_abus_x0: std_logic_vector(31 downto 0);                          
  signal opb_be_x0: std_logic_vector(3 downto 0);                          
  signal opb_dbus_x0: std_logic_vector(31 downto 0);                          
  signal opb_rnw_x0: std_logic;                          
  signal opb_rst_x0: std_logic;                          
  signal opb_select_x0: std_logic;                          
  signal opb_seqaddr_x0: std_logic;                          
  signal rx_anta_adci_dv4_x0: std_logic_vector(13 downto 0);                          
  signal rx_anta_adcq_dv4_x0: std_logic_vector(13 downto 0);                          
  signal rx_anta_agc_done_x0: std_logic;                          
  signal rx_anta_gainbb_x0: std_logic_vector(4 downto 0);                          
  signal rx_anta_gainrf_x0: std_logic_vector(1 downto 0);                          
  signal rx_antb_adci_dv4_x0: std_logic_vector(13 downto 0);                          
  signal rx_antb_adcq_dv4_x0: std_logic_vector(13 downto 0);                          
  signal rx_antb_agc_done_x0: std_logic;                          
  signal rx_antb_gainbb_x0: std_logic_vector(4 downto 0);                          
  signal rx_antb_gainrf_x0: std_logic_vector(1 downto 0);                          
  signal rx_debug_antsel_x0: std_logic;                          
  signal rx_debug_cfophasediff_x0: std_logic_vector(13 downto 0);                          
  signal rx_debug_eq_i_x0: std_logic_vector(13 downto 0);                          
  signal rx_debug_eq_q_x0: std_logic_vector(13 downto 0);                          
  signal rx_debug_payload_x0: std_logic;                          
  signal rx_debug_phasecorrect_x0: std_logic_vector(13 downto 0);                          
  signal rx_debug_phaseerror_x0: std_logic_vector(13 downto 0);                          
  signal rx_debug_pktdone_x0: std_logic;                          
  signal rx_extpktdet_x0: std_logic;                          
  signal rx_int_badpkt_x0: std_logic;                          
  signal rx_int_goodheader_x0: std_logic;                          
  signal rx_int_goodpkt_x0: std_logic;                          
  signal rx_pktdetreset_x0: std_logic;                          
  signal rx_reset_x0: std_logic;                          
  signal sgp_dbus_x0: std_logic_vector(31 downto 0);                          
  signal sgp_errack_x0: std_logic;                          
  signal sgp_retry_x0: std_logic;                          
  signal sgp_toutsup_x0: std_logic;                          
  signal sgp_xferack_x0: std_logic;                          
  signal tx_anta_dac_i_x0: std_logic_vector(15 downto 0);                          
  signal tx_anta_dac_q_x0: std_logic_vector(15 downto 0);                          
  signal tx_antb_dac_i_x0: std_logic_vector(15 downto 0);                          
  signal tx_antb_dac_q_x0: std_logic_vector(15 downto 0);                          
  signal tx_debug_pktrunning_x0: std_logic;                          
  signal tx_int_pktdone_x0: std_logic;                          
  signal tx_reset_x0: std_logic;                          
  signal tx_starttransmit_x0: std_logic;                          
                          
begin                          
  bram_datain_x0 <= bram_datain;                          
  ce_x0 <= ce;                          
  debug_chipscopetrig1_x0 <= debug_chipscopetrig1;                          
  opb_abus_x0 <= opb_abus xor C_BASEADDR;
  opb_be_x0 <= opb_be;                          
  clk <= opb_clk;                          
  opb_dbus_x0 <= opb_dbus;                          
  opb_rnw_x0 <= opb_rnw;                          
  opb_rst_x0 <= opb_rst;                          
  opb_select_x0 <= opb_select;                          
  opb_seqaddr_x0 <= opb_seqaddr;                          
  rx_anta_adci_dv4_x0 <= rx_anta_adci_dv4;                          
  rx_anta_adcq_dv4_x0 <= rx_anta_adcq_dv4;                          
  rx_anta_agc_done_x0 <= rx_anta_agc_done;                          
  rx_anta_gainbb_x0 <= rx_anta_gainbb;                          
  rx_anta_gainrf_x0 <= rx_anta_gainrf;                          
  rx_antb_adci_dv4_x0 <= rx_antb_adci_dv4;                          
  rx_antb_adcq_dv4_x0 <= rx_antb_adcq_dv4;                          
  rx_antb_agc_done_x0 <= rx_antb_agc_done;                          
  rx_antb_gainbb_x0 <= rx_antb_gainbb;                          
  rx_antb_gainrf_x0 <= rx_antb_gainrf;                          
  rx_extpktdet_x0 <= rx_extpktdet;                          
  rx_reset_x0 <= rx_reset;                          
  tx_reset_x0 <= tx_reset;                          
  tx_starttransmit_x0 <= tx_starttransmit;                          
  bram_addr <= bram_addr_x0;                          
  bram_dout <= bram_dout_x0;                          
  bram_reset <= bram_reset_x0;                          
  bram_wen <= bram_wen_x0;                          
  rx_debug_antsel <= rx_debug_antsel_x0;                          
  rx_debug_cfophasediff <= rx_debug_cfophasediff_x0;                          
  rx_debug_eq_i <= rx_debug_eq_i_x0;                          
  rx_debug_eq_q <= rx_debug_eq_q_x0;                          
  rx_debug_payload <= rx_debug_payload_x0;                          
  rx_debug_phasecorrect <= rx_debug_phasecorrect_x0;                          
  rx_debug_phaseerror <= rx_debug_phaseerror_x0;                          
  rx_debug_pktdone <= rx_debug_pktdone_x0;                          
  rx_int_badpkt <= rx_int_badpkt_x0;                          
  rx_int_goodheader <= rx_int_goodheader_x0;                          
  rx_int_goodpkt <= rx_int_goodpkt_x0;                          
  rx_pktdetreset <= rx_pktdetreset_x0;                          
  sgp_dbus <= sgp_dbus_x0;                          
  sgp_errack <= sgp_errack_x0;                          
  sgp_retry <= sgp_retry_x0;                          
  sgp_toutsup <= sgp_toutsup_x0;                          
  sgp_xferack <= sgp_xferack_x0;                          
  tx_anta_dac_i <= tx_anta_dac_i_x0;                          
  tx_anta_dac_q <= tx_anta_dac_q_x0;                          
  tx_antb_dac_i <= tx_antb_dac_i_x0;                          
  tx_antb_dac_q <= tx_antb_dac_q_x0;                          
  tx_debug_pktrunning <= tx_debug_pktrunning_x0;                          
  tx_int_pktdone <= tx_int_pktdone_x0;                          
                          
  sysgen_dut: entity work.ofdm_txrx_mimo_cw                          
    port map (                          
      bram_datain => bram_datain_x0,                          
      ce => ce_x0,                          
      clk => clk,                          
      debug_chipscopetrig1 => debug_chipscopetrig1_x0,                          
      opb_abus => opb_abus_x0,                          
      opb_be => opb_be_x0,                          
      opb_dbus => opb_dbus_x0,                          
      opb_rnw => opb_rnw_x0,                          
      opb_rst => opb_rst_x0,                          
      opb_select => opb_select_x0,                          
      opb_seqaddr => opb_seqaddr_x0,                          
      rx_anta_adci_dv4 => rx_anta_adci_dv4_x0,                          
      rx_anta_adcq_dv4 => rx_anta_adcq_dv4_x0,                          
      rx_anta_agc_done => rx_anta_agc_done_x0,                          
      rx_anta_gainbb => rx_anta_gainbb_x0,                          
      rx_anta_gainrf => rx_anta_gainrf_x0,                          
      rx_antb_adci_dv4 => rx_antb_adci_dv4_x0,                          
      rx_antb_adcq_dv4 => rx_antb_adcq_dv4_x0,                          
      rx_antb_agc_done => rx_antb_agc_done_x0,                          
      rx_antb_gainbb => rx_antb_gainbb_x0,                          
      rx_antb_gainrf => rx_antb_gainrf_x0,                          
      rx_extpktdet => rx_extpktdet_x0,                          
      rx_reset => rx_reset_x0,                          
      tx_reset => tx_reset_x0,                          
      tx_starttransmit => tx_starttransmit_x0,                          
      bram_addr => bram_addr_x0,                          
      bram_dout => bram_dout_x0,                          
      bram_reset => bram_reset_x0,                          
      bram_wen => bram_wen_x0,                          
      rx_debug_antsel => rx_debug_antsel_x0,                          
      rx_debug_cfophasediff => rx_debug_cfophasediff_x0,                          
      rx_debug_eq_i => rx_debug_eq_i_x0,                          
      rx_debug_eq_q => rx_debug_eq_q_x0,                          
      rx_debug_payload => rx_debug_payload_x0,                          
      rx_debug_phasecorrect => rx_debug_phasecorrect_x0,                          
      rx_debug_phaseerror => rx_debug_phaseerror_x0,                          
      rx_debug_pktdone => rx_debug_pktdone_x0,                          
      rx_int_badpkt => rx_int_badpkt_x0,                          
      rx_int_goodheader => rx_int_goodheader_x0,                          
      rx_int_goodpkt => rx_int_goodpkt_x0,                          
      rx_pktdetreset => rx_pktdetreset_x0,                          
      sgp_dbus => sgp_dbus_x0,                          
      sgp_errack => sgp_errack_x0,                          
      sgp_retry => sgp_retry_x0,                          
      sgp_toutsup => sgp_toutsup_x0,                          
      sgp_xferack => sgp_xferack_x0,                          
      tx_anta_dac_i => tx_anta_dac_i_x0,                          
      tx_anta_dac_q => tx_anta_dac_q_x0,                          
      tx_antb_dac_i => tx_antb_dac_i_x0,                          
      tx_antb_dac_q => tx_antb_dac_q_x0,                          
      tx_debug_pktrunning => tx_debug_pktrunning_x0,                          
      tx_int_pktdone => tx_int_pktdone_x0                          
    );                          
                          
end structural;                          
