-------------------------------------------------------------------------------
-- system.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

entity system is
  port (
    fpga_0_clk_board_config_sys_clk_pin : in std_logic;
    fpga_0_clk_board_config_cfg_radio_dat_out_pin : out std_logic;
    fpga_0_clk_board_config_cfg_radio_csb_out_pin : out std_logic;
    fpga_0_clk_board_config_cfg_radio_en_out_pin : out std_logic;
    fpga_0_clk_board_config_cfg_radio_clk_out_pin : out std_logic;
    fpga_0_clk_board_config_cfg_logic_dat_out_pin : out std_logic;
    fpga_0_clk_board_config_cfg_logic_csb_out_pin : out std_logic;
    fpga_0_clk_board_config_cfg_logic_en_out_pin : out std_logic;
    fpga_0_clk_board_config_cfg_logic_clk_out_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_converter_clock_out_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_radio_EEPROM_IO : inout std_logic;
    fpga_0_radio_bridge_slot_2_dac_spi_clk_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_dac_spi_cs_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_dac_spi_data_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_radio_24PA_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_radio_5PA_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_radio_ANTSW_pin : out std_logic_vector(1 downto 0);
    fpga_0_radio_bridge_slot_2_radio_dac_PLL_LOCK_pin : in std_logic;
    fpga_0_radio_bridge_slot_2_radio_dac_RESET_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_radio_DIPSW_pin : in std_logic_vector(3 downto 0);
    fpga_0_radio_bridge_slot_2_radio_LD_pin : in std_logic;
    fpga_0_radio_bridge_slot_2_radio_LED_pin : out std_logic_vector(2 downto 0);
    fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_clk_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_CLAMP_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_D_pin : in std_logic_vector(9 downto 0);
    fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_HIZ_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_OTR_pin : in std_logic;
    fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_SLEEP_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_radio_RX_ADC_DCS_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_radio_RX_ADC_DFS_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_radio_RX_ADC_OTRA_pin : in std_logic;
    fpga_0_radio_bridge_slot_2_radio_RX_ADC_OTRB_pin : in std_logic;
    fpga_0_radio_bridge_slot_2_radio_RX_ADC_PWDNA_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_radio_RX_ADC_PWDNB_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_radio_RxEn_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_radio_RxHP_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_radio_SHDN_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_radio_spi_clk_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_radio_spi_cs_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_radio_spi_data_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_radio_TxEn_pin : out std_logic;
    fpga_0_radio_bridge_slot_2_radio_B_pin : out std_logic_vector(6 downto 0);
    fpga_0_radio_bridge_slot_2_radio_DAC_I_pin : out std_logic_vector(15 downto 0);
    fpga_0_radio_bridge_slot_2_radio_DAC_Q_pin : out std_logic_vector(15 downto 0);
    fpga_0_radio_bridge_slot_2_radio_ADC_I_pin : in std_logic_vector(13 downto 0);
    fpga_0_radio_bridge_slot_2_radio_ADC_Q_pin : in std_logic_vector(13 downto 0);
    fpga_0_radio_bridge_slot_3_converter_clock_out_pin : out std_logic;
    fpga_0_radio_bridge_slot_3_radio_EEPROM_IO : inout std_logic;
    fpga_0_radio_bridge_slot_3_dac_spi_clk_pin : out std_logic;
    fpga_0_radio_bridge_slot_3_dac_spi_cs_pin : out std_logic;
    fpga_0_radio_bridge_slot_3_dac_spi_data_pin : out std_logic;
    fpga_0_radio_bridge_slot_3_radio_24PA_pin : out std_logic;
    fpga_0_radio_bridge_slot_3_radio_5PA_pin : out std_logic;
    fpga_0_radio_bridge_slot_3_radio_ANTSW_pin : out std_logic_vector(1 downto 0);
    fpga_0_radio_bridge_slot_3_radio_dac_PLL_LOCK_pin : in std_logic;
    fpga_0_radio_bridge_slot_3_radio_dac_RESET_pin : out std_logic;
    fpga_0_radio_bridge_slot_3_radio_DIPSW_pin : in std_logic_vector(3 downto 0);
    fpga_0_radio_bridge_slot_3_radio_LD_pin : in std_logic;
    fpga_0_radio_bridge_slot_3_radio_LED_pin : out std_logic_vector(2 downto 0);
    fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_clk_pin : out std_logic;
    fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_CLAMP_pin : out std_logic;
    fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_D_pin : in std_logic_vector(9 downto 0);
    fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_HIZ_pin : out std_logic;
    fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_OTR_pin : in std_logic;
    fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_SLEEP_pin : out std_logic;
    fpga_0_radio_bridge_slot_3_radio_RX_ADC_DCS_pin : out std_logic;
    fpga_0_radio_bridge_slot_3_radio_RX_ADC_DFS_pin : out std_logic;
    fpga_0_radio_bridge_slot_3_radio_RX_ADC_OTRA_pin : in std_logic;
    fpga_0_radio_bridge_slot_3_radio_RX_ADC_OTRB_pin : in std_logic;
    fpga_0_radio_bridge_slot_3_radio_RX_ADC_PWDNA_pin : out std_logic;
    fpga_0_radio_bridge_slot_3_radio_RX_ADC_PWDNB_pin : out std_logic;
    fpga_0_radio_bridge_slot_3_radio_RxEn_pin : out std_logic;
    fpga_0_radio_bridge_slot_3_radio_RxHP_pin : out std_logic;
    fpga_0_radio_bridge_slot_3_radio_SHDN_pin : out std_logic;
    fpga_0_radio_bridge_slot_3_radio_spi_clk_pin : out std_logic;
    fpga_0_radio_bridge_slot_3_radio_spi_cs_pin : out std_logic;
    fpga_0_radio_bridge_slot_3_radio_spi_data_pin : out std_logic;
    fpga_0_radio_bridge_slot_3_radio_TxEn_pin : out std_logic;
    fpga_0_radio_bridge_slot_3_radio_B_pin : out std_logic_vector(6 downto 0);
    fpga_0_radio_bridge_slot_3_radio_DAC_I_pin : out std_logic_vector(15 downto 0);
    fpga_0_radio_bridge_slot_3_radio_DAC_Q_pin : out std_logic_vector(15 downto 0);
    fpga_0_radio_bridge_slot_3_radio_ADC_I_pin : in std_logic_vector(13 downto 0);
    fpga_0_radio_bridge_slot_3_radio_ADC_Q_pin : in std_logic_vector(13 downto 0);
    fpga_0_analog_bridge_slot_4_clock_out_pin : out std_logic;
    fpga_0_analog_bridge_slot_4_analog_DAC1_A_pin : out std_logic_vector(13 downto 0);
    fpga_0_analog_bridge_slot_4_analog_DAC1_B_pin : out std_logic_vector(13 downto 0);
    fpga_0_analog_bridge_slot_4_analog_DAC2_A_pin : out std_logic_vector(13 downto 0);
    fpga_0_analog_bridge_slot_4_analog_DAC2_B_pin : out std_logic_vector(13 downto 0);
    fpga_0_analog_bridge_slot_4_analog_DAC1_sleep_pin : out std_logic;
    fpga_0_analog_bridge_slot_4_analog_DAC2_sleep_pin : out std_logic;
    fpga_0_analog_bridge_slot_4_analog_ADC_A_pin : in std_logic_vector(13 downto 0);
    fpga_0_analog_bridge_slot_4_analog_ADC_B_pin : in std_logic_vector(13 downto 0);
    fpga_0_analog_bridge_slot_4_analog_ADC_DFS_pin : out std_logic;
    fpga_0_analog_bridge_slot_4_analog_ADC_DCS_pin : out std_logic;
    fpga_0_analog_bridge_slot_4_analog_ADC_pdwnA_pin : out std_logic;
    fpga_0_analog_bridge_slot_4_analog_ADC_pdwnB_pin : out std_logic;
    fpga_0_analog_bridge_slot_4_analog_ADC_otrA_pin : in std_logic;
    fpga_0_analog_bridge_slot_4_analog_ADC_otrB_pin : in std_logic;
    fpga_0_analog_bridge_slot_4_analog_LED_pin : out std_logic_vector(0 to 2);
    fpga_0_LED_7SEGMENT_GPIO_d_out_pin : out std_logic_vector(0 to 6);
    fpga_0_LED_7SEGMENT_1_GPIO_d_out_pin : out std_logic_vector(0 to 6);
    fpga_0_LEDs_4Bit_GPIO_d_out_pin : out std_logic_vector(0 to 3);
    fpga_0_Push_Buttons_4bit_GPIO_in_pin : in std_logic_vector(0 to 3);
    fpga_0_rs232_RX_pin : in std_logic;
    fpga_0_rs232_TX_pin : out std_logic;
    fpga_0_eeprom_controller_DQ0_pin : inout std_logic;
    fpga_0_Ethernet_MAC_slew1_pin : out std_logic;
    fpga_0_Ethernet_MAC_slew2_pin : out std_logic;
    fpga_0_Ethernet_MAC_PHY_rst_n_pin : out std_logic;
    fpga_0_Ethernet_MAC_PHY_crs_pin : in std_logic;
    fpga_0_Ethernet_MAC_PHY_col_pin : in std_logic;
    fpga_0_Ethernet_MAC_PHY_tx_data_pin : out std_logic_vector(3 downto 0);
    fpga_0_Ethernet_MAC_PHY_tx_en_pin : out std_logic;
    fpga_0_Ethernet_MAC_PHY_tx_clk_pin : in std_logic;
    fpga_0_Ethernet_MAC_PHY_tx_er_pin : out std_logic;
    fpga_0_Ethernet_MAC_PHY_rx_er_pin : in std_logic;
    fpga_0_Ethernet_MAC_PHY_rx_clk_pin : in std_logic;
    fpga_0_Ethernet_MAC_PHY_dv_pin : in std_logic;
    fpga_0_Ethernet_MAC_PHY_rx_data_pin : in std_logic_vector(3 downto 0);
    fpga_0_Ethernet_MAC_PHY_Mii_clk_pin : inout std_logic;
    fpga_0_Ethernet_MAC_PHY_Mii_data_pin : inout std_logic;
    fpga_0_DIPSWs_4Bit_GPIO_in_pin : in std_logic_vector(0 to 3);
    fpga_0_SRAM0_ZBT_512Kx32_Mem_OEN_pin : out std_logic_vector(0 to 0);
    fpga_0_SRAM0_ZBT_512Kx32_Mem_ADV_LDN_pin : out std_logic;
    fpga_0_SRAM0_ZBT_512Kx32_Mem_CKEN_pin : out std_logic;
    fpga_0_SRAM0_ZBT_512Kx32_Mem_CE_pin : out std_logic;
    fpga_0_SRAM0_ZBT_512Kx32_Mem_BEN_pin : out std_logic_vector(0 to 3);
    fpga_0_SRAM0_ZBT_512Kx32_Mem_WEN_pin : out std_logic;
    fpga_0_SRAM0_ZBT_512Kx32_Mem_A_pin : out std_logic_vector(11 to 29);
    fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin : inout std_logic_vector(0 to 31);
    fpga_0_SRAM1_ZBT_512Kx32_Mem_OEN_pin : out std_logic_vector(0 to 0);
    fpga_0_SRAM1_ZBT_512Kx32_Mem_ADV_LDN_pin : out std_logic;
    fpga_0_SRAM1_ZBT_512Kx32_Mem_CKEN_pin : out std_logic;
    fpga_0_SRAM1_ZBT_512Kx32_Mem_BEN_pin : out std_logic_vector(0 to 3);
    fpga_0_SRAM1_ZBT_512Kx32_Mem_WEN_pin : out std_logic;
    fpga_0_SRAM1_ZBT_512Kx32_Mem_CE_pin : out std_logic;
    fpga_0_SRAM1_ZBT_512Kx32_Mem_A_pin : out std_logic_vector(11 to 29);
    fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin : inout std_logic_vector(0 to 31);
    fpga_0_SRAM0_CLOCK : out std_logic;
    fpga_0_SRAM1_CLOCK : out std_logic;
    sys_clk_pin : in std_logic;
    sys_rst_pin : in std_logic;
    debug : out std_logic_vector(0 to 9);
    debug_chipscopetrig_pin : in std_logic;
    debug_GPIO_d_out_pin : out std_logic_vector(0 to 3);
    user_io_board_controller_opbw_0_cs_pin : out std_logic;
    user_io_board_controller_opbw_0_resetlcd_pin : out std_logic;
    user_io_board_controller_opbw_0_scl_pin : out std_logic;
    user_io_board_controller_opbw_0_sdi_pin : out std_logic
  );
end system;

architecture STRUCTURE of system is

  component ppc405_0_wrapper is
    port (
      C405CPMCORESLEEPREQ : out std_logic;
      C405CPMMSRCE : out std_logic;
      C405CPMMSREE : out std_logic;
      C405CPMTIMERIRQ : out std_logic;
      C405CPMTIMERRESETREQ : out std_logic;
      C405XXXMACHINECHECK : out std_logic;
      CPMC405CLOCK : in std_logic;
      CPMC405CORECLKINACTIVE : in std_logic;
      CPMC405CPUCLKEN : in std_logic;
      CPMC405JTAGCLKEN : in std_logic;
      CPMC405TIMERCLKEN : in std_logic;
      CPMC405TIMERTICK : in std_logic;
      MCBCPUCLKEN : in std_logic;
      MCBTIMEREN : in std_logic;
      MCPPCRST : in std_logic;
      PLBCLK : in std_logic;
      DCRCLK : in std_logic;
      C405RSTCHIPRESETREQ : out std_logic;
      C405RSTCORERESETREQ : out std_logic;
      C405RSTSYSRESETREQ : out std_logic;
      RSTC405RESETCHIP : in std_logic;
      RSTC405RESETCORE : in std_logic;
      RSTC405RESETSYS : in std_logic;
      C405PLBICUABUS : out std_logic_vector(0 to 31);
      C405PLBICUBE : out std_logic_vector(0 to 7);
      C405PLBICURNW : out std_logic;
      C405PLBICUABORT : out std_logic;
      C405PLBICUBUSLOCK : out std_logic;
      C405PLBICUU0ATTR : out std_logic;
      C405PLBICUGUARDED : out std_logic;
      C405PLBICULOCKERR : out std_logic;
      C405PLBICUMSIZE : out std_logic_vector(0 to 1);
      C405PLBICUORDERED : out std_logic;
      C405PLBICUPRIORITY : out std_logic_vector(0 to 1);
      C405PLBICURDBURST : out std_logic;
      C405PLBICUREQUEST : out std_logic;
      C405PLBICUSIZE : out std_logic_vector(0 to 3);
      C405PLBICUTYPE : out std_logic_vector(0 to 2);
      C405PLBICUWRBURST : out std_logic;
      C405PLBICUWRDBUS : out std_logic_vector(0 to 63);
      C405PLBICUCACHEABLE : out std_logic;
      PLBC405ICUADDRACK : in std_logic;
      PLBC405ICUBUSY : in std_logic;
      PLBC405ICUERR : in std_logic;
      PLBC405ICURDBTERM : in std_logic;
      PLBC405ICURDDACK : in std_logic;
      PLBC405ICURDDBUS : in std_logic_vector(0 to 63);
      PLBC405ICURDWDADDR : in std_logic_vector(0 to 3);
      PLBC405ICUREARBITRATE : in std_logic;
      PLBC405ICUWRBTERM : in std_logic;
      PLBC405ICUWRDACK : in std_logic;
      PLBC405ICUSSIZE : in std_logic_vector(0 to 1);
      PLBC405ICUSERR : in std_logic;
      PLBC405ICUSBUSYS : in std_logic;
      C405PLBDCUABUS : out std_logic_vector(0 to 31);
      C405PLBDCUBE : out std_logic_vector(0 to 7);
      C405PLBDCURNW : out std_logic;
      C405PLBDCUABORT : out std_logic;
      C405PLBDCUBUSLOCK : out std_logic;
      C405PLBDCUU0ATTR : out std_logic;
      C405PLBDCUGUARDED : out std_logic;
      C405PLBDCULOCKERR : out std_logic;
      C405PLBDCUMSIZE : out std_logic_vector(0 to 1);
      C405PLBDCUORDERED : out std_logic;
      C405PLBDCUPRIORITY : out std_logic_vector(0 to 1);
      C405PLBDCURDBURST : out std_logic;
      C405PLBDCUREQUEST : out std_logic;
      C405PLBDCUSIZE : out std_logic_vector(0 to 3);
      C405PLBDCUTYPE : out std_logic_vector(0 to 2);
      C405PLBDCUWRBURST : out std_logic;
      C405PLBDCUWRDBUS : out std_logic_vector(0 to 63);
      C405PLBDCUCACHEABLE : out std_logic;
      C405PLBDCUWRITETHRU : out std_logic;
      PLBC405DCUADDRACK : in std_logic;
      PLBC405DCUBUSY : in std_logic;
      PLBC405DCUERR : in std_logic;
      PLBC405DCURDBTERM : in std_logic;
      PLBC405DCURDDACK : in std_logic;
      PLBC405DCURDDBUS : in std_logic_vector(0 to 63);
      PLBC405DCURDWDADDR : in std_logic_vector(0 to 3);
      PLBC405DCUREARBITRATE : in std_logic;
      PLBC405DCUWRBTERM : in std_logic;
      PLBC405DCUWRDACK : in std_logic;
      PLBC405DCUSSIZE : in std_logic_vector(0 to 1);
      PLBC405DCUSERR : in std_logic;
      PLBC405DCUSBUSYS : in std_logic;
      BRAMDSOCMCLK : in std_logic;
      BRAMDSOCMRDDBUS : in std_logic_vector(0 to 31);
      DSARCVALUE : in std_logic_vector(0 to 7);
      DSCNTLVALUE : in std_logic_vector(0 to 7);
      DSOCMBRAMABUS : out std_logic_vector(8 to 29);
      DSOCMBRAMBYTEWRITE : out std_logic_vector(0 to 3);
      DSOCMBRAMEN : out std_logic;
      DSOCMBRAMWRDBUS : out std_logic_vector(0 to 31);
      DSOCMBUSY : out std_logic;
      BRAMISOCMCLK : in std_logic;
      BRAMISOCMRDDBUS : in std_logic_vector(0 to 63);
      ISARCVALUE : in std_logic_vector(0 to 7);
      ISCNTLVALUE : in std_logic_vector(0 to 7);
      ISOCMBRAMEN : out std_logic;
      ISOCMBRAMEVENWRITEEN : out std_logic;
      ISOCMBRAMODDWRITEEN : out std_logic;
      ISOCMBRAMRDABUS : out std_logic_vector(8 to 28);
      ISOCMBRAMWRABUS : out std_logic_vector(8 to 28);
      ISOCMBRAMWRDBUS : out std_logic_vector(0 to 31);
      C405DCRABUS : out std_logic_vector(0 to 9);
      C405DCRDBUSOUT : out std_logic_vector(0 to 31);
      C405DCRREAD : out std_logic;
      C405DCRWRITE : out std_logic;
      DCRC405ACK : in std_logic;
      DCRC405DBUSIN : in std_logic_vector(0 to 31);
      EICC405CRITINPUTIRQ : in std_logic;
      EICC405EXTINPUTIRQ : in std_logic;
      C405JTGCAPTUREDR : out std_logic;
      C405JTGEXTEST : out std_logic;
      C405JTGPGMOUT : out std_logic;
      C405JTGSHIFTDR : out std_logic;
      C405JTGTDO : out std_logic;
      C405JTGTDOEN : out std_logic;
      C405JTGUPDATEDR : out std_logic;
      MCBJTAGEN : in std_logic;
      JTGC405BNDSCANTDO : in std_logic;
      JTGC405TCK : in std_logic;
      JTGC405TDI : in std_logic;
      JTGC405TMS : in std_logic;
      JTGC405TRSTNEG : in std_logic;
      C405DBGMSRWE : out std_logic;
      C405DBGSTOPACK : out std_logic;
      C405DBGWBCOMPLETE : out std_logic;
      C405DBGWBFULL : out std_logic;
      C405DBGWBIAR : out std_logic_vector(0 to 29);
      DBGC405DEBUGHALT : in std_logic;
      DBGC405EXTBUSHOLDACK : in std_logic;
      DBGC405UNCONDDEBUGEVENT : in std_logic;
      C405TRCCYCLE : out std_logic;
      C405TRCEVENEXECUTIONSTATUS : out std_logic_vector(0 to 1);
      C405TRCODDEXECUTIONSTATUS : out std_logic_vector(0 to 1);
      C405TRCTRACESTATUS : out std_logic_vector(0 to 3);
      C405TRCTRIGGEREVENTOUT : out std_logic;
      C405TRCTRIGGEREVENTTYPE : out std_logic_vector(0 to 10);
      TRCC405TRACEDISABLE : in std_logic;
      TRCC405TRIGGEREVENTIN : in std_logic
    );
  end component;

  component ppc405_1_wrapper is
    port (
      C405CPMCORESLEEPREQ : out std_logic;
      C405CPMMSRCE : out std_logic;
      C405CPMMSREE : out std_logic;
      C405CPMTIMERIRQ : out std_logic;
      C405CPMTIMERRESETREQ : out std_logic;
      C405XXXMACHINECHECK : out std_logic;
      CPMC405CLOCK : in std_logic;
      CPMC405CORECLKINACTIVE : in std_logic;
      CPMC405CPUCLKEN : in std_logic;
      CPMC405JTAGCLKEN : in std_logic;
      CPMC405TIMERCLKEN : in std_logic;
      CPMC405TIMERTICK : in std_logic;
      MCBCPUCLKEN : in std_logic;
      MCBTIMEREN : in std_logic;
      MCPPCRST : in std_logic;
      PLBCLK : in std_logic;
      DCRCLK : in std_logic;
      C405RSTCHIPRESETREQ : out std_logic;
      C405RSTCORERESETREQ : out std_logic;
      C405RSTSYSRESETREQ : out std_logic;
      RSTC405RESETCHIP : in std_logic;
      RSTC405RESETCORE : in std_logic;
      RSTC405RESETSYS : in std_logic;
      C405PLBICUABUS : out std_logic_vector(0 to 31);
      C405PLBICUBE : out std_logic_vector(0 to 7);
      C405PLBICURNW : out std_logic;
      C405PLBICUABORT : out std_logic;
      C405PLBICUBUSLOCK : out std_logic;
      C405PLBICUU0ATTR : out std_logic;
      C405PLBICUGUARDED : out std_logic;
      C405PLBICULOCKERR : out std_logic;
      C405PLBICUMSIZE : out std_logic_vector(0 to 1);
      C405PLBICUORDERED : out std_logic;
      C405PLBICUPRIORITY : out std_logic_vector(0 to 1);
      C405PLBICURDBURST : out std_logic;
      C405PLBICUREQUEST : out std_logic;
      C405PLBICUSIZE : out std_logic_vector(0 to 3);
      C405PLBICUTYPE : out std_logic_vector(0 to 2);
      C405PLBICUWRBURST : out std_logic;
      C405PLBICUWRDBUS : out std_logic_vector(0 to 63);
      C405PLBICUCACHEABLE : out std_logic;
      PLBC405ICUADDRACK : in std_logic;
      PLBC405ICUBUSY : in std_logic;
      PLBC405ICUERR : in std_logic;
      PLBC405ICURDBTERM : in std_logic;
      PLBC405ICURDDACK : in std_logic;
      PLBC405ICURDDBUS : in std_logic_vector(0 to 63);
      PLBC405ICURDWDADDR : in std_logic_vector(0 to 3);
      PLBC405ICUREARBITRATE : in std_logic;
      PLBC405ICUWRBTERM : in std_logic;
      PLBC405ICUWRDACK : in std_logic;
      PLBC405ICUSSIZE : in std_logic_vector(0 to 1);
      PLBC405ICUSERR : in std_logic;
      PLBC405ICUSBUSYS : in std_logic;
      C405PLBDCUABUS : out std_logic_vector(0 to 31);
      C405PLBDCUBE : out std_logic_vector(0 to 7);
      C405PLBDCURNW : out std_logic;
      C405PLBDCUABORT : out std_logic;
      C405PLBDCUBUSLOCK : out std_logic;
      C405PLBDCUU0ATTR : out std_logic;
      C405PLBDCUGUARDED : out std_logic;
      C405PLBDCULOCKERR : out std_logic;
      C405PLBDCUMSIZE : out std_logic_vector(0 to 1);
      C405PLBDCUORDERED : out std_logic;
      C405PLBDCUPRIORITY : out std_logic_vector(0 to 1);
      C405PLBDCURDBURST : out std_logic;
      C405PLBDCUREQUEST : out std_logic;
      C405PLBDCUSIZE : out std_logic_vector(0 to 3);
      C405PLBDCUTYPE : out std_logic_vector(0 to 2);
      C405PLBDCUWRBURST : out std_logic;
      C405PLBDCUWRDBUS : out std_logic_vector(0 to 63);
      C405PLBDCUCACHEABLE : out std_logic;
      C405PLBDCUWRITETHRU : out std_logic;
      PLBC405DCUADDRACK : in std_logic;
      PLBC405DCUBUSY : in std_logic;
      PLBC405DCUERR : in std_logic;
      PLBC405DCURDBTERM : in std_logic;
      PLBC405DCURDDACK : in std_logic;
      PLBC405DCURDDBUS : in std_logic_vector(0 to 63);
      PLBC405DCURDWDADDR : in std_logic_vector(0 to 3);
      PLBC405DCUREARBITRATE : in std_logic;
      PLBC405DCUWRBTERM : in std_logic;
      PLBC405DCUWRDACK : in std_logic;
      PLBC405DCUSSIZE : in std_logic_vector(0 to 1);
      PLBC405DCUSERR : in std_logic;
      PLBC405DCUSBUSYS : in std_logic;
      BRAMDSOCMCLK : in std_logic;
      BRAMDSOCMRDDBUS : in std_logic_vector(0 to 31);
      DSARCVALUE : in std_logic_vector(0 to 7);
      DSCNTLVALUE : in std_logic_vector(0 to 7);
      DSOCMBRAMABUS : out std_logic_vector(8 to 29);
      DSOCMBRAMBYTEWRITE : out std_logic_vector(0 to 3);
      DSOCMBRAMEN : out std_logic;
      DSOCMBRAMWRDBUS : out std_logic_vector(0 to 31);
      DSOCMBUSY : out std_logic;
      BRAMISOCMCLK : in std_logic;
      BRAMISOCMRDDBUS : in std_logic_vector(0 to 63);
      ISARCVALUE : in std_logic_vector(0 to 7);
      ISCNTLVALUE : in std_logic_vector(0 to 7);
      ISOCMBRAMEN : out std_logic;
      ISOCMBRAMEVENWRITEEN : out std_logic;
      ISOCMBRAMODDWRITEEN : out std_logic;
      ISOCMBRAMRDABUS : out std_logic_vector(8 to 28);
      ISOCMBRAMWRABUS : out std_logic_vector(8 to 28);
      ISOCMBRAMWRDBUS : out std_logic_vector(0 to 31);
      C405DCRABUS : out std_logic_vector(0 to 9);
      C405DCRDBUSOUT : out std_logic_vector(0 to 31);
      C405DCRREAD : out std_logic;
      C405DCRWRITE : out std_logic;
      DCRC405ACK : in std_logic;
      DCRC405DBUSIN : in std_logic_vector(0 to 31);
      EICC405CRITINPUTIRQ : in std_logic;
      EICC405EXTINPUTIRQ : in std_logic;
      C405JTGCAPTUREDR : out std_logic;
      C405JTGEXTEST : out std_logic;
      C405JTGPGMOUT : out std_logic;
      C405JTGSHIFTDR : out std_logic;
      C405JTGTDO : out std_logic;
      C405JTGTDOEN : out std_logic;
      C405JTGUPDATEDR : out std_logic;
      MCBJTAGEN : in std_logic;
      JTGC405BNDSCANTDO : in std_logic;
      JTGC405TCK : in std_logic;
      JTGC405TDI : in std_logic;
      JTGC405TMS : in std_logic;
      JTGC405TRSTNEG : in std_logic;
      C405DBGMSRWE : out std_logic;
      C405DBGSTOPACK : out std_logic;
      C405DBGWBCOMPLETE : out std_logic;
      C405DBGWBFULL : out std_logic;
      C405DBGWBIAR : out std_logic_vector(0 to 29);
      DBGC405DEBUGHALT : in std_logic;
      DBGC405EXTBUSHOLDACK : in std_logic;
      DBGC405UNCONDDEBUGEVENT : in std_logic;
      C405TRCCYCLE : out std_logic;
      C405TRCEVENEXECUTIONSTATUS : out std_logic_vector(0 to 1);
      C405TRCODDEXECUTIONSTATUS : out std_logic_vector(0 to 1);
      C405TRCTRACESTATUS : out std_logic_vector(0 to 3);
      C405TRCTRIGGEREVENTOUT : out std_logic;
      C405TRCTRIGGEREVENTTYPE : out std_logic_vector(0 to 10);
      TRCC405TRACEDISABLE : in std_logic;
      TRCC405TRIGGEREVENTIN : in std_logic
    );
  end component;

  component jtagppc_0_wrapper is
    port (
      TRSTNEG : in std_logic;
      HALTNEG0 : in std_logic;
      DBGC405DEBUGHALT0 : out std_logic;
      HALTNEG1 : in std_logic;
      DBGC405DEBUGHALT1 : out std_logic;
      C405JTGTDO0 : in std_logic;
      C405JTGTDOEN0 : in std_logic;
      JTGC405TCK0 : out std_logic;
      JTGC405TDI0 : out std_logic;
      JTGC405TMS0 : out std_logic;
      JTGC405TRSTNEG0 : out std_logic;
      C405JTGTDO1 : in std_logic;
      C405JTGTDOEN1 : in std_logic;
      JTGC405TCK1 : out std_logic;
      JTGC405TDI1 : out std_logic;
      JTGC405TMS1 : out std_logic;
      JTGC405TRSTNEG1 : out std_logic
    );
  end component;

  component reset_block_wrapper is
    port (
      Slowest_sync_clk : in std_logic;
      Ext_Reset_In : in std_logic;
      Aux_Reset_In : in std_logic;
      Core_Reset_Req : in std_logic;
      Chip_Reset_Req : in std_logic;
      System_Reset_Req : in std_logic;
      Dcm_locked : in std_logic;
      Rstc405resetcore : out std_logic;
      Rstc405resetchip : out std_logic;
      Rstc405resetsys : out std_logic;
      Bus_Struct_Reset : out std_logic_vector(0 to 0);
      Peripheral_Reset : out std_logic_vector(0 to 0)
    );
  end component;

  component iocm_wrapper is
    port (
      ISOCM_Clk : in std_logic;
      SYS_Rst : in std_logic;
      ISOCM_Rst : out std_logic;
      M_ISOCMBRAMRDABUS : in std_logic_vector(8 to 28);
      M_ISOCMBRAMWRABUS : in std_logic_vector(8 to 28);
      M_ISOCMBRAMEN : in std_logic;
      M_ISOCMBRAMWRDBUS : in std_logic_vector(0 to 31);
      M_ISOCMBRAMODDWRITEEN : in std_logic;
      M_ISOCMBRAMEVENWRITEEN : in std_logic;
      M_ISOCMDCRBRAMODDEN : in std_logic;
      M_ISOCMDCRBRAMEVENEN : in std_logic;
      M_ISOCMDCRBRAMRDSELECT : in std_logic;
      S_BRAMISOCMRDDBUS : in std_logic_vector(0 to 63);
      S_BRAMISOCMDCRRDDBUS : in std_logic_vector(0 to 31);
      S_ISOCMSLAVESELECT : in std_logic_vector(0 to 0);
      S_ISOCMDCRSLAVESELECT : in std_logic_vector(0 to 0);
      BRAMISOCMRDDBUS : out std_logic_vector(0 to 63);
      ISARCVALUE : out std_logic_vector(0 to 7);
      ISCNTLVALUE : out std_logic_vector(0 to 7);
      ISOCMBRAMEN : out std_logic;
      ISOCMBRAMWRDBUS : out std_logic_vector(0 to 31);
      ISOCMBRAMODDWRITEEN : out std_logic;
      ISOCMBRAMEVENWRITEEN : out std_logic;
      ISOCMBRAMRDABUS : out std_logic_vector(8 to 28);
      ISOCMBRAMWRABUS : out std_logic_vector(8 to 28);
      ISOCMDCRBRAMODDEN : out std_logic;
      ISOCMDCRBRAMEVENEN : out std_logic;
      ISOCMDCRBRAMRDSELECT : out std_logic;
      BRAMISOCMDCRRDDBUS : out std_logic_vector(0 to 31)
    );
  end component;

  component iocm_cntlr_wrapper is
    port (
      BRAMISOCMCLK : in std_logic;
      ISBRAMRST : in std_logic;
      ISOCMBRAMRDABUS : in std_logic_vector(8 to 28);
      ISOCMBRAMWRABUS : in std_logic_vector(8 to 28);
      ISOCMBRAMEN : in std_logic;
      ISOCMBRAMWRDBUS : in std_logic_vector(0 to 31);
      ISOCMBRAMODDWRITEEN : in std_logic;
      ISOCMBRAMEVENWRITEEN : in std_logic;
      ISOCMDCRBRAMODDEN : in std_logic;
      ISOCMDCRBRAMEVENEN : in std_logic;
      ISOCMDCRBRAMRDSELECT : in std_logic;
      S_BRAMISOCMRDDBUS : out std_logic_vector(0 to 63);
      S_BRAMISOCMDCRRDDBUS : out std_logic_vector(0 to 31);
      S_ISOCMSLAVESELECT : out std_logic;
      S_ISOCMDCRSLAVESELECT : out std_logic;
      BRAM_Rst_A : out std_logic;
      BRAM_Clk_A : out std_logic;
      BRAM_Addr_A : out std_logic_vector(0 to 31);
      BRAM_EN_A : out std_logic;
      BRAM_WEN_A : out std_logic_vector(0 to 1);
      BRAM_Dout_A : out std_logic_vector(0 to 63);
      BRAM_Din_A : in std_logic_vector(0 to 63);
      BRAM_Rst_B : out std_logic;
      BRAM_Clk_B : out std_logic;
      BRAM_Addr_B : out std_logic_vector(0 to 31);
      BRAM_EN_B : out std_logic;
      BRAM_WEN_B : out std_logic_vector(0 to 1);
      BRAM_Dout_B : out std_logic_vector(0 to 63);
      BRAM_Din_B : in std_logic_vector(0 to 63)
    );
  end component;

  component isocm_bram_wrapper is
    port (
      BRAM_Rst_A : in std_logic;
      BRAM_Clk_A : in std_logic;
      BRAM_EN_A : in std_logic;
      BRAM_WEN_A : in std_logic_vector(0 to 1);
      BRAM_Addr_A : in std_logic_vector(0 to 31);
      BRAM_Din_A : out std_logic_vector(0 to 63);
      BRAM_Dout_A : in std_logic_vector(0 to 63);
      BRAM_Rst_B : in std_logic;
      BRAM_Clk_B : in std_logic;
      BRAM_EN_B : in std_logic;
      BRAM_WEN_B : in std_logic_vector(0 to 1);
      BRAM_Addr_B : in std_logic_vector(0 to 31);
      BRAM_Din_B : out std_logic_vector(0 to 63);
      BRAM_Dout_B : in std_logic_vector(0 to 63)
    );
  end component;

  component docm_wrapper is
    port (
      DSOCM_Clk : in std_logic;
      SYS_Rst : in std_logic;
      DSOCM_Rst : out std_logic;
      M_DSOCMBRAMABUS : in std_logic_vector(8 to 29);
      M_DSOCMBRAMBYTEWRITE : in std_logic_vector(0 to 3);
      M_DSOCMBRAMEN : in std_logic;
      M_DSOCMBRAMWRDBUS : in std_logic_vector(0 to 31);
      M_DSOCMBUSY : in std_logic;
      M_DSOCMRDADDRVALID : in std_logic;
      M_DSOCMWRADDRVALID : in std_logic;
      S_BRAMDSOCMRDDBUS : in std_logic_vector(0 to 31);
      S_DSOCMRWCOMPLETE : in std_logic_vector(0 to 0);
      S_DSOCMSLAVESELECT : in std_logic_vector(0 to 0);
      BRAMDSOCMRDDBUS : out std_logic_vector(0 to 31);
      DSARCVALUE : out std_logic_vector(0 to 7);
      DSCNTLVALUE : out std_logic_vector(0 to 7);
      DSOCMBRAMWRDBUS : out std_logic_vector(0 to 31);
      DSOCMBRAMEN : out std_logic;
      DSOCMBRAMBYTEWRITE : out std_logic_vector(0 to 3);
      DSOCMBRAMABUS : out std_logic_vector(8 to 29);
      DSOCMBUSY : out std_logic;
      DSOCMRDADDRVALID : out std_logic;
      DSOCMWRADDRVALID : out std_logic;
      DSOCMRWCOMPLETE : out std_logic
    );
  end component;

  component docm_cntlr_wrapper is
    port (
      BRAMDSOCMCLK : in std_logic;
      DSBRAMRST : in std_logic;
      DSOCMBRAMABUS : in std_logic_vector(8 to 29);
      DSOCMBRAMBYTEWRITE : in std_logic_vector(0 to 3);
      DSOCMBRAMEN : in std_logic;
      DSOCMBRAMWRDBUS : in std_logic_vector(0 to 31);
      S_BRAMDSOCMRDDBUS : out std_logic_vector(0 to 31);
      S_DSOCMRWCOMPLETE : out std_logic;
      S_DSOCMSLAVESELECT : out std_logic;
      BRAM_Rst_A : out std_logic;
      BRAM_Clk_A : out std_logic;
      BRAM_EN_A : out std_logic;
      BRAM_WEN_A : out std_logic_vector(0 to 3);
      BRAM_Addr_A : out std_logic_vector(0 to 31);
      BRAM_Din_A : in std_logic_vector(0 to 31);
      BRAM_Dout_A : out std_logic_vector(0 to 31)
    );
  end component;

  component dsocm_bram_wrapper is
    port (
      BRAM_Rst_A : in std_logic;
      BRAM_Clk_A : in std_logic;
      BRAM_EN_A : in std_logic;
      BRAM_WEN_A : in std_logic_vector(0 to 3);
      BRAM_Addr_A : in std_logic_vector(0 to 31);
      BRAM_Din_A : out std_logic_vector(0 to 31);
      BRAM_Dout_A : in std_logic_vector(0 to 31);
      BRAM_Rst_B : in std_logic;
      BRAM_Clk_B : in std_logic;
      BRAM_EN_B : in std_logic;
      BRAM_WEN_B : in std_logic_vector(0 to 3);
      BRAM_Addr_B : in std_logic_vector(0 to 31);
      BRAM_Din_B : out std_logic_vector(0 to 31);
      BRAM_Dout_B : in std_logic_vector(0 to 31)
    );
  end component;

  component plb_wrapper is
    port (
      PLB_Clk : in std_logic;
      SYS_Rst : in std_logic;
      PLB_Rst : out std_logic;
      PLB_dcrAck : out std_logic;
      PLB_dcrDBus : out std_logic_vector(0 to 31);
      DCR_ABus : in std_logic_vector(0 to 9);
      DCR_DBus : in std_logic_vector(0 to 31);
      DCR_Read : in std_logic;
      DCR_Write : in std_logic;
      M_ABus : in std_logic_vector(0 to 95);
      M_BE : in std_logic_vector(0 to 23);
      M_RNW : in std_logic_vector(0 to 2);
      M_abort : in std_logic_vector(0 to 2);
      M_busLock : in std_logic_vector(0 to 2);
      M_compress : in std_logic_vector(0 to 2);
      M_guarded : in std_logic_vector(0 to 2);
      M_lockErr : in std_logic_vector(0 to 2);
      M_MSize : in std_logic_vector(0 to 5);
      M_ordered : in std_logic_vector(0 to 2);
      M_priority : in std_logic_vector(0 to 5);
      M_rdBurst : in std_logic_vector(0 to 2);
      M_request : in std_logic_vector(0 to 2);
      M_size : in std_logic_vector(0 to 11);
      M_type : in std_logic_vector(0 to 8);
      M_wrBurst : in std_logic_vector(0 to 2);
      M_wrDBus : in std_logic_vector(0 to 191);
      Sl_addrAck : in std_logic_vector(0 to 5);
      Sl_MErr : in std_logic_vector(0 to 17);
      Sl_MBusy : in std_logic_vector(0 to 17);
      Sl_rdBTerm : in std_logic_vector(0 to 5);
      Sl_rdComp : in std_logic_vector(0 to 5);
      Sl_rdDAck : in std_logic_vector(0 to 5);
      Sl_rdDBus : in std_logic_vector(0 to 383);
      Sl_rdWdAddr : in std_logic_vector(0 to 23);
      Sl_rearbitrate : in std_logic_vector(0 to 5);
      Sl_SSize : in std_logic_vector(0 to 11);
      Sl_wait : in std_logic_vector(0 to 5);
      Sl_wrBTerm : in std_logic_vector(0 to 5);
      Sl_wrComp : in std_logic_vector(0 to 5);
      Sl_wrDAck : in std_logic_vector(0 to 5);
      PLB_ABus : out std_logic_vector(0 to 31);
      PLB_BE : out std_logic_vector(0 to 7);
      PLB_MAddrAck : out std_logic_vector(0 to 2);
      PLB_MBusy : out std_logic_vector(0 to 2);
      PLB_MErr : out std_logic_vector(0 to 2);
      PLB_MRdBTerm : out std_logic_vector(0 to 2);
      PLB_MRdDAck : out std_logic_vector(0 to 2);
      PLB_MRdDBus : out std_logic_vector(0 to 191);
      PLB_MRdWdAddr : out std_logic_vector(0 to 11);
      PLB_MRearbitrate : out std_logic_vector(0 to 2);
      PLB_MWrBTerm : out std_logic_vector(0 to 2);
      PLB_MWrDAck : out std_logic_vector(0 to 2);
      PLB_MSSize : out std_logic_vector(0 to 5);
      PLB_PAValid : out std_logic;
      PLB_RNW : out std_logic;
      PLB_SAValid : out std_logic;
      PLB_abort : out std_logic;
      PLB_busLock : out std_logic;
      PLB_compress : out std_logic;
      PLB_guarded : out std_logic;
      PLB_lockErr : out std_logic;
      PLB_masterID : out std_logic_vector(0 to 1);
      PLB_MSize : out std_logic_vector(0 to 1);
      PLB_ordered : out std_logic;
      PLB_pendPri : out std_logic_vector(0 to 1);
      PLB_pendReq : out std_logic;
      PLB_rdBurst : out std_logic;
      PLB_rdPrim : out std_logic;
      PLB_reqPri : out std_logic_vector(0 to 1);
      PLB_size : out std_logic_vector(0 to 3);
      PLB_type : out std_logic_vector(0 to 2);
      PLB_wrBurst : out std_logic;
      PLB_wrDBus : out std_logic_vector(0 to 63);
      PLB_wrPrim : out std_logic;
      PLB_SaddrAck : out std_logic;
      PLB_SMErr : out std_logic_vector(0 to 2);
      PLB_SMBusy : out std_logic_vector(0 to 2);
      PLB_SrdBTerm : out std_logic;
      PLB_SrdComp : out std_logic;
      PLB_SrdDAck : out std_logic;
      PLB_SrdDBus : out std_logic_vector(0 to 63);
      PLB_SrdWdAddr : out std_logic_vector(0 to 3);
      PLB_Srearbitrate : out std_logic;
      PLB_Sssize : out std_logic_vector(0 to 1);
      PLB_Swait : out std_logic;
      PLB_SwrBTerm : out std_logic;
      PLB_SwrComp : out std_logic;
      PLB_SwrDAck : out std_logic;
      PLB2OPB_rearb : in std_logic_vector(0 to 5);
      ArbAddrVldReg : out std_logic;
      Bus_Error_Det : out std_logic
    );
  end component;

  component opb_wrapper is
    port (
      OPB_Clk : in std_logic;
      OPB_Rst : out std_logic;
      SYS_Rst : in std_logic;
      Debug_SYS_Rst : in std_logic;
      WDT_Rst : in std_logic;
      M_ABus : in std_logic_vector(0 to 31);
      M_BE : in std_logic_vector(0 to 3);
      M_beXfer : in std_logic_vector(0 to 0);
      M_busLock : in std_logic_vector(0 to 0);
      M_DBus : in std_logic_vector(0 to 31);
      M_DBusEn : in std_logic_vector(0 to 0);
      M_DBusEn32_63 : in std_logic_vector(0 to 0);
      M_dwXfer : in std_logic_vector(0 to 0);
      M_fwXfer : in std_logic_vector(0 to 0);
      M_hwXfer : in std_logic_vector(0 to 0);
      M_request : in std_logic_vector(0 to 0);
      M_RNW : in std_logic_vector(0 to 0);
      M_select : in std_logic_vector(0 to 0);
      M_seqAddr : in std_logic_vector(0 to 0);
      Sl_beAck : in std_logic_vector(0 to 14);
      Sl_DBus : in std_logic_vector(0 to 479);
      Sl_DBusEn : in std_logic_vector(0 to 14);
      Sl_DBusEn32_63 : in std_logic_vector(0 to 14);
      Sl_errAck : in std_logic_vector(0 to 14);
      Sl_dwAck : in std_logic_vector(0 to 14);
      Sl_fwAck : in std_logic_vector(0 to 14);
      Sl_hwAck : in std_logic_vector(0 to 14);
      Sl_retry : in std_logic_vector(0 to 14);
      Sl_toutSup : in std_logic_vector(0 to 14);
      Sl_xferAck : in std_logic_vector(0 to 14);
      OPB_MRequest : out std_logic_vector(0 to 0);
      OPB_ABus : out std_logic_vector(0 to 31);
      OPB_BE : out std_logic_vector(0 to 3);
      OPB_beXfer : out std_logic;
      OPB_beAck : out std_logic;
      OPB_busLock : out std_logic;
      OPB_rdDBus : out std_logic_vector(0 to 31);
      OPB_wrDBus : out std_logic_vector(0 to 31);
      OPB_DBus : out std_logic_vector(0 to 31);
      OPB_errAck : out std_logic;
      OPB_dwAck : out std_logic;
      OPB_dwXfer : out std_logic;
      OPB_fwAck : out std_logic;
      OPB_fwXfer : out std_logic;
      OPB_hwAck : out std_logic;
      OPB_hwXfer : out std_logic;
      OPB_MGrant : out std_logic_vector(0 to 0);
      OPB_pendReq : out std_logic_vector(0 to 0);
      OPB_retry : out std_logic;
      OPB_RNW : out std_logic;
      OPB_select : out std_logic;
      OPB_seqAddr : out std_logic;
      OPB_timeout : out std_logic;
      OPB_toutSup : out std_logic;
      OPB_xferAck : out std_logic
    );
  end component;

  component plb2opb_wrapper is
    port (
      PLB_Clk : in std_logic;
      OPB_Clk : in std_logic;
      PLB_Rst : in std_logic;
      OPB_Rst : in std_logic;
      Bus_Error_Det : out std_logic;
      BGI_Trans_Abort : out std_logic;
      BGO_dcrAck : out std_logic;
      BGO_dcrDBus : out std_logic_vector(0 to 31);
      DCR_ABus : in std_logic_vector(0 to 9);
      DCR_DBus : in std_logic_vector(0 to 31);
      DCR_Read : in std_logic;
      DCR_Write : in std_logic;
      BGO_addrAck : out std_logic;
      BGO_MErr : out std_logic_vector(0 to 2);
      BGO_MBusy : out std_logic_vector(0 to 2);
      BGO_rdBTerm : out std_logic;
      BGO_rdComp : out std_logic;
      BGO_rdDAck : out std_logic;
      BGO_rdDBus : out std_logic_vector(0 to 63);
      BGO_rdWdAddr : out std_logic_vector(0 to 3);
      BGO_rearbitrate : out std_logic;
      BGO_SSize : out std_logic_vector(0 to 1);
      BGO_wait : out std_logic;
      BGO_wrBTerm : out std_logic;
      BGO_wrComp : out std_logic;
      BGO_wrDAck : out std_logic;
      PLB_abort : in std_logic;
      PLB_ABus : in std_logic_vector(0 to 31);
      PLB_BE : in std_logic_vector(0 to 7);
      PLB_busLock : in std_logic;
      PLB_compress : in std_logic;
      PLB_guarded : in std_logic;
      PLB_lockErr : in std_logic;
      PLB_masterID : in std_logic_vector(0 to 1);
      PLB_MSize : in std_logic_vector(0 to 1);
      PLB_ordered : in std_logic;
      PLB_PAValid : in std_logic;
      PLB_rdBurst : in std_logic;
      PLB_rdPrim : in std_logic;
      PLB_RNW : in std_logic;
      PLB_SAValid : in std_logic;
      PLB_size : in std_logic_vector(0 to 3);
      PLB_type : in std_logic_vector(0 to 2);
      PLB_wrBurst : in std_logic;
      PLB_wrDBus : in std_logic_vector(0 to 63);
      PLB_wrPrim : in std_logic;
      PLB2OPB_rearb : out std_logic;
      BGO_ABus : out std_logic_vector(0 to 31);
      BGO_BE : out std_logic_vector(0 to 3);
      BGO_busLock : out std_logic;
      BGO_DBus : out std_logic_vector(0 to 31);
      BGO_request : out std_logic;
      BGO_RNW : out std_logic;
      BGO_select : out std_logic;
      BGO_seqAddr : out std_logic;
      OPB_DBus : in std_logic_vector(0 to 31);
      OPB_errAck : in std_logic;
      OPB_MnGrant : in std_logic;
      OPB_retry : in std_logic;
      OPB_timeout : in std_logic;
      OPB_xferAck : in std_logic
    );
  end component;

  component led_7segment_wrapper is
    port (
      OPB_ABus : in std_logic_vector(0 to 31);
      OPB_BE : in std_logic_vector(0 to 3);
      OPB_Clk : in std_logic;
      OPB_DBus : in std_logic_vector(0 to 31);
      OPB_RNW : in std_logic;
      OPB_Rst : in std_logic;
      OPB_select : in std_logic;
      OPB_seqAddr : in std_logic;
      Sln_DBus : out std_logic_vector(0 to 31);
      Sln_errAck : out std_logic;
      Sln_retry : out std_logic;
      Sln_toutSup : out std_logic;
      Sln_xferAck : out std_logic;
      IP2INTC_Irpt : out std_logic;
      GPIO_in : in std_logic_vector(0 to 6);
      GPIO_d_out : out std_logic_vector(0 to 6);
      GPIO_t_out : out std_logic_vector(0 to 6);
      GPIO2_in : in std_logic_vector(0 to 6);
      GPIO2_d_out : out std_logic_vector(0 to 6);
      GPIO2_t_out : out std_logic_vector(0 to 6);
      GPIO_IO_I : in std_logic_vector(0 to 6);
      GPIO_IO_O : out std_logic_vector(0 to 6);
      GPIO_IO_T : out std_logic_vector(0 to 6);
      GPIO2_IO_I : in std_logic_vector(0 to 6);
      GPIO2_IO_O : out std_logic_vector(0 to 6);
      GPIO2_IO_T : out std_logic_vector(0 to 6)
    );
  end component;

  component led_7segment_1_wrapper is
    port (
      OPB_ABus : in std_logic_vector(0 to 31);
      OPB_BE : in std_logic_vector(0 to 3);
      OPB_Clk : in std_logic;
      OPB_DBus : in std_logic_vector(0 to 31);
      OPB_RNW : in std_logic;
      OPB_Rst : in std_logic;
      OPB_select : in std_logic;
      OPB_seqAddr : in std_logic;
      Sln_DBus : out std_logic_vector(0 to 31);
      Sln_errAck : out std_logic;
      Sln_retry : out std_logic;
      Sln_toutSup : out std_logic;
      Sln_xferAck : out std_logic;
      IP2INTC_Irpt : out std_logic;
      GPIO_in : in std_logic_vector(0 to 6);
      GPIO_d_out : out std_logic_vector(0 to 6);
      GPIO_t_out : out std_logic_vector(0 to 6);
      GPIO2_in : in std_logic_vector(0 to 6);
      GPIO2_d_out : out std_logic_vector(0 to 6);
      GPIO2_t_out : out std_logic_vector(0 to 6);
      GPIO_IO_I : in std_logic_vector(0 to 6);
      GPIO_IO_O : out std_logic_vector(0 to 6);
      GPIO_IO_T : out std_logic_vector(0 to 6);
      GPIO2_IO_I : in std_logic_vector(0 to 6);
      GPIO2_IO_O : out std_logic_vector(0 to 6);
      GPIO2_IO_T : out std_logic_vector(0 to 6)
    );
  end component;

  component leds_4bit_wrapper is
    port (
      OPB_ABus : in std_logic_vector(0 to 31);
      OPB_BE : in std_logic_vector(0 to 3);
      OPB_Clk : in std_logic;
      OPB_DBus : in std_logic_vector(0 to 31);
      OPB_RNW : in std_logic;
      OPB_Rst : in std_logic;
      OPB_select : in std_logic;
      OPB_seqAddr : in std_logic;
      Sln_DBus : out std_logic_vector(0 to 31);
      Sln_errAck : out std_logic;
      Sln_retry : out std_logic;
      Sln_toutSup : out std_logic;
      Sln_xferAck : out std_logic;
      IP2INTC_Irpt : out std_logic;
      GPIO_in : in std_logic_vector(0 to 3);
      GPIO_d_out : out std_logic_vector(0 to 3);
      GPIO_t_out : out std_logic_vector(0 to 3);
      GPIO2_in : in std_logic_vector(0 to 3);
      GPIO2_d_out : out std_logic_vector(0 to 3);
      GPIO2_t_out : out std_logic_vector(0 to 3);
      GPIO_IO_I : in std_logic_vector(0 to 3);
      GPIO_IO_O : out std_logic_vector(0 to 3);
      GPIO_IO_T : out std_logic_vector(0 to 3);
      GPIO2_IO_I : in std_logic_vector(0 to 3);
      GPIO2_IO_O : out std_logic_vector(0 to 3);
      GPIO2_IO_T : out std_logic_vector(0 to 3)
    );
  end component;

  component push_buttons_4bit_wrapper is
    port (
      OPB_ABus : in std_logic_vector(0 to 31);
      OPB_BE : in std_logic_vector(0 to 3);
      OPB_Clk : in std_logic;
      OPB_DBus : in std_logic_vector(0 to 31);
      OPB_RNW : in std_logic;
      OPB_Rst : in std_logic;
      OPB_select : in std_logic;
      OPB_seqAddr : in std_logic;
      Sln_DBus : out std_logic_vector(0 to 31);
      Sln_errAck : out std_logic;
      Sln_retry : out std_logic;
      Sln_toutSup : out std_logic;
      Sln_xferAck : out std_logic;
      IP2INTC_Irpt : out std_logic;
      GPIO_in : in std_logic_vector(0 to 3);
      GPIO_d_out : out std_logic_vector(0 to 3);
      GPIO_t_out : out std_logic_vector(0 to 3);
      GPIO2_in : in std_logic_vector(0 to 3);
      GPIO2_d_out : out std_logic_vector(0 to 3);
      GPIO2_t_out : out std_logic_vector(0 to 3);
      GPIO_IO_I : in std_logic_vector(0 to 3);
      GPIO_IO_O : out std_logic_vector(0 to 3);
      GPIO_IO_T : out std_logic_vector(0 to 3);
      GPIO2_IO_I : in std_logic_vector(0 to 3);
      GPIO2_IO_O : out std_logic_vector(0 to 3);
      GPIO2_IO_T : out std_logic_vector(0 to 3)
    );
  end component;

  component dipsws_4bit_wrapper is
    port (
      OPB_ABus : in std_logic_vector(0 to 31);
      OPB_BE : in std_logic_vector(0 to 3);
      OPB_Clk : in std_logic;
      OPB_DBus : in std_logic_vector(0 to 31);
      OPB_RNW : in std_logic;
      OPB_Rst : in std_logic;
      OPB_select : in std_logic;
      OPB_seqAddr : in std_logic;
      Sln_DBus : out std_logic_vector(0 to 31);
      Sln_errAck : out std_logic;
      Sln_retry : out std_logic;
      Sln_toutSup : out std_logic;
      Sln_xferAck : out std_logic;
      IP2INTC_Irpt : out std_logic;
      GPIO_in : in std_logic_vector(0 to 3);
      GPIO_d_out : out std_logic_vector(0 to 3);
      GPIO_t_out : out std_logic_vector(0 to 3);
      GPIO2_in : in std_logic_vector(0 to 3);
      GPIO2_d_out : out std_logic_vector(0 to 3);
      GPIO2_t_out : out std_logic_vector(0 to 3);
      GPIO_IO_I : in std_logic_vector(0 to 3);
      GPIO_IO_O : out std_logic_vector(0 to 3);
      GPIO_IO_T : out std_logic_vector(0 to 3);
      GPIO2_IO_I : in std_logic_vector(0 to 3);
      GPIO2_IO_O : out std_logic_vector(0 to 3);
      GPIO2_IO_T : out std_logic_vector(0 to 3)
    );
  end component;

  component rs232_wrapper is
    port (
      OPB_Clk : in std_logic;
      OPB_Rst : in std_logic;
      Interrupt : out std_logic;
      OPB_ABus : in std_logic_vector(0 to 31);
      OPB_BE : in std_logic_vector(0 to 3);
      OPB_RNW : in std_logic;
      OPB_select : in std_logic;
      OPB_seqAddr : in std_logic;
      OPB_DBus : in std_logic_vector(0 to 31);
      UART_DBus : out std_logic_vector(0 to 31);
      UART_errAck : out std_logic;
      UART_retry : out std_logic;
      UART_toutSup : out std_logic;
      UART_xferAck : out std_logic;
      RX : in std_logic;
      TX : out std_logic
    );
  end component;

  component clk_board_config_wrapper is
    port (
      sys_clk : in std_logic;
      sys_rst : in std_logic;
      cfg_radio_dat_out : out std_logic;
      cfg_radio_csb_out : out std_logic;
      cfg_radio_en_out : out std_logic;
      cfg_radio_clk_out : out std_logic;
      cfg_logic_dat_out : out std_logic;
      cfg_logic_csb_out : out std_logic;
      cfg_logic_en_out : out std_logic;
      cfg_logic_clk_out : out std_logic;
      config_invalid : out std_logic
    );
  end component;

  component eeprom_controller_wrapper is
    port (
      DQ0_T : out std_logic;
      DQ0_O : out std_logic;
      DQ0_I : in std_logic;
      DQ1_T : out std_logic;
      DQ1_O : out std_logic;
      DQ1_I : in std_logic;
      DQ2_T : out std_logic;
      DQ2_O : out std_logic;
      DQ2_I : in std_logic;
      DQ3_T : out std_logic;
      DQ3_O : out std_logic;
      DQ3_I : in std_logic;
      DQ4_T : out std_logic;
      DQ4_O : out std_logic;
      DQ4_I : in std_logic;
      DQ5_T : out std_logic;
      DQ5_O : out std_logic;
      DQ5_I : in std_logic;
      DQ6_T : out std_logic;
      DQ6_O : out std_logic;
      DQ6_I : in std_logic;
      DQ7_T : out std_logic;
      DQ7_O : out std_logic;
      DQ7_I : in std_logic;
      OPB_Clk : in std_logic;
      OPB_Rst : in std_logic;
      Sl_DBus : out std_logic_vector(0 to 31);
      Sl_errAck : out std_logic;
      Sl_retry : out std_logic;
      Sl_toutSup : out std_logic;
      Sl_xferAck : out std_logic;
      OPB_ABus : in std_logic_vector(0 to 31);
      OPB_BE : in std_logic_vector(0 to 3);
      OPB_DBus : in std_logic_vector(0 to 31);
      OPB_RNW : in std_logic;
      OPB_select : in std_logic;
      OPB_seqAddr : in std_logic
    );
  end component;

  component ethernet_mac_wrapper is
    port (
      PHY_tx_clk : in std_logic;
      PHY_rx_clk : in std_logic;
      PHY_crs : in std_logic;
      PHY_dv : in std_logic;
      PHY_rx_data : in std_logic_vector(3 downto 0);
      PHY_col : in std_logic;
      PHY_rx_er : in std_logic;
      PHY_tx_en : out std_logic;
      PHY_rx_en : out std_logic;
      PHY_tx_er : out std_logic;
      PHY_tx_data : out std_logic_vector(3 downto 0);
      PHY_rst_n : out std_logic;
      PLB_Clk : in std_logic;
      PLB_Rst : in std_logic;
      Freeze : in std_logic;
      IP2INTC_Irpt : out std_logic;
      PLB_ABus : in std_logic_vector(0 to 31);
      PLB_PAValid : in std_logic;
      PLB_SAValid : in std_logic;
      PLB_rdPrim : in std_logic;
      PLB_wrPrim : in std_logic;
      PLB_masterID : in std_logic_vector(0 to 1);
      PLB_abort : in std_logic;
      PLB_busLock : in std_logic;
      PLB_RNW : in std_logic;
      PLB_BE : in std_logic_vector(0 to 7);
      PLB_MSize : in std_logic_vector(0 to 1);
      PLB_size : in std_logic_vector(0 to 3);
      PLB_type : in std_logic_vector(0 to 2);
      PLB_compress : in std_logic;
      PLB_guarded : in std_logic;
      PLB_ordered : in std_logic;
      PLB_lockErr : in std_logic;
      PLB_wrDBus : in std_logic_vector(0 to 63);
      PLB_wrBurst : in std_logic;
      PLB_rdBurst : in std_logic;
      PLB_pendReq : in std_logic;
      PLB_pendPri : in std_logic_vector(0 to 1);
      PLB_reqPri : in std_logic_vector(0 to 1);
      Sl_addrAck : out std_logic;
      Sl_SSize : out std_logic_vector(0 to 1);
      Sl_wait : out std_logic;
      Sl_rearbitrate : out std_logic;
      Sl_wrDAck : out std_logic;
      Sl_wrComp : out std_logic;
      Sl_wrBTerm : out std_logic;
      Sl_rdDBus : out std_logic_vector(0 to 63);
      Sl_rdWdAddr : out std_logic_vector(0 to 3);
      Sl_rdDAck : out std_logic;
      Sl_rdComp : out std_logic;
      Sl_rdBTerm : out std_logic;
      Sl_MBusy : out std_logic_vector(0 to 2);
      Sl_MErr : out std_logic_vector(0 to 2);
      PLB_MAddrAck : in std_logic;
      PLB_MSSize : in std_logic_vector(0 to 1);
      PLB_MRearbitrate : in std_logic;
      PLB_MBusy : in std_logic;
      PLB_MErr : in std_logic;
      PLB_MWrDAck : in std_logic;
      PLB_MRdDBus : in std_logic_vector(0 to 63);
      PLB_MRdWdAddr : in std_logic_vector(0 to 3);
      PLB_MRdDAck : in std_logic;
      PLB_MRdBTerm : in std_logic;
      PLB_MWrBTerm : in std_logic;
      M_request : out std_logic;
      M_priority : out std_logic_vector(0 to 1);
      M_buslock : out std_logic;
      M_RNW : out std_logic;
      M_BE : out std_logic_vector(0 to 7);
      M_MSize : out std_logic_vector(0 to 1);
      M_size : out std_logic_vector(0 to 3);
      M_type : out std_logic_vector(0 to 2);
      M_compress : out std_logic;
      M_guarded : out std_logic;
      M_ordered : out std_logic;
      M_lockErr : out std_logic;
      M_abort : out std_logic;
      M_ABus : out std_logic_vector(0 to 31);
      M_wrDBus : out std_logic_vector(0 to 63);
      M_wrBurst : out std_logic;
      M_rdBurst : out std_logic;
      PHY_Mii_clk_I : in std_logic;
      PHY_Mii_clk_O : out std_logic;
      PHY_Mii_clk_T : out std_logic;
      PHY_Mii_data_I : in std_logic;
      PHY_Mii_data_O : out std_logic;
      PHY_Mii_data_T : out std_logic
    );
  end component;

  component radio_controller_0_wrapper is
    port (
      OPB_Clk : in std_logic;
      OPB_Rst : in std_logic;
      Sl_DBus : out std_logic_vector(0 to 31);
      Sl_errAck : out std_logic;
      Sl_retry : out std_logic;
      Sl_toutSup : out std_logic;
      Sl_xferAck : out std_logic;
      OPB_ABus : in std_logic_vector(0 to 31);
      OPB_BE : in std_logic_vector(0 to 3);
      OPB_DBus : in std_logic_vector(0 to 31);
      OPB_RNW : in std_logic;
      OPB_select : in std_logic;
      OPB_seqAddr : in std_logic;
      spi_clk : out std_logic;
      data_out : out std_logic;
      radio1_cs : out std_logic;
      radio2_cs : out std_logic;
      radio3_cs : out std_logic;
      radio4_cs : out std_logic;
      dac1_cs : out std_logic;
      dac2_cs : out std_logic;
      dac3_cs : out std_logic;
      dac4_cs : out std_logic;
      radio1_SHDN : out std_logic;
      radio1_TxEn : out std_logic;
      radio1_RxEn : out std_logic;
      radio1_RxHP : out std_logic;
      radio1_LD : in std_logic;
      radio1_24PA : out std_logic;
      radio1_5PA : out std_logic;
      radio1_ANTSW : out std_logic_vector(0 to 1);
      radio1_LED : out std_logic_vector(0 to 2);
      radio1_ADC_RX_DCS : out std_logic;
      radio1_ADC_RX_DFS : out std_logic;
      radio1_ADC_RX_OTRA : in std_logic;
      radio1_ADC_RX_OTRB : in std_logic;
      radio1_ADC_RX_PWDNA : out std_logic;
      radio1_ADC_RX_PWDNB : out std_logic;
      radio1_DIPSW : in std_logic_vector(0 to 3);
      radio1_RSSI_ADC_CLAMP : out std_logic;
      radio1_RSSI_ADC_HIZ : out std_logic;
      radio1_RSSI_ADC_OTR : in std_logic;
      radio1_RSSI_ADC_SLEEP : out std_logic;
      radio1_RSSI_ADC_D : in std_logic_vector(0 to 9);
      radio1_TX_DAC_PLL_LOCK : in std_logic;
      radio1_TX_DAC_RESET : out std_logic;
      radio1_SHDN_external : in std_logic;
      radio1_TxEn_external : in std_logic;
      radio1_RxEn_external : in std_logic;
      radio1_RxHP_external : in std_logic;
      radio1_TxGain : out std_logic_vector(0 to 5);
      radio1_TxStart : out std_logic;
      radio2_SHDN : out std_logic;
      radio2_TxEn : out std_logic;
      radio2_RxEn : out std_logic;
      radio2_RxHP : out std_logic;
      radio2_LD : in std_logic;
      radio2_24PA : out std_logic;
      radio2_5PA : out std_logic;
      radio2_ANTSW : out std_logic_vector(0 to 1);
      radio2_LED : out std_logic_vector(0 to 2);
      radio2_ADC_RX_DCS : out std_logic;
      radio2_ADC_RX_DFS : out std_logic;
      radio2_ADC_RX_OTRA : in std_logic;
      radio2_ADC_RX_OTRB : in std_logic;
      radio2_ADC_RX_PWDNA : out std_logic;
      radio2_ADC_RX_PWDNB : out std_logic;
      radio2_DIPSW : in std_logic_vector(0 to 3);
      radio2_RSSI_ADC_CLAMP : out std_logic;
      radio2_RSSI_ADC_HIZ : out std_logic;
      radio2_RSSI_ADC_OTR : in std_logic;
      radio2_RSSI_ADC_SLEEP : out std_logic;
      radio2_RSSI_ADC_D : in std_logic_vector(0 to 9);
      radio2_TX_DAC_PLL_LOCK : in std_logic;
      radio2_TX_DAC_RESET : out std_logic;
      radio2_SHDN_external : in std_logic;
      radio2_TxEn_external : in std_logic;
      radio2_RxEn_external : in std_logic;
      radio2_RxHP_external : in std_logic;
      radio2_TxGain : out std_logic_vector(0 to 5);
      radio2_TxStart : out std_logic;
      radio3_SHDN : out std_logic;
      radio3_TxEn : out std_logic;
      radio3_RxEn : out std_logic;
      radio3_RxHP : out std_logic;
      radio3_LD : in std_logic;
      radio3_24PA : out std_logic;
      radio3_5PA : out std_logic;
      radio3_ANTSW : out std_logic_vector(0 to 1);
      radio3_LED : out std_logic_vector(0 to 2);
      radio3_ADC_RX_DCS : out std_logic;
      radio3_ADC_RX_DFS : out std_logic;
      radio3_ADC_RX_OTRA : in std_logic;
      radio3_ADC_RX_OTRB : in std_logic;
      radio3_ADC_RX_PWDNA : out std_logic;
      radio3_ADC_RX_PWDNB : out std_logic;
      radio3_DIPSW : in std_logic_vector(0 to 3);
      radio3_RSSI_ADC_CLAMP : out std_logic;
      radio3_RSSI_ADC_HIZ : out std_logic;
      radio3_RSSI_ADC_OTR : in std_logic;
      radio3_RSSI_ADC_SLEEP : out std_logic;
      radio3_RSSI_ADC_D : in std_logic_vector(0 to 9);
      radio3_TX_DAC_PLL_LOCK : in std_logic;
      radio3_TX_DAC_RESET : out std_logic;
      radio3_SHDN_external : in std_logic;
      radio3_TxEn_external : in std_logic;
      radio3_RxEn_external : in std_logic;
      radio3_RxHP_external : in std_logic;
      radio3_TxGain : out std_logic_vector(0 to 5);
      radio3_TxStart : out std_logic;
      radio4_SHDN : out std_logic;
      radio4_TxEn : out std_logic;
      radio4_RxEn : out std_logic;
      radio4_RxHP : out std_logic;
      radio4_LD : in std_logic;
      radio4_24PA : out std_logic;
      radio4_5PA : out std_logic;
      radio4_ANTSW : out std_logic_vector(0 to 1);
      radio4_LED : out std_logic_vector(0 to 2);
      radio4_ADC_RX_DCS : out std_logic;
      radio4_ADC_RX_DFS : out std_logic;
      radio4_ADC_RX_OTRA : in std_logic;
      radio4_ADC_RX_OTRB : in std_logic;
      radio4_ADC_RX_PWDNA : out std_logic;
      radio4_ADC_RX_PWDNB : out std_logic;
      radio4_DIPSW : in std_logic_vector(0 to 3);
      radio4_RSSI_ADC_CLAMP : out std_logic;
      radio4_RSSI_ADC_HIZ : out std_logic;
      radio4_RSSI_ADC_OTR : in std_logic;
      radio4_RSSI_ADC_SLEEP : out std_logic;
      radio4_RSSI_ADC_D : in std_logic_vector(0 to 9);
      radio4_TX_DAC_PLL_LOCK : in std_logic;
      radio4_TX_DAC_RESET : out std_logic;
      radio4_SHDN_external : in std_logic;
      radio4_TxEn_external : in std_logic;
      radio4_RxEn_external : in std_logic;
      radio4_RxHP_external : in std_logic;
      radio4_TxGain : out std_logic_vector(0 to 5);
      radio4_TxStart : out std_logic
    );
  end component;

  component radio_bridge_slot_2_wrapper is
    port (
      user_ADC_I : out std_logic_vector(0 to 13);
      user_ADC_Q : out std_logic_vector(0 to 13);
      user_DAC_I : in std_logic_vector(0 to 15);
      user_DAC_Q : in std_logic_vector(0 to 15);
      user_RxRF_gain : in std_logic_vector(0 to 1);
      user_RxBB_gain : in std_logic_vector(0 to 4);
      user_Tx_gain : in std_logic_vector(0 to 5);
      user_TxModelStart : out std_logic;
      user_RSSI_ADC_clk : in std_logic;
      user_RSSI_ADC_D : out std_logic_vector(0 to 9);
      user_EEPROM_IO_T : in std_logic;
      user_EEPROM_IO_O : in std_logic;
      user_EEPROM_IO_I : out std_logic;
      user_SHDN_external : in std_logic;
      user_RxEn_external : in std_logic;
      user_TxEn_external : in std_logic;
      user_RxHP_external : in std_logic;
      converter_clock_in : in std_logic;
      converter_clock_out : out std_logic;
      radio_RSSI_ADC_clk : out std_logic;
      radio_DAC_I : out std_logic_vector(15 downto 0);
      radio_DAC_Q : out std_logic_vector(15 downto 0);
      radio_ADC_I : in std_logic_vector(13 downto 0);
      radio_ADC_Q : in std_logic_vector(13 downto 0);
      radio_B : out std_logic_vector(6 downto 0);
      radio_ANTSW : out std_logic_vector(1 downto 0);
      radio_LED : out std_logic_vector(2 downto 0);
      radio_DIPSW : in std_logic_vector(3 downto 0);
      radio_RSSI_ADC_D : in std_logic_vector(9 downto 0);
      radio_EEPROM_IO : inout std_logic;
      radio_spi_clk : out std_logic;
      radio_spi_data : out std_logic;
      radio_spi_cs : out std_logic;
      radio_SHDN : out std_logic;
      radio_TxEn : out std_logic;
      radio_RxEn : out std_logic;
      radio_RxHP : out std_logic;
      radio_24PA : out std_logic;
      radio_5PA : out std_logic;
      radio_RX_ADC_DCS : out std_logic;
      radio_RX_ADC_DFS : out std_logic;
      radio_RX_ADC_PWDNA : out std_logic;
      radio_RX_ADC_PWDNB : out std_logic;
      radio_RSSI_ADC_CLAMP : out std_logic;
      radio_RSSI_ADC_HIZ : out std_logic;
      radio_RSSI_ADC_SLEEP : out std_logic;
      radio_LD : in std_logic;
      radio_RX_ADC_OTRA : in std_logic;
      radio_RX_ADC_OTRB : in std_logic;
      radio_RSSI_ADC_OTR : in std_logic;
      radio_DAC_PLL_LOCK : in std_logic;
      radio_DAC_RESET : out std_logic;
      controller_spi_clk : in std_logic;
      controller_spi_data : in std_logic;
      controller_radio_cs : in std_logic;
      controller_dac_cs : in std_logic;
      controller_SHDN : in std_logic;
      controller_TxEn : in std_logic;
      controller_RxEn : in std_logic;
      controller_RxHP : in std_logic;
      controller_24PA : in std_logic;
      controller_5PA : in std_logic;
      controller_ANTSW : in std_logic_vector(0 to 1);
      controller_LED : in std_logic_vector(0 to 2);
      controller_RX_ADC_DCS : in std_logic;
      controller_RX_ADC_DFS : in std_logic;
      controller_RX_ADC_PWDNA : in std_logic;
      controller_RX_ADC_PWDNB : in std_logic;
      controller_RSSI_ADC_CLAMP : in std_logic;
      controller_RSSI_ADC_HIZ : in std_logic;
      controller_RSSI_ADC_SLEEP : in std_logic;
      controller_DIPSW : out std_logic_vector(0 to 3);
      controller_RSSI_ADC_D : out std_logic_vector(0 to 9);
      controller_LD : out std_logic;
      controller_RX_ADC_OTRA : out std_logic;
      controller_RX_ADC_OTRB : out std_logic;
      controller_RSSI_ADC_OTR : out std_logic;
      controller_DAC_PLL_LOCK : out std_logic;
      controller_DAC_RESET : in std_logic;
      controller_TxStart : in std_logic;
      dac_spi_data : out std_logic;
      dac_spi_cs : out std_logic;
      dac_spi_clk : out std_logic;
      controller_SHDN_external : out std_logic;
      controller_RxEn_external : out std_logic;
      controller_TxEn_external : out std_logic;
      controller_RxHP_external : out std_logic
    );
  end component;

  component radio_bridge_slot_3_wrapper is
    port (
      user_ADC_I : out std_logic_vector(0 to 13);
      user_ADC_Q : out std_logic_vector(0 to 13);
      user_DAC_I : in std_logic_vector(0 to 15);
      user_DAC_Q : in std_logic_vector(0 to 15);
      user_RxRF_gain : in std_logic_vector(0 to 1);
      user_RxBB_gain : in std_logic_vector(0 to 4);
      user_Tx_gain : in std_logic_vector(0 to 5);
      user_TxModelStart : out std_logic;
      user_RSSI_ADC_clk : in std_logic;
      user_RSSI_ADC_D : out std_logic_vector(0 to 9);
      user_EEPROM_IO_T : in std_logic;
      user_EEPROM_IO_O : in std_logic;
      user_EEPROM_IO_I : out std_logic;
      user_SHDN_external : in std_logic;
      user_RxEn_external : in std_logic;
      user_TxEn_external : in std_logic;
      user_RxHP_external : in std_logic;
      converter_clock_in : in std_logic;
      converter_clock_out : out std_logic;
      radio_RSSI_ADC_clk : out std_logic;
      radio_DAC_I : out std_logic_vector(15 downto 0);
      radio_DAC_Q : out std_logic_vector(15 downto 0);
      radio_ADC_I : in std_logic_vector(13 downto 0);
      radio_ADC_Q : in std_logic_vector(13 downto 0);
      radio_B : out std_logic_vector(6 downto 0);
      radio_ANTSW : out std_logic_vector(1 downto 0);
      radio_LED : out std_logic_vector(2 downto 0);
      radio_DIPSW : in std_logic_vector(3 downto 0);
      radio_RSSI_ADC_D : in std_logic_vector(9 downto 0);
      radio_EEPROM_IO : inout std_logic;
      radio_spi_clk : out std_logic;
      radio_spi_data : out std_logic;
      radio_spi_cs : out std_logic;
      radio_SHDN : out std_logic;
      radio_TxEn : out std_logic;
      radio_RxEn : out std_logic;
      radio_RxHP : out std_logic;
      radio_24PA : out std_logic;
      radio_5PA : out std_logic;
      radio_RX_ADC_DCS : out std_logic;
      radio_RX_ADC_DFS : out std_logic;
      radio_RX_ADC_PWDNA : out std_logic;
      radio_RX_ADC_PWDNB : out std_logic;
      radio_RSSI_ADC_CLAMP : out std_logic;
      radio_RSSI_ADC_HIZ : out std_logic;
      radio_RSSI_ADC_SLEEP : out std_logic;
      radio_LD : in std_logic;
      radio_RX_ADC_OTRA : in std_logic;
      radio_RX_ADC_OTRB : in std_logic;
      radio_RSSI_ADC_OTR : in std_logic;
      radio_DAC_PLL_LOCK : in std_logic;
      radio_DAC_RESET : out std_logic;
      controller_spi_clk : in std_logic;
      controller_spi_data : in std_logic;
      controller_radio_cs : in std_logic;
      controller_dac_cs : in std_logic;
      controller_SHDN : in std_logic;
      controller_TxEn : in std_logic;
      controller_RxEn : in std_logic;
      controller_RxHP : in std_logic;
      controller_24PA : in std_logic;
      controller_5PA : in std_logic;
      controller_ANTSW : in std_logic_vector(0 to 1);
      controller_LED : in std_logic_vector(0 to 2);
      controller_RX_ADC_DCS : in std_logic;
      controller_RX_ADC_DFS : in std_logic;
      controller_RX_ADC_PWDNA : in std_logic;
      controller_RX_ADC_PWDNB : in std_logic;
      controller_RSSI_ADC_CLAMP : in std_logic;
      controller_RSSI_ADC_HIZ : in std_logic;
      controller_RSSI_ADC_SLEEP : in std_logic;
      controller_DIPSW : out std_logic_vector(0 to 3);
      controller_RSSI_ADC_D : out std_logic_vector(0 to 9);
      controller_LD : out std_logic;
      controller_RX_ADC_OTRA : out std_logic;
      controller_RX_ADC_OTRB : out std_logic;
      controller_RSSI_ADC_OTR : out std_logic;
      controller_DAC_PLL_LOCK : out std_logic;
      controller_DAC_RESET : in std_logic;
      controller_TxStart : in std_logic;
      dac_spi_data : out std_logic;
      dac_spi_cs : out std_logic;
      dac_spi_clk : out std_logic;
      controller_SHDN_external : out std_logic;
      controller_RxEn_external : out std_logic;
      controller_TxEn_external : out std_logic;
      controller_RxHP_external : out std_logic
    );
  end component;

  component analog_bridge_slot_4_wrapper is
    port (
      user_DAC1_A : in std_logic_vector(0 to 13);
      user_DAC1_B : in std_logic_vector(0 to 13);
      user_DAC2_A : in std_logic_vector(0 to 13);
      user_DAC2_B : in std_logic_vector(0 to 13);
      user_DAC1_sleep : in std_logic;
      user_DAC2_sleep : in std_logic;
      user_ADC_A : out std_logic_vector(0 to 13);
      user_ADC_B : out std_logic_vector(0 to 13);
      user_ADC_DFS : in std_logic;
      user_ADC_DCS : in std_logic;
      user_ADC_pdwnA : in std_logic;
      user_ADC_pdwnB : in std_logic;
      user_ADC_otrA : out std_logic;
      user_ADC_otrB : out std_logic;
      user_LED : in std_logic_vector(0 to 2);
      clock_in : in std_logic;
      clock_out : out std_logic;
      analog_DAC1_A : out std_logic_vector(13 downto 0);
      analog_DAC1_B : out std_logic_vector(13 downto 0);
      analog_DAC2_A : out std_logic_vector(13 downto 0);
      analog_DAC2_B : out std_logic_vector(13 downto 0);
      analog_DAC1_sleep : out std_logic;
      analog_DAC2_sleep : out std_logic;
      analog_ADC_A : in std_logic_vector(13 downto 0);
      analog_ADC_B : in std_logic_vector(13 downto 0);
      analog_ADC_DFS : out std_logic;
      analog_ADC_DCS : out std_logic;
      analog_ADC_pdwnA : out std_logic;
      analog_ADC_pdwnB : out std_logic;
      analog_ADC_otrA : in std_logic;
      analog_ADC_otrB : in std_logic;
      analog_LED : out std_logic_vector(0 to 2)
    );
  end component;

  component sram0_zbt_512kx32_wrapper is
    port (
      PLB_Clk : in std_logic;
      PLB_Rst : in std_logic;
      PLB_abort : in std_logic;
      PLB_ABus : in std_logic_vector(0 to 31);
      PLB_BE : in std_logic_vector(0 to 7);
      PLB_busLock : in std_logic;
      PLB_compress : in std_logic;
      PLB_guarded : in std_logic;
      PLB_lockErr : in std_logic;
      PLB_masterID : in std_logic_vector(0 to 1);
      PLB_MSize : in std_logic_vector(0 to 1);
      PLB_ordered : in std_logic;
      PLB_PAValid : in std_logic;
      PLB_RNW : in std_logic;
      PLB_size : in std_logic_vector(0 to 3);
      PLB_type : in std_logic_vector(0 to 2);
      Sl_addrAck : out std_logic;
      Sl_MBusy : out std_logic_vector(0 to 2);
      Sl_MErr : out std_logic_vector(0 to 2);
      Sl_rearbitrate : out std_logic;
      Sl_SSize : out std_logic_vector(0 to 1);
      Sl_wait : out std_logic;
      PLB_rdPrim : in std_logic;
      PLB_SAValid : in std_logic;
      PLB_wrPrim : in std_logic;
      PLB_wrBurst : in std_logic;
      PLB_wrDBus : in std_logic_vector(0 to 63);
      Sl_wrBTerm : out std_logic;
      Sl_wrComp : out std_logic;
      Sl_wrDAck : out std_logic;
      PLB_rdBurst : in std_logic;
      Sl_rdBTerm : out std_logic;
      Sl_rdComp : out std_logic;
      Sl_rdDAck : out std_logic;
      Sl_rdDBus : out std_logic_vector(0 to 63);
      Sl_rdWdAddr : out std_logic_vector(0 to 3);
      PLB_pendReq : in std_logic;
      PLB_pendPri : in std_logic_vector(0 to 1);
      PLB_reqPri : in std_logic_vector(0 to 1);
      Mem_A : out std_logic_vector(0 to 31);
      Mem_CEN : out std_logic_vector(0 to 0);
      Mem_OEN : out std_logic_vector(0 to 0);
      Mem_WEN : out std_logic;
      Mem_QWEN : out std_logic_vector(0 to 3);
      Mem_BEN : out std_logic_vector(0 to 3);
      Mem_RPN : out std_logic;
      Mem_CE : out std_logic_vector(0 to 0);
      Mem_ADV_LDN : out std_logic;
      Mem_LBON : out std_logic;
      Mem_CKEN : out std_logic;
      Mem_RNW : out std_logic;
      Mem_DQ_I : in std_logic_vector(0 to 31);
      Mem_DQ_O : out std_logic_vector(0 to 31);
      Mem_DQ_T : out std_logic_vector(0 to 31)
    );
  end component;

  component sram1_zbt_512kx32_wrapper is
    port (
      PLB_Clk : in std_logic;
      PLB_Rst : in std_logic;
      PLB_abort : in std_logic;
      PLB_ABus : in std_logic_vector(0 to 31);
      PLB_BE : in std_logic_vector(0 to 7);
      PLB_busLock : in std_logic;
      PLB_compress : in std_logic;
      PLB_guarded : in std_logic;
      PLB_lockErr : in std_logic;
      PLB_masterID : in std_logic_vector(0 to 1);
      PLB_MSize : in std_logic_vector(0 to 1);
      PLB_ordered : in std_logic;
      PLB_PAValid : in std_logic;
      PLB_RNW : in std_logic;
      PLB_size : in std_logic_vector(0 to 3);
      PLB_type : in std_logic_vector(0 to 2);
      Sl_addrAck : out std_logic;
      Sl_MBusy : out std_logic_vector(0 to 2);
      Sl_MErr : out std_logic_vector(0 to 2);
      Sl_rearbitrate : out std_logic;
      Sl_SSize : out std_logic_vector(0 to 1);
      Sl_wait : out std_logic;
      PLB_rdPrim : in std_logic;
      PLB_SAValid : in std_logic;
      PLB_wrPrim : in std_logic;
      PLB_wrBurst : in std_logic;
      PLB_wrDBus : in std_logic_vector(0 to 63);
      Sl_wrBTerm : out std_logic;
      Sl_wrComp : out std_logic;
      Sl_wrDAck : out std_logic;
      PLB_rdBurst : in std_logic;
      Sl_rdBTerm : out std_logic;
      Sl_rdComp : out std_logic;
      Sl_rdDAck : out std_logic;
      Sl_rdDBus : out std_logic_vector(0 to 63);
      Sl_rdWdAddr : out std_logic_vector(0 to 3);
      PLB_pendReq : in std_logic;
      PLB_pendPri : in std_logic_vector(0 to 1);
      PLB_reqPri : in std_logic_vector(0 to 1);
      Mem_A : out std_logic_vector(0 to 31);
      Mem_CEN : out std_logic_vector(0 to 0);
      Mem_OEN : out std_logic_vector(0 to 0);
      Mem_WEN : out std_logic;
      Mem_QWEN : out std_logic_vector(0 to 3);
      Mem_BEN : out std_logic_vector(0 to 3);
      Mem_RPN : out std_logic;
      Mem_CE : out std_logic_vector(0 to 0);
      Mem_ADV_LDN : out std_logic;
      Mem_LBON : out std_logic;
      Mem_CKEN : out std_logic;
      Mem_RNW : out std_logic;
      Mem_DQ_I : in std_logic_vector(0 to 31);
      Mem_DQ_O : out std_logic_vector(0 to 31);
      Mem_DQ_T : out std_logic_vector(0 to 31)
    );
  end component;

  component plb_bram_if_cntlr_1_wrapper is
    port (
      plb_clk : in std_logic;
      plb_rst : in std_logic;
      plb_abort : in std_logic;
      plb_abus : in std_logic_vector(0 to 31);
      plb_be : in std_logic_vector(0 to 7);
      plb_buslock : in std_logic;
      plb_compress : in std_logic;
      plb_guarded : in std_logic;
      plb_lockerr : in std_logic;
      plb_masterid : in std_logic_vector(0 to 1);
      plb_msize : in std_logic_vector(0 to 1);
      plb_ordered : in std_logic;
      plb_pavalid : in std_logic;
      plb_rnw : in std_logic;
      plb_size : in std_logic_vector(0 to 3);
      plb_type : in std_logic_vector(0 to 2);
      sl_addrack : out std_logic;
      sl_mbusy : out std_logic_vector(0 to 2);
      sl_merr : out std_logic_vector(0 to 2);
      sl_rearbitrate : out std_logic;
      sl_ssize : out std_logic_vector(0 to 1);
      sl_wait : out std_logic;
      plb_rdprim : in std_logic;
      plb_savalid : in std_logic;
      plb_wrprim : in std_logic;
      plb_wrburst : in std_logic;
      plb_wrdbus : in std_logic_vector(0 to 63);
      sl_wrbterm : out std_logic;
      sl_wrcomp : out std_logic;
      sl_wrdack : out std_logic;
      plb_rdburst : in std_logic;
      sl_rdbterm : out std_logic;
      sl_rdcomp : out std_logic;
      sl_rddack : out std_logic;
      sl_rddbus : out std_logic_vector(0 to 63);
      sl_rdwdaddr : out std_logic_vector(0 to 3);
      plb_pendreq : in std_logic;
      plb_pendpri : in std_logic_vector(0 to 1);
      plb_reqpri : in std_logic_vector(0 to 1);
      bram_rst : out std_logic;
      bram_clk : out std_logic;
      bram_en : out std_logic;
      bram_wen : out std_logic_vector(0 to 7);
      bram_addr : out std_logic_vector(0 to 31);
      bram_din : in std_logic_vector(0 to 63);
      bram_dout : out std_logic_vector(0 to 63)
    );
  end component;

  component plb_bram_if_cntlr_1_bram_wrapper is
    port (
      BRAM_Rst_A : in std_logic;
      BRAM_Clk_A : in std_logic;
      BRAM_EN_A : in std_logic;
      BRAM_WEN_A : in std_logic_vector(0 to 7);
      BRAM_Addr_A : in std_logic_vector(0 to 31);
      BRAM_Din_A : out std_logic_vector(0 to 63);
      BRAM_Dout_A : in std_logic_vector(0 to 63);
      BRAM_Rst_B : in std_logic;
      BRAM_Clk_B : in std_logic;
      BRAM_EN_B : in std_logic;
      BRAM_WEN_B : in std_logic_vector(0 to 7);
      BRAM_Addr_B : in std_logic_vector(0 to 31);
      BRAM_Din_B : out std_logic_vector(0 to 63);
      BRAM_Dout_B : in std_logic_vector(0 to 63)
    );
  end component;

  component opb_intc_0_wrapper is
    port (
      OPB_Clk : in std_logic;
      Intr : in std_logic_vector(6 downto 0);
      OPB_Rst : in std_logic;
      OPB_ABus : in std_logic_vector(0 to 31);
      OPB_BE : in std_logic_vector(0 to 3);
      OPB_RNW : in std_logic;
      OPB_select : in std_logic;
      OPB_seqAddr : in std_logic;
      OPB_DBus : in std_logic_vector(0 to 31);
      IntC_DBus : out std_logic_vector(0 to 31);
      IntC_errAck : out std_logic;
      IntC_retry : out std_logic;
      IntC_toutSup : out std_logic;
      IntC_xferAck : out std_logic;
      Irq : out std_logic
    );
  end component;

  component sram0_zbt_512kx32_util_bus_split_0_wrapper is
    port (
      Sig : in std_logic_vector(0 to 31);
      Out1 : out std_logic_vector(11 to 29);
      Out2 : out std_logic_vector(30 to 31)
    );
  end component;

  component sram1_zbt_512kx32_util_bus_split_1_wrapper is
    port (
      Sig : in std_logic_vector(0 to 31);
      Out1 : out std_logic_vector(11 to 29);
      Out2 : out std_logic_vector(30 to 31)
    );
  end component;

  component dcm_0_wrapper is
    port (
      RST : in std_logic;
      CLKIN : in std_logic;
      CLKFB : in std_logic;
      PSEN : in std_logic;
      PSINCDEC : in std_logic;
      PSCLK : in std_logic;
      DSSEN : in std_logic;
      CLK0 : out std_logic;
      CLK90 : out std_logic;
      CLK180 : out std_logic;
      CLK270 : out std_logic;
      CLKDV : out std_logic;
      CLK2X : out std_logic;
      CLK2X180 : out std_logic;
      CLKFX : out std_logic;
      CLKFX180 : out std_logic;
      STATUS : out std_logic_vector(7 downto 0);
      LOCKED : out std_logic;
      PSDONE : out std_logic
    );
  end component;

  component ofdm_timer_opbw_0_wrapper is
    port (
      ce : in std_logic;
      idlefordifs : in std_logic;
      opb_abus : in std_logic_vector(0 to 31);
      opb_be : in std_logic_vector(0 to 3);
      opb_clk : in std_logic;
      opb_dbus : in std_logic_vector(0 to 31);
      opb_rnw : in std_logic;
      opb_rst : in std_logic;
      opb_select : in std_logic;
      opb_seqaddr : in std_logic;
      sgp_dbus : out std_logic_vector(0 to 31);
      sgp_errack : out std_logic;
      sgp_retry : out std_logic;
      sgp_toutsup : out std_logic;
      sgp_xferack : out std_logic;
      timerexpire : out std_logic
    );
  end component;

  component ofdm_pktdetector_mimo_opbw_0_wrapper is
    port (
      ce : in std_logic;
      opb_abus : in std_logic_vector(0 to 31);
      opb_be : in std_logic_vector(0 to 3);
      opb_clk : in std_logic;
      opb_dbus : in std_logic_vector(0 to 31);
      opb_rnw : in std_logic;
      opb_rst : in std_logic;
      opb_select : in std_logic;
      opb_seqaddr : in std_logic;
      reset : in std_logic;
      rssi1 : in std_logic_vector(0 to 9);
      rssi2 : in std_logic_vector(0 to 9);
      rssi3 : in std_logic_vector(0 to 9);
      rssi4 : in std_logic_vector(0 to 9);
      avgrssi1 : out std_logic_vector(0 to 15);
      avgrssi2 : out std_logic_vector(0 to 15);
      avgrssi3 : out std_logic_vector(0 to 15);
      avgrssi4 : out std_logic_vector(0 to 15);
      debugbusy : out std_logic;
      debugidledifs : out std_logic;
      idlefordifs : out std_logic;
      mediumbusy : out std_logic;
      pktdet : out std_logic;
      rssi_clk_out : out std_logic;
      sgp_dbus : out std_logic_vector(0 to 31);
      sgp_errack : out std_logic;
      sgp_retry : out std_logic;
      sgp_toutsup : out std_logic;
      sgp_xferack : out std_logic
    );
  end component;

  component ofdm_txrx_mimo_opbw_0_wrapper is
    port (
      bram_addr : out std_logic_vector(0 to 31);
      bram_datain : in std_logic_vector(0 to 63);
      bram_dout : out std_logic_vector(0 to 63);
      bram_reset : out std_logic;
      bram_wen : out std_logic_vector(0 to 7);
      ce : in std_logic;
      debug_chipscopetrig1 : in std_logic;
      opb_abus : in std_logic_vector(0 to 31);
      opb_be : in std_logic_vector(0 to 3);
      opb_clk : in std_logic;
      opb_dbus : in std_logic_vector(0 to 31);
      opb_rnw : in std_logic;
      opb_rst : in std_logic;
      opb_select : in std_logic;
      opb_seqaddr : in std_logic;
      rx_anta_adci_dv4 : in std_logic_vector(0 to 13);
      rx_anta_adcq_dv4 : in std_logic_vector(0 to 13);
      rx_anta_agc_done : in std_logic;
      rx_anta_gainbb : in std_logic_vector(0 to 4);
      rx_anta_gainrf : in std_logic_vector(0 to 1);
      rx_antb_adci_dv4 : in std_logic_vector(0 to 13);
      rx_antb_adcq_dv4 : in std_logic_vector(0 to 13);
      rx_antb_agc_done : in std_logic;
      rx_antb_gainbb : in std_logic_vector(0 to 4);
      rx_antb_gainrf : in std_logic_vector(0 to 1);
      rx_extpktdet : in std_logic;
      rx_reset : in std_logic;
      tx_reset : in std_logic;
      tx_starttransmit : in std_logic;
      rx_debug_antsel : out std_logic;
      rx_debug_eq_i : out std_logic_vector(0 to 13);
      rx_debug_eq_q : out std_logic_vector(0 to 13);
      rx_debug_payload : out std_logic;
      rx_debug_phasecorrect : out std_logic_vector(0 to 13);
      rx_debug_phaseerror : out std_logic_vector(0 to 13);
      rx_debug_cfophasediff : out std_logic_vector(0 to 13);
      rx_debug_pktdone : out std_logic;
      rx_int_badpkt : out std_logic;
      rx_int_goodpkt : out std_logic;
      rx_int_goodheader : out std_logic;
      tx_int_pktdone : out std_logic;
      rx_pktdetreset : out std_logic;
      sgp_dbus : out std_logic_vector(0 to 31);
      sgp_errack : out std_logic;
      sgp_retry : out std_logic;
      sgp_toutsup : out std_logic;
      sgp_xferack : out std_logic;
      tx_anta_dac_i : out std_logic_vector(0 to 15);
      tx_anta_dac_q : out std_logic_vector(0 to 15);
      tx_antb_dac_i : out std_logic_vector(0 to 15);
      tx_antb_dac_q : out std_logic_vector(0 to 15);
      tx_debug_pktrunning : out std_logic
    );
  end component;

  component ofdm_agc_mimo_opbw_0_wrapper is
    port (
      ce : in std_logic;
      i_in_a : in std_logic_vector(0 to 13);
      i_in_b : in std_logic_vector(0 to 13);
      opb_abus : in std_logic_vector(0 to 31);
      opb_be : in std_logic_vector(0 to 3);
      opb_clk : in std_logic;
      opb_dbus : in std_logic_vector(0 to 31);
      opb_rnw : in std_logic;
      opb_rst : in std_logic;
      opb_select : in std_logic;
      opb_seqaddr : in std_logic;
      packet_in : in std_logic;
      q_in_a : in std_logic_vector(0 to 13);
      q_in_b : in std_logic_vector(0 to 13);
      reset_in : in std_logic;
      rssi_in_a : in std_logic_vector(0 to 9);
      rssi_in_b : in std_logic_vector(0 to 9);
      done_a : out std_logic;
      done_b : out std_logic;
      g_bb_a : out std_logic_vector(0 to 4);
      g_bb_b : out std_logic_vector(0 to 4);
      g_rf_a : out std_logic_vector(0 to 1);
      g_rf_b : out std_logic_vector(0 to 1);
      i_out_a : out std_logic_vector(0 to 13);
      i_out_b : out std_logic_vector(0 to 13);
      q_out_a : out std_logic_vector(0 to 13);
      q_out_b : out std_logic_vector(0 to 13);
      rxhp_a : out std_logic;
      rxhp_b : out std_logic;
      sgp_dbus : out std_logic_vector(0 to 31);
      sgp_errack : out std_logic;
      sgp_retry : out std_logic;
      sgp_toutsup : out std_logic;
      sgp_xferack : out std_logic
    );
  end component;

  component plb_bram_if_cntlr_2_wrapper is
    port (
      plb_clk : in std_logic;
      plb_rst : in std_logic;
      plb_abort : in std_logic;
      plb_abus : in std_logic_vector(0 to 31);
      plb_be : in std_logic_vector(0 to 7);
      plb_buslock : in std_logic;
      plb_compress : in std_logic;
      plb_guarded : in std_logic;
      plb_lockerr : in std_logic;
      plb_masterid : in std_logic_vector(0 to 1);
      plb_msize : in std_logic_vector(0 to 1);
      plb_ordered : in std_logic;
      plb_pavalid : in std_logic;
      plb_rnw : in std_logic;
      plb_size : in std_logic_vector(0 to 3);
      plb_type : in std_logic_vector(0 to 2);
      sl_addrack : out std_logic;
      sl_mbusy : out std_logic_vector(0 to 2);
      sl_merr : out std_logic_vector(0 to 2);
      sl_rearbitrate : out std_logic;
      sl_ssize : out std_logic_vector(0 to 1);
      sl_wait : out std_logic;
      plb_rdprim : in std_logic;
      plb_savalid : in std_logic;
      plb_wrprim : in std_logic;
      plb_wrburst : in std_logic;
      plb_wrdbus : in std_logic_vector(0 to 63);
      sl_wrbterm : out std_logic;
      sl_wrcomp : out std_logic;
      sl_wrdack : out std_logic;
      plb_rdburst : in std_logic;
      sl_rdbterm : out std_logic;
      sl_rdcomp : out std_logic;
      sl_rddack : out std_logic;
      sl_rddbus : out std_logic_vector(0 to 63);
      sl_rdwdaddr : out std_logic_vector(0 to 3);
      plb_pendreq : in std_logic;
      plb_pendpri : in std_logic_vector(0 to 1);
      plb_reqpri : in std_logic_vector(0 to 1);
      bram_rst : out std_logic;
      bram_clk : out std_logic;
      bram_en : out std_logic;
      bram_wen : out std_logic_vector(0 to 7);
      bram_addr : out std_logic_vector(0 to 31);
      bram_din : in std_logic_vector(0 to 63);
      bram_dout : out std_logic_vector(0 to 63)
    );
  end component;

  component plb_bram_if_cntlr_2_bram_wrapper is
    port (
      BRAM_Rst_A : in std_logic;
      BRAM_Clk_A : in std_logic;
      BRAM_EN_A : in std_logic;
      BRAM_WEN_A : in std_logic_vector(0 to 7);
      BRAM_Addr_A : in std_logic_vector(0 to 31);
      BRAM_Din_A : out std_logic_vector(0 to 63);
      BRAM_Dout_A : in std_logic_vector(0 to 63);
      BRAM_Rst_B : in std_logic;
      BRAM_Clk_B : in std_logic;
      BRAM_EN_B : in std_logic;
      BRAM_WEN_B : in std_logic_vector(0 to 7);
      BRAM_Addr_B : in std_logic_vector(0 to 31);
      BRAM_Din_B : out std_logic_vector(0 to 63);
      BRAM_Dout_B : in std_logic_vector(0 to 63)
    );
  end component;

  component debugoutputs_wrapper is
    port (
      OPB_ABus : in std_logic_vector(0 to 31);
      OPB_BE : in std_logic_vector(0 to 3);
      OPB_Clk : in std_logic;
      OPB_DBus : in std_logic_vector(0 to 31);
      OPB_RNW : in std_logic;
      OPB_Rst : in std_logic;
      OPB_select : in std_logic;
      OPB_seqAddr : in std_logic;
      Sln_DBus : out std_logic_vector(0 to 31);
      Sln_errAck : out std_logic;
      Sln_retry : out std_logic;
      Sln_toutSup : out std_logic;
      Sln_xferAck : out std_logic;
      IP2INTC_Irpt : out std_logic;
      GPIO_in : in std_logic_vector(0 to 3);
      GPIO_d_out : out std_logic_vector(0 to 3);
      GPIO_t_out : out std_logic_vector(0 to 3);
      GPIO2_in : in std_logic_vector(0 to 3);
      GPIO2_d_out : out std_logic_vector(0 to 3);
      GPIO2_t_out : out std_logic_vector(0 to 3);
      GPIO_IO_I : in std_logic_vector(0 to 3);
      GPIO_IO_O : out std_logic_vector(0 to 3);
      GPIO_IO_T : out std_logic_vector(0 to 3);
      GPIO2_IO_I : in std_logic_vector(0 to 3);
      GPIO2_IO_O : out std_logic_vector(0 to 3);
      GPIO2_IO_T : out std_logic_vector(0 to 3)
    );
  end component;

  component util_reduced_logic_0_wrapper is
    port (
      Op1 : in std_logic_vector(0 to 1);
      Res : out std_logic
    );
  end component;

  component user_io_board_controller_opbw_0_wrapper is
    port (
      ce : in std_logic;
      opb_abus : in std_logic_vector(0 to 31);
      opb_be : in std_logic_vector(0 to 3);
      opb_clk : in std_logic;
      opb_dbus : in std_logic_vector(0 to 31);
      opb_rnw : in std_logic;
      opb_rst : in std_logic;
      opb_select : in std_logic;
      opb_seqaddr : in std_logic;
      reset : in std_logic;
      cs : out std_logic;
      resetlcd : out std_logic;
      scl : out std_logic;
      sdi : out std_logic;
      sgp_dbus : out std_logic_vector(0 to 31);
      sgp_errack : out std_logic;
      sgp_retry : out std_logic;
      sgp_toutsup : out std_logic;
      sgp_xferack : out std_logic
    );
  end component;

  component IOBUF is
    port (
      I : in std_logic;
      IO : inout std_logic;
      O : out std_logic;
      T : in std_logic
    );
  end component;

  -- Internal signals

  signal C405RSTCHIPRESETREQ : std_logic;
  signal C405RSTCORERESETREQ : std_logic;
  signal C405RSTSYSRESETREQ : std_logic;
  signal EICC405EXTINPUTIRQ : std_logic;
  signal Ethernet_MAC_IP2INTC_Irpt : std_logic;
  signal Push_Buttons_4bit_IP2INTC_Irpt : std_logic;
  signal RSTC405RESETCHIP : std_logic;
  signal RSTC405RESETCORE : std_logic;
  signal RSTC405RESETSYS : std_logic;
  signal agc_done_a : std_logic;
  signal agc_done_b : std_logic;
  signal agc_g_bb_a : std_logic_vector(0 to 4);
  signal agc_g_bb_b : std_logic_vector(0 to 4);
  signal agc_g_rf_a : std_logic_vector(0 to 1);
  signal agc_g_rf_b : std_logic_vector(0 to 1);
  signal agc_rxhp_a : std_logic;
  signal agc_rxhp_b : std_logic;
  signal clkBoardConfig_DCM_Reset : std_logic;
  signal dcm_0_lock : std_logic;
  signal dcm_clk_s : std_logic;
  signal debug_chipscopetrig : std_logic;
  signal debug_rx_payload : std_logic;
  signal debug_rx_pktdone : std_logic;
  signal debug_tx_pktrunning : std_logic;
  signal docm_BRAMDSOCMRDDBUS : std_logic_vector(0 to 31);
  signal docm_DSARCVALUE : std_logic_vector(0 to 7);
  signal docm_DSCNTLVALUE : std_logic_vector(0 to 7);
  signal docm_DSOCMBRAMABUS : std_logic_vector(8 to 29);
  signal docm_DSOCMBRAMBYTEWRITE : std_logic_vector(0 to 3);
  signal docm_DSOCMBRAMEN : std_logic;
  signal docm_DSOCMBRAMWRDBUS : std_logic_vector(0 to 31);
  signal docm_DSOCM_Rst : std_logic;
  signal docm_M_DSOCMBRAMABUS : std_logic_vector(8 to 29);
  signal docm_M_DSOCMBRAMBYTEWRITE : std_logic_vector(0 to 3);
  signal docm_M_DSOCMBRAMEN : std_logic;
  signal docm_M_DSOCMBRAMWRDBUS : std_logic_vector(0 to 31);
  signal docm_M_DSOCMBUSY : std_logic;
  signal docm_S_BRAMDSOCMRDDBUS : std_logic_vector(0 to 31);
  signal docm_S_DSOCMRWCOMPLETE : std_logic_vector(0 to 0);
  signal docm_S_DSOCMSLAVESELECT : std_logic_vector(0 to 0);
  signal dsocm_porta_BRAM_Addr : std_logic_vector(0 to 31);
  signal dsocm_porta_BRAM_Clk : std_logic;
  signal dsocm_porta_BRAM_Din : std_logic_vector(0 to 31);
  signal dsocm_porta_BRAM_Dout : std_logic_vector(0 to 31);
  signal dsocm_porta_BRAM_EN : std_logic;
  signal dsocm_porta_BRAM_Rst : std_logic;
  signal dsocm_porta_BRAM_WEN : std_logic_vector(0 to 3);
  signal eeprom_controller_DQ2_I_radio_bridge_slot_2_user_EEPROM_IO_I : std_logic;
  signal eeprom_controller_DQ2_O_radio_bridge_slot_2_user_EEPROM_IO_O : std_logic;
  signal eeprom_controller_DQ2_T_radio_bridge_slot_2_user_EEPROM_IO_T : std_logic;
  signal eeprom_controller_DQ3_I_radio_bridge_slot_3_user_EEPROM_IO_I : std_logic;
  signal eeprom_controller_DQ3_O_radio_bridge_slot_3_user_EEPROM_IO_O : std_logic;
  signal eeprom_controller_DQ3_T_radio_bridge_slot_3_user_EEPROM_IO_T : std_logic;
  signal fpga_0_DIPSWs_4Bit_GPIO_in : std_logic_vector(0 to 3);
  signal fpga_0_Ethernet_MAC_PHY_Mii_clk_I : std_logic;
  signal fpga_0_Ethernet_MAC_PHY_Mii_clk_O : std_logic;
  signal fpga_0_Ethernet_MAC_PHY_Mii_clk_T : std_logic;
  signal fpga_0_Ethernet_MAC_PHY_Mii_data_I : std_logic;
  signal fpga_0_Ethernet_MAC_PHY_Mii_data_O : std_logic;
  signal fpga_0_Ethernet_MAC_PHY_Mii_data_T : std_logic;
  signal fpga_0_Ethernet_MAC_PHY_col : std_logic;
  signal fpga_0_Ethernet_MAC_PHY_crs : std_logic;
  signal fpga_0_Ethernet_MAC_PHY_dv : std_logic;
  signal fpga_0_Ethernet_MAC_PHY_rst_n : std_logic;
  signal fpga_0_Ethernet_MAC_PHY_rx_clk : std_logic;
  signal fpga_0_Ethernet_MAC_PHY_rx_data : std_logic_vector(3 downto 0);
  signal fpga_0_Ethernet_MAC_PHY_rx_er : std_logic;
  signal fpga_0_Ethernet_MAC_PHY_tx_clk : std_logic;
  signal fpga_0_Ethernet_MAC_PHY_tx_data : std_logic_vector(3 downto 0);
  signal fpga_0_Ethernet_MAC_PHY_tx_en : std_logic;
  signal fpga_0_Ethernet_MAC_PHY_tx_er : std_logic;
  signal fpga_0_LED_7SEGMENT_1_GPIO_d_out : std_logic_vector(0 to 6);
  signal fpga_0_LED_7SEGMENT_GPIO_d_out : std_logic_vector(0 to 6);
  signal fpga_0_LEDs_4Bit_GPIO_d_out : std_logic_vector(0 to 3);
  signal fpga_0_Push_Buttons_4bit_GPIO_in : std_logic_vector(0 to 3);
  signal fpga_0_SRAM0_ZBT_512Kx32_Mem_A : std_logic_vector(11 to 29);
  signal fpga_0_SRAM0_ZBT_512Kx32_Mem_ADV_LDN : std_logic;
  signal fpga_0_SRAM0_ZBT_512Kx32_Mem_A_split : std_logic_vector(0 to 31);
  signal fpga_0_SRAM0_ZBT_512Kx32_Mem_BEN : std_logic_vector(0 to 3);
  signal fpga_0_SRAM0_ZBT_512Kx32_Mem_CE : std_logic_vector(0 to 0);
  signal fpga_0_SRAM0_ZBT_512Kx32_Mem_CKEN : std_logic;
  signal fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I : std_logic_vector(0 to 31);
  signal fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O : std_logic_vector(0 to 31);
  signal fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T : std_logic_vector(0 to 31);
  signal fpga_0_SRAM0_ZBT_512Kx32_Mem_OEN : std_logic_vector(0 to 0);
  signal fpga_0_SRAM0_ZBT_512Kx32_Mem_WEN : std_logic;
  signal fpga_0_SRAM1_ZBT_512Kx32_Mem_A : std_logic_vector(11 to 29);
  signal fpga_0_SRAM1_ZBT_512Kx32_Mem_ADV_LDN : std_logic;
  signal fpga_0_SRAM1_ZBT_512Kx32_Mem_A_split : std_logic_vector(0 to 31);
  signal fpga_0_SRAM1_ZBT_512Kx32_Mem_BEN : std_logic_vector(0 to 3);
  signal fpga_0_SRAM1_ZBT_512Kx32_Mem_CE : std_logic_vector(0 to 0);
  signal fpga_0_SRAM1_ZBT_512Kx32_Mem_CKEN : std_logic;
  signal fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I : std_logic_vector(0 to 31);
  signal fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O : std_logic_vector(0 to 31);
  signal fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T : std_logic_vector(0 to 31);
  signal fpga_0_SRAM1_ZBT_512Kx32_Mem_OEN : std_logic_vector(0 to 0);
  signal fpga_0_SRAM1_ZBT_512Kx32_Mem_WEN : std_logic;
  signal fpga_0_analog_bridge_slot_4_analog_ADC_A : std_logic_vector(13 downto 0);
  signal fpga_0_analog_bridge_slot_4_analog_ADC_B : std_logic_vector(13 downto 0);
  signal fpga_0_analog_bridge_slot_4_analog_ADC_DCS : std_logic;
  signal fpga_0_analog_bridge_slot_4_analog_ADC_DFS : std_logic;
  signal fpga_0_analog_bridge_slot_4_analog_ADC_otrA : std_logic;
  signal fpga_0_analog_bridge_slot_4_analog_ADC_otrB : std_logic;
  signal fpga_0_analog_bridge_slot_4_analog_ADC_pdwnA : std_logic;
  signal fpga_0_analog_bridge_slot_4_analog_ADC_pdwnB : std_logic;
  signal fpga_0_analog_bridge_slot_4_analog_DAC1_A : std_logic_vector(13 downto 0);
  signal fpga_0_analog_bridge_slot_4_analog_DAC1_B : std_logic_vector(13 downto 0);
  signal fpga_0_analog_bridge_slot_4_analog_DAC1_sleep : std_logic;
  signal fpga_0_analog_bridge_slot_4_analog_DAC2_A : std_logic_vector(13 downto 0);
  signal fpga_0_analog_bridge_slot_4_analog_DAC2_B : std_logic_vector(13 downto 0);
  signal fpga_0_analog_bridge_slot_4_analog_DAC2_sleep : std_logic;
  signal fpga_0_analog_bridge_slot_4_analog_LED : std_logic_vector(0 to 2);
  signal fpga_0_analog_bridge_slot_4_clock_out : std_logic;
  signal fpga_0_clk_board_config_cfg_logic_clk_out : std_logic;
  signal fpga_0_clk_board_config_cfg_logic_csb_out : std_logic;
  signal fpga_0_clk_board_config_cfg_logic_dat_out : std_logic;
  signal fpga_0_clk_board_config_cfg_logic_en_out : std_logic;
  signal fpga_0_clk_board_config_cfg_radio_clk_out : std_logic;
  signal fpga_0_clk_board_config_cfg_radio_csb_out : std_logic;
  signal fpga_0_clk_board_config_cfg_radio_dat_out : std_logic;
  signal fpga_0_clk_board_config_cfg_radio_en_out : std_logic;
  signal fpga_0_clk_board_config_sys_clk : std_logic;
  signal fpga_0_debug_GPIO_d_out : std_logic_vector(0 to 3);
  signal fpga_0_eeprom_controller_DQ0_I : std_logic;
  signal fpga_0_eeprom_controller_DQ0_O : std_logic;
  signal fpga_0_eeprom_controller_DQ0_T : std_logic;
  signal fpga_0_radio_bridge_slot_2_converter_clock_out : std_logic;
  signal fpga_0_radio_bridge_slot_2_dac_spi_clk : std_logic;
  signal fpga_0_radio_bridge_slot_2_dac_spi_cs : std_logic;
  signal fpga_0_radio_bridge_slot_2_dac_spi_data : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_5PA : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_24PA : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_ADC_I : std_logic_vector(13 downto 0);
  signal fpga_0_radio_bridge_slot_2_radio_ADC_Q : std_logic_vector(13 downto 0);
  signal fpga_0_radio_bridge_slot_2_radio_ANTSW : std_logic_vector(1 downto 0);
  signal fpga_0_radio_bridge_slot_2_radio_B : std_logic_vector(6 downto 0);
  signal fpga_0_radio_bridge_slot_2_radio_DAC_I : std_logic_vector(15 downto 0);
  signal fpga_0_radio_bridge_slot_2_radio_DAC_Q : std_logic_vector(15 downto 0);
  signal fpga_0_radio_bridge_slot_2_radio_DIPSW : std_logic_vector(3 downto 0);
  signal fpga_0_radio_bridge_slot_2_radio_LD : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_LED : std_logic_vector(2 downto 0);
  signal fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_CLAMP : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_D : std_logic_vector(9 downto 0);
  signal fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_HIZ : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_OTR : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_SLEEP : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_clk : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_RX_ADC_DCS : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_RX_ADC_DFS : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_RX_ADC_OTRA : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_RX_ADC_OTRB : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_RX_ADC_PWDNA : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_RX_ADC_PWDNB : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_RxEn : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_RxHP : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_SHDN : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_TxEn : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_dac_PLL_LOCK : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_dac_RESET : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_spi_clk : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_spi_cs : std_logic;
  signal fpga_0_radio_bridge_slot_2_radio_spi_data : std_logic;
  signal fpga_0_radio_bridge_slot_3_converter_clock_out : std_logic;
  signal fpga_0_radio_bridge_slot_3_dac_spi_clk : std_logic;
  signal fpga_0_radio_bridge_slot_3_dac_spi_cs : std_logic;
  signal fpga_0_radio_bridge_slot_3_dac_spi_data : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_5PA : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_24PA : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_ADC_I : std_logic_vector(13 downto 0);
  signal fpga_0_radio_bridge_slot_3_radio_ADC_Q : std_logic_vector(13 downto 0);
  signal fpga_0_radio_bridge_slot_3_radio_ANTSW : std_logic_vector(1 downto 0);
  signal fpga_0_radio_bridge_slot_3_radio_B : std_logic_vector(6 downto 0);
  signal fpga_0_radio_bridge_slot_3_radio_DAC_I : std_logic_vector(15 downto 0);
  signal fpga_0_radio_bridge_slot_3_radio_DAC_Q : std_logic_vector(15 downto 0);
  signal fpga_0_radio_bridge_slot_3_radio_DIPSW : std_logic_vector(3 downto 0);
  signal fpga_0_radio_bridge_slot_3_radio_LD : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_LED : std_logic_vector(2 downto 0);
  signal fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_CLAMP : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_D : std_logic_vector(9 downto 0);
  signal fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_HIZ : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_OTR : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_SLEEP : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_clk : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_RX_ADC_DCS : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_RX_ADC_DFS : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_RX_ADC_OTRA : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_RX_ADC_OTRB : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_RX_ADC_PWDNA : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_RX_ADC_PWDNB : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_RxEn : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_RxHP : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_SHDN : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_TxEn : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_dac_PLL_LOCK : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_dac_RESET : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_spi_clk : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_spi_cs : std_logic;
  signal fpga_0_radio_bridge_slot_3_radio_spi_data : std_logic;
  signal fpga_0_rs232_RX : std_logic;
  signal fpga_0_rs232_TX : std_logic;
  signal iocm_BRAMISOCMRDDBUS : std_logic_vector(0 to 63);
  signal iocm_ISARCVALUE : std_logic_vector(0 to 7);
  signal iocm_ISCNTLVALUE : std_logic_vector(0 to 7);
  signal iocm_ISOCMBRAMEN : std_logic;
  signal iocm_ISOCMBRAMEVENWRITEEN : std_logic;
  signal iocm_ISOCMBRAMODDWRITEEN : std_logic;
  signal iocm_ISOCMBRAMRDABUS : std_logic_vector(8 to 28);
  signal iocm_ISOCMBRAMWRABUS : std_logic_vector(8 to 28);
  signal iocm_ISOCMBRAMWRDBUS : std_logic_vector(0 to 31);
  signal iocm_ISOCMDCRBRAMEVENEN : std_logic;
  signal iocm_ISOCMDCRBRAMODDEN : std_logic;
  signal iocm_ISOCMDCRBRAMRDSELECT : std_logic;
  signal iocm_ISOCM_Rst : std_logic;
  signal iocm_M_ISOCMBRAMEN : std_logic;
  signal iocm_M_ISOCMBRAMEVENWRITEEN : std_logic;
  signal iocm_M_ISOCMBRAMODDWRITEEN : std_logic;
  signal iocm_M_ISOCMBRAMRDABUS : std_logic_vector(8 to 28);
  signal iocm_M_ISOCMBRAMWRABUS : std_logic_vector(8 to 28);
  signal iocm_M_ISOCMBRAMWRDBUS : std_logic_vector(0 to 31);
  signal iocm_S_BRAMISOCMDCRRDDBUS : std_logic_vector(0 to 31);
  signal iocm_S_BRAMISOCMRDDBUS : std_logic_vector(0 to 63);
  signal iocm_S_ISOCMDCRSLAVESELECT : std_logic_vector(0 to 0);
  signal iocm_S_ISOCMSLAVESELECT : std_logic_vector(0 to 0);
  signal isocm_porta_BRAM_Addr : std_logic_vector(0 to 31);
  signal isocm_porta_BRAM_Clk : std_logic;
  signal isocm_porta_BRAM_Din : std_logic_vector(0 to 63);
  signal isocm_porta_BRAM_Dout : std_logic_vector(0 to 63);
  signal isocm_porta_BRAM_EN : std_logic;
  signal isocm_porta_BRAM_Rst : std_logic;
  signal isocm_porta_BRAM_WEN : std_logic_vector(0 to 1);
  signal isocm_portb_BRAM_Addr : std_logic_vector(0 to 31);
  signal isocm_portb_BRAM_Clk : std_logic;
  signal isocm_portb_BRAM_Din : std_logic_vector(0 to 63);
  signal isocm_portb_BRAM_Dout : std_logic_vector(0 to 63);
  signal isocm_portb_BRAM_EN : std_logic;
  signal isocm_portb_BRAM_Rst : std_logic;
  signal isocm_portb_BRAM_WEN : std_logic_vector(0 to 1);
  signal jtagppc_0_0_C405JTGTDO : std_logic;
  signal jtagppc_0_0_C405JTGTDOEN : std_logic;
  signal jtagppc_0_0_JTGC405TCK : std_logic;
  signal jtagppc_0_0_JTGC405TDI : std_logic;
  signal jtagppc_0_0_JTGC405TMS : std_logic;
  signal jtagppc_0_0_JTGC405TRSTNEG : std_logic;
  signal jtagppc_0_1_C405JTGTDO : std_logic;
  signal jtagppc_0_1_C405JTGTDOEN : std_logic;
  signal jtagppc_0_1_JTGC405TCK : std_logic;
  signal jtagppc_0_1_JTGC405TDI : std_logic;
  signal jtagppc_0_1_JTGC405TMS : std_logic;
  signal jtagppc_0_1_JTGC405TRSTNEG : std_logic;
  signal net_gnd0 : std_logic;
  signal net_gnd1 : std_logic_vector(0 to 0);
  signal net_gnd2 : std_logic_vector(0 to 1);
  signal net_gnd3 : std_logic_vector(0 to 2);
  signal net_gnd4 : std_logic_vector(0 to 3);
  signal net_gnd7 : std_logic_vector(0 to 6);
  signal net_gnd8 : std_logic_vector(0 to 7);
  signal net_gnd10 : std_logic_vector(0 to 9);
  signal net_gnd15 : std_logic_vector(0 to 14);
  signal net_gnd32 : std_logic_vector(0 to 31);
  signal net_gnd64 : std_logic_vector(0 to 63);
  signal net_vcc0 : std_logic;
  signal net_vcc1 : std_logic_vector(0 to 0);
  signal net_vcc15 : std_logic_vector(0 to 14);
  signal ofdmRx_antA_ADC_I : std_logic_vector(0 to 13);
  signal ofdmRx_antA_ADC_Q : std_logic_vector(0 to 13);
  signal ofdmRx_antB_ADC_I : std_logic_vector(0 to 13);
  signal ofdmRx_antB_ADC_Q : std_logic_vector(0 to 13);
  signal ofdm_TxRxPLB_BRAM_port_BRAM_Addr : std_logic_vector(0 to 31);
  signal ofdm_TxRxPLB_BRAM_port_BRAM_Din : std_logic_vector(0 to 63);
  signal ofdm_TxRxPLB_BRAM_port_BRAM_Dout : std_logic_vector(0 to 63);
  signal ofdm_TxRxPLB_BRAM_port_BRAM_Rst : std_logic;
  signal ofdm_TxRxPLB_BRAM_port_BRAM_WEN : std_logic_vector(0 to 7);
  signal ofdm_pktDetector_mimo_opbw_0_debugbusy : std_logic;
  signal ofdm_pktDetector_mimo_opbw_0_debugidledifs : std_logic;
  signal ofdm_pktDetector_mimo_opbw_0_idlefordifs : std_logic;
  signal ofdm_rx_debug_eq_i : std_logic_vector(0 to 13);
  signal ofdm_rx_debug_eq_q : std_logic_vector(0 to 13);
  signal ofdm_timer_opbw_0_timerexpire : std_logic;
  signal opb_M_ABus : std_logic_vector(0 to 31);
  signal opb_M_BE : std_logic_vector(0 to 3);
  signal opb_M_DBus : std_logic_vector(0 to 31);
  signal opb_M_RNW : std_logic_vector(0 to 0);
  signal opb_M_busLock : std_logic_vector(0 to 0);
  signal opb_M_request : std_logic_vector(0 to 0);
  signal opb_M_select : std_logic_vector(0 to 0);
  signal opb_M_seqAddr : std_logic_vector(0 to 0);
  signal opb_OPB_ABus : std_logic_vector(0 to 31);
  signal opb_OPB_BE : std_logic_vector(0 to 3);
  signal opb_OPB_DBus : std_logic_vector(0 to 31);
  signal opb_OPB_MGrant : std_logic_vector(0 to 0);
  signal opb_OPB_RNW : std_logic;
  signal opb_OPB_Rst : std_logic;
  signal opb_OPB_errAck : std_logic;
  signal opb_OPB_retry : std_logic;
  signal opb_OPB_select : std_logic;
  signal opb_OPB_seqAddr : std_logic;
  signal opb_OPB_timeout : std_logic;
  signal opb_OPB_xferAck : std_logic;
  signal opb_Sl_DBus : std_logic_vector(0 to 479);
  signal opb_Sl_errAck : std_logic_vector(0 to 14);
  signal opb_Sl_retry : std_logic_vector(0 to 14);
  signal opb_Sl_toutSup : std_logic_vector(0 to 14);
  signal opb_Sl_xferAck : std_logic_vector(0 to 14);
  signal pcoreReset : std_logic_vector(0 to 0);
  signal pgassign1 : std_logic_vector(6 downto 0);
  signal pgassign2 : std_logic_vector(0 to 1);
  signal pgassign3 : std_logic_vector(0 to 9);
  signal plb_M_ABus : std_logic_vector(0 to 95);
  signal plb_M_BE : std_logic_vector(0 to 23);
  signal plb_M_MSize : std_logic_vector(0 to 5);
  signal plb_M_RNW : std_logic_vector(0 to 2);
  signal plb_M_abort : std_logic_vector(0 to 2);
  signal plb_M_busLock : std_logic_vector(0 to 2);
  signal plb_M_compress : std_logic_vector(0 to 2);
  signal plb_M_guarded : std_logic_vector(0 to 2);
  signal plb_M_lockErr : std_logic_vector(0 to 2);
  signal plb_M_ordered : std_logic_vector(0 to 2);
  signal plb_M_priority : std_logic_vector(0 to 5);
  signal plb_M_rdBurst : std_logic_vector(0 to 2);
  signal plb_M_request : std_logic_vector(0 to 2);
  signal plb_M_size : std_logic_vector(0 to 11);
  signal plb_M_type : std_logic_vector(0 to 8);
  signal plb_M_wrBurst : std_logic_vector(0 to 2);
  signal plb_M_wrDBus : std_logic_vector(0 to 191);
  signal plb_PLB2OPB_rearb : std_logic_vector(0 to 5);
  signal plb_PLB_ABus : std_logic_vector(0 to 31);
  signal plb_PLB_BE : std_logic_vector(0 to 7);
  signal plb_PLB_MAddrAck : std_logic_vector(0 to 2);
  signal plb_PLB_MBusy : std_logic_vector(0 to 2);
  signal plb_PLB_MErr : std_logic_vector(0 to 2);
  signal plb_PLB_MRdBTerm : std_logic_vector(0 to 2);
  signal plb_PLB_MRdDAck : std_logic_vector(0 to 2);
  signal plb_PLB_MRdDBus : std_logic_vector(0 to 191);
  signal plb_PLB_MRdWdAddr : std_logic_vector(0 to 11);
  signal plb_PLB_MRearbitrate : std_logic_vector(0 to 2);
  signal plb_PLB_MSSize : std_logic_vector(0 to 5);
  signal plb_PLB_MSize : std_logic_vector(0 to 1);
  signal plb_PLB_MWrBTerm : std_logic_vector(0 to 2);
  signal plb_PLB_MWrDAck : std_logic_vector(0 to 2);
  signal plb_PLB_PAValid : std_logic;
  signal plb_PLB_RNW : std_logic;
  signal plb_PLB_Rst : std_logic;
  signal plb_PLB_SAValid : std_logic;
  signal plb_PLB_SMBusy : std_logic_vector(0 to 2);
  signal plb_PLB_SMErr : std_logic_vector(0 to 2);
  signal plb_PLB_abort : std_logic;
  signal plb_PLB_busLock : std_logic;
  signal plb_PLB_compress : std_logic;
  signal plb_PLB_guarded : std_logic;
  signal plb_PLB_lockErr : std_logic;
  signal plb_PLB_masterID : std_logic_vector(0 to 1);
  signal plb_PLB_ordered : std_logic;
  signal plb_PLB_pendPri : std_logic_vector(0 to 1);
  signal plb_PLB_pendReq : std_logic;
  signal plb_PLB_rdBurst : std_logic;
  signal plb_PLB_rdPrim : std_logic;
  signal plb_PLB_reqPri : std_logic_vector(0 to 1);
  signal plb_PLB_size : std_logic_vector(0 to 3);
  signal plb_PLB_type : std_logic_vector(0 to 2);
  signal plb_PLB_wrBurst : std_logic;
  signal plb_PLB_wrDBus : std_logic_vector(0 to 63);
  signal plb_PLB_wrPrim : std_logic;
  signal plb_Sl_MBusy : std_logic_vector(0 to 17);
  signal plb_Sl_MErr : std_logic_vector(0 to 17);
  signal plb_Sl_SSize : std_logic_vector(0 to 11);
  signal plb_Sl_addrAck : std_logic_vector(0 to 5);
  signal plb_Sl_rdBTerm : std_logic_vector(0 to 5);
  signal plb_Sl_rdComp : std_logic_vector(0 to 5);
  signal plb_Sl_rdDAck : std_logic_vector(0 to 5);
  signal plb_Sl_rdDBus : std_logic_vector(0 to 383);
  signal plb_Sl_rdWdAddr : std_logic_vector(0 to 23);
  signal plb_Sl_rearbitrate : std_logic_vector(0 to 5);
  signal plb_Sl_wait : std_logic_vector(0 to 5);
  signal plb_Sl_wrBTerm : std_logic_vector(0 to 5);
  signal plb_Sl_wrComp : std_logic_vector(0 to 5);
  signal plb_Sl_wrDAck : std_logic_vector(0 to 5);
  signal plb_bram_if_cntlr_1_port_BRAM_Addr : std_logic_vector(0 to 31);
  signal plb_bram_if_cntlr_1_port_BRAM_Clk : std_logic;
  signal plb_bram_if_cntlr_1_port_BRAM_Din : std_logic_vector(0 to 63);
  signal plb_bram_if_cntlr_1_port_BRAM_Dout : std_logic_vector(0 to 63);
  signal plb_bram_if_cntlr_1_port_BRAM_EN : std_logic;
  signal plb_bram_if_cntlr_1_port_BRAM_Rst : std_logic;
  signal plb_bram_if_cntlr_1_port_BRAM_WEN : std_logic_vector(0 to 7);
  signal plb_bram_if_cntlr_2_port_BRAM_Addr : std_logic_vector(0 to 31);
  signal plb_bram_if_cntlr_2_port_BRAM_Clk : std_logic;
  signal plb_bram_if_cntlr_2_port_BRAM_Din : std_logic_vector(0 to 63);
  signal plb_bram_if_cntlr_2_port_BRAM_Dout : std_logic_vector(0 to 63);
  signal plb_bram_if_cntlr_2_port_BRAM_EN : std_logic;
  signal plb_bram_if_cntlr_2_port_BRAM_Rst : std_logic;
  signal plb_bram_if_cntlr_2_port_BRAM_WEN : std_logic_vector(0 to 7);
  signal proc_clk_s : std_logic;
  signal radio2_txStart : std_logic;
  signal radio3_txStart : std_logic;
  signal radio_bridge_slot_2_controller_5PA_radio_controller_0_radio2_5PA : std_logic;
  signal radio_bridge_slot_2_controller_24PA_radio_controller_0_radio2_24PA : std_logic;
  signal radio_bridge_slot_2_controller_ANTSW_radio_controller_0_radio2_ANTSW : std_logic_vector(0 to 1);
  signal radio_bridge_slot_2_controller_DIPSW_radio_controller_0_radio2_DIPSW : std_logic_vector(0 to 3);
  signal radio_bridge_slot_2_controller_LD_radio_controller_0_radio2_LD : std_logic;
  signal radio_bridge_slot_2_controller_LED_radio_controller_0_radio2_LED : std_logic_vector(0 to 2);
  signal radio_bridge_slot_2_controller_RSSI_ADC_CLAMP_radio_controller_0_radio2_RSSI_ADC_CLAMP : std_logic;
  signal radio_bridge_slot_2_controller_RSSI_ADC_D_radio_controller_0_radio2_RSSI_ADC_D : std_logic_vector(0 to 9);
  signal radio_bridge_slot_2_controller_RSSI_ADC_HIZ_radio_controller_0_radio2_RSSI_ADC_HIZ : std_logic;
  signal radio_bridge_slot_2_controller_RSSI_ADC_OTR_radio_controller_0_radio2_RSSI_ADC_OTR : std_logic;
  signal radio_bridge_slot_2_controller_RSSI_ADC_SLEEP_radio_controller_0_radio2_RSSI_ADC_SLEEP : std_logic;
  signal radio_bridge_slot_2_controller_RX_ADC_DCS_radio_controller_0_radio2_ADC_RX_DCS : std_logic;
  signal radio_bridge_slot_2_controller_RX_ADC_DFS_radio_controller_0_radio2_ADC_RX_DFS : std_logic;
  signal radio_bridge_slot_2_controller_RX_ADC_OTRA_radio_controller_0_radio2_ADC_RX_OTRA : std_logic;
  signal radio_bridge_slot_2_controller_RX_ADC_OTRB_radio_controller_0_radio2_ADC_RX_OTRB : std_logic;
  signal radio_bridge_slot_2_controller_RX_ADC_PWDNA_radio_controller_0_radio2_ADC_RX_PWDNA : std_logic;
  signal radio_bridge_slot_2_controller_RX_ADC_PWDNB_radio_controller_0_radio2_ADC_RX_PWDNB : std_logic;
  signal radio_bridge_slot_2_controller_RxEn_external_radio_controller_0_radio2_RxEn_external : std_logic;
  signal radio_bridge_slot_2_controller_RxEn_radio_controller_0_radio2_RxEn : std_logic;
  signal radio_bridge_slot_2_controller_RxHP_external_radio_controller_0_radio2_RxHP_external : std_logic;
  signal radio_bridge_slot_2_controller_RxHP_radio_controller_0_radio2_RxHP : std_logic;
  signal radio_bridge_slot_2_controller_SHDN_external_radio_controller_0_radio2_SHDN_external : std_logic;
  signal radio_bridge_slot_2_controller_SHDN_radio_controller_0_radio2_SHDN : std_logic;
  signal radio_bridge_slot_2_controller_TxEn_external_radio_controller_0_radio2_TxEn_external : std_logic;
  signal radio_bridge_slot_2_controller_TxEn_radio_controller_0_radio2_TxEn : std_logic;
  signal radio_bridge_slot_2_controller_TxStart_radio_controller_0_radio2_TxStart : std_logic;
  signal radio_bridge_slot_2_controller_dac_PLL_LOCK_radio_controller_0_radio2_TX_DAC_PLL_LOCK : std_logic;
  signal radio_bridge_slot_2_controller_dac_RESET_radio_controller_0_radio2_TX_DAC_RESET : std_logic;
  signal radio_bridge_slot_2_controller_dac_cs_radio_controller_0_dac2_cs : std_logic;
  signal radio_bridge_slot_2_controller_radio_cs_radio_controller_0_radio2_cs : std_logic;
  signal radio_bridge_slot_2_controller_spi_clk_radio_bridge_slot_3_controller_spi_clk_radio_controller_0_spi_clk : std_logic;
  signal radio_bridge_slot_2_controller_spi_data_radio_bridge_slot_3_controller_spi_data_radio_controller_0_data_out : std_logic;
  signal radio_bridge_slot_2_user_ADC_I : std_logic_vector(0 to 13);
  signal radio_bridge_slot_2_user_ADC_Q : std_logic_vector(0 to 13);
  signal radio_bridge_slot_2_user_DAC_I : std_logic_vector(0 to 15);
  signal radio_bridge_slot_2_user_DAC_Q : std_logic_vector(0 to 15);
  signal radio_bridge_slot_2_user_RSSI_ADC_D : std_logic_vector(0 to 9);
  signal radio_bridge_slot_2_user_Tx_gain_radio_controller_0_radio2_TxGain : std_logic_vector(0 to 5);
  signal radio_bridge_slot_3_controller_5PA_radio_controller_0_radio3_5PA : std_logic;
  signal radio_bridge_slot_3_controller_24PA_radio_controller_0_radio3_24PA : std_logic;
  signal radio_bridge_slot_3_controller_ANTSW_radio_controller_0_radio3_ANTSW : std_logic_vector(0 to 1);
  signal radio_bridge_slot_3_controller_DIPSW_radio_controller_0_radio3_DIPSW : std_logic_vector(0 to 3);
  signal radio_bridge_slot_3_controller_LD_radio_controller_0_radio3_LD : std_logic;
  signal radio_bridge_slot_3_controller_LED_radio_controller_0_radio3_LED : std_logic_vector(0 to 2);
  signal radio_bridge_slot_3_controller_RSSI_ADC_CLAMP_radio_controller_0_radio3_RSSI_ADC_CLAMP : std_logic;
  signal radio_bridge_slot_3_controller_RSSI_ADC_D_radio_controller_0_radio3_RSSI_ADC_D : std_logic_vector(0 to 9);
  signal radio_bridge_slot_3_controller_RSSI_ADC_HIZ_radio_controller_0_radio3_RSSI_ADC_HIZ : std_logic;
  signal radio_bridge_slot_3_controller_RSSI_ADC_OTR_radio_controller_0_radio3_RSSI_ADC_OTR : std_logic;
  signal radio_bridge_slot_3_controller_RSSI_ADC_SLEEP_radio_controller_0_radio3_RSSI_ADC_SLEEP : std_logic;
  signal radio_bridge_slot_3_controller_RX_ADC_DCS_radio_controller_0_radio3_ADC_RX_DCS : std_logic;
  signal radio_bridge_slot_3_controller_RX_ADC_DFS_radio_controller_0_radio3_ADC_RX_DFS : std_logic;
  signal radio_bridge_slot_3_controller_RX_ADC_OTRA_radio_controller_0_radio3_ADC_RX_OTRA : std_logic;
  signal radio_bridge_slot_3_controller_RX_ADC_OTRB_radio_controller_0_radio3_ADC_RX_OTRB : std_logic;
  signal radio_bridge_slot_3_controller_RX_ADC_PWDNA_radio_controller_0_radio3_ADC_RX_PWDNA : std_logic;
  signal radio_bridge_slot_3_controller_RX_ADC_PWDNB_radio_controller_0_radio3_ADC_RX_PWDNB : std_logic;
  signal radio_bridge_slot_3_controller_RxEn_external_radio_controller_0_radio3_RxEn_external : std_logic;
  signal radio_bridge_slot_3_controller_RxEn_radio_controller_0_radio3_RxEn : std_logic;
  signal radio_bridge_slot_3_controller_RxHP_external_radio_controller_0_radio3_RxHP_external : std_logic;
  signal radio_bridge_slot_3_controller_RxHP_radio_controller_0_radio3_RxHP : std_logic;
  signal radio_bridge_slot_3_controller_SHDN_external_radio_controller_0_radio3_SHDN_external : std_logic;
  signal radio_bridge_slot_3_controller_SHDN_radio_controller_0_radio3_SHDN : std_logic;
  signal radio_bridge_slot_3_controller_TxEn_external_radio_controller_0_radio3_TxEn_external : std_logic;
  signal radio_bridge_slot_3_controller_TxEn_radio_controller_0_radio3_TxEn : std_logic;
  signal radio_bridge_slot_3_controller_TxStart_radio_controller_0_radio3_TxStart : std_logic;
  signal radio_bridge_slot_3_controller_dac_PLL_LOCK_radio_controller_0_radio3_TX_DAC_PLL_LOCK : std_logic;
  signal radio_bridge_slot_3_controller_dac_RESET_radio_controller_0_radio3_TX_DAC_RESET : std_logic;
  signal radio_bridge_slot_3_controller_dac_cs_radio_controller_0_dac3_cs : std_logic;
  signal radio_bridge_slot_3_controller_radio_cs_radio_controller_0_radio3_cs : std_logic;
  signal radio_bridge_slot_3_user_ADC_I : std_logic_vector(0 to 13);
  signal radio_bridge_slot_3_user_ADC_Q : std_logic_vector(0 to 13);
  signal radio_bridge_slot_3_user_DAC_I : std_logic_vector(0 to 15);
  signal radio_bridge_slot_3_user_DAC_Q : std_logic_vector(0 to 15);
  signal radio_bridge_slot_3_user_RSSI_ADC_D : std_logic_vector(0 to 9);
  signal radio_bridge_slot_3_user_Tx_gain_radio_controller_0_radio3_TxGain : std_logic_vector(0 to 5);
  signal rssi_pkt_detect_opbw_0_rssi_clk_out : std_logic;
  signal rssi_pkt_detect_opbw_0_rssi_pkt_det_out : std_logic;
  signal rx_debug_cfophasediff : std_logic_vector(0 to 13);
  signal rx_debug_phasecorrect : std_logic_vector(0 to 13);
  signal rx_int_badpkt : std_logic;
  signal rx_int_goodheader : std_logic;
  signal rx_int_goodpkt : std_logic;
  signal rx_pktdetreset : std_logic;
  signal sys_bus_reset : std_logic_vector(0 to 0);
  signal sys_clk_OPB : std_logic;
  signal sys_clk_s : std_logic;
  signal sys_rst_s : std_logic;
  signal txPHYStart : std_logic;
  signal tx_int_pktdone : std_logic;
  signal user_io_board_controller_opbw_0_cs : std_logic;
  signal user_io_board_controller_opbw_0_resetlcd : std_logic;
  signal user_io_board_controller_opbw_0_scl : std_logic;
  signal user_io_board_controller_opbw_0_sdi : std_logic;

  attribute box_type : STRING;
  attribute box_type of ppc405_0_wrapper : component is "black_box";
  attribute box_type of ppc405_1_wrapper : component is "black_box";
  attribute box_type of jtagppc_0_wrapper : component is "black_box";
  attribute box_type of reset_block_wrapper : component is "black_box";
  attribute box_type of iocm_wrapper : component is "black_box";
  attribute box_type of iocm_cntlr_wrapper : component is "black_box";
  attribute box_type of isocm_bram_wrapper : component is "black_box";
  attribute box_type of docm_wrapper : component is "black_box";
  attribute box_type of docm_cntlr_wrapper : component is "black_box";
  attribute box_type of dsocm_bram_wrapper : component is "black_box";
  attribute box_type of plb_wrapper : component is "black_box";
  attribute box_type of opb_wrapper : component is "black_box";
  attribute box_type of plb2opb_wrapper : component is "black_box";
  attribute box_type of led_7segment_wrapper : component is "black_box";
  attribute box_type of led_7segment_1_wrapper : component is "black_box";
  attribute box_type of leds_4bit_wrapper : component is "black_box";
  attribute box_type of push_buttons_4bit_wrapper : component is "black_box";
  attribute box_type of dipsws_4bit_wrapper : component is "black_box";
  attribute box_type of rs232_wrapper : component is "black_box";
  attribute box_type of clk_board_config_wrapper : component is "black_box";
  attribute box_type of eeprom_controller_wrapper : component is "black_box";
  attribute box_type of ethernet_mac_wrapper : component is "black_box";
  attribute box_type of radio_controller_0_wrapper : component is "black_box";
  attribute box_type of radio_bridge_slot_2_wrapper : component is "black_box";
  attribute box_type of radio_bridge_slot_3_wrapper : component is "black_box";
  attribute box_type of analog_bridge_slot_4_wrapper : component is "black_box";
  attribute box_type of sram0_zbt_512kx32_wrapper : component is "black_box";
  attribute box_type of sram1_zbt_512kx32_wrapper : component is "black_box";
  attribute box_type of plb_bram_if_cntlr_1_wrapper : component is "black_box";
  attribute box_type of plb_bram_if_cntlr_1_bram_wrapper : component is "black_box";
  attribute box_type of opb_intc_0_wrapper : component is "black_box";
  attribute box_type of sram0_zbt_512kx32_util_bus_split_0_wrapper : component is "black_box";
  attribute box_type of sram1_zbt_512kx32_util_bus_split_1_wrapper : component is "black_box";
  attribute box_type of dcm_0_wrapper : component is "black_box";
  attribute box_type of ofdm_timer_opbw_0_wrapper : component is "black_box";
  attribute box_type of ofdm_pktdetector_mimo_opbw_0_wrapper : component is "black_box";
  attribute box_type of ofdm_txrx_mimo_opbw_0_wrapper : component is "black_box";
  attribute box_type of ofdm_agc_mimo_opbw_0_wrapper : component is "black_box";
  attribute box_type of plb_bram_if_cntlr_2_wrapper : component is "black_box";
  attribute box_type of plb_bram_if_cntlr_2_bram_wrapper : component is "black_box";
  attribute box_type of debugoutputs_wrapper : component is "black_box";
  attribute box_type of util_reduced_logic_0_wrapper : component is "black_box";
  attribute box_type of user_io_board_controller_opbw_0_wrapper : component is "black_box";

begin

  -- Internal assignments

  fpga_0_clk_board_config_sys_clk <= fpga_0_clk_board_config_sys_clk_pin;
  fpga_0_clk_board_config_cfg_radio_dat_out_pin <= fpga_0_clk_board_config_cfg_radio_dat_out;
  fpga_0_clk_board_config_cfg_radio_csb_out_pin <= fpga_0_clk_board_config_cfg_radio_csb_out;
  fpga_0_clk_board_config_cfg_radio_en_out_pin <= fpga_0_clk_board_config_cfg_radio_en_out;
  fpga_0_clk_board_config_cfg_radio_clk_out_pin <= fpga_0_clk_board_config_cfg_radio_clk_out;
  fpga_0_clk_board_config_cfg_logic_dat_out_pin <= fpga_0_clk_board_config_cfg_logic_dat_out;
  fpga_0_clk_board_config_cfg_logic_csb_out_pin <= fpga_0_clk_board_config_cfg_logic_csb_out;
  fpga_0_clk_board_config_cfg_logic_en_out_pin <= fpga_0_clk_board_config_cfg_logic_en_out;
  fpga_0_clk_board_config_cfg_logic_clk_out_pin <= fpga_0_clk_board_config_cfg_logic_clk_out;
  fpga_0_radio_bridge_slot_2_converter_clock_out_pin <= fpga_0_radio_bridge_slot_2_converter_clock_out;
  fpga_0_radio_bridge_slot_2_dac_spi_clk_pin <= fpga_0_radio_bridge_slot_2_dac_spi_clk;
  fpga_0_radio_bridge_slot_2_dac_spi_cs_pin <= fpga_0_radio_bridge_slot_2_dac_spi_cs;
  fpga_0_radio_bridge_slot_2_dac_spi_data_pin <= fpga_0_radio_bridge_slot_2_dac_spi_data;
  fpga_0_radio_bridge_slot_2_radio_24PA_pin <= fpga_0_radio_bridge_slot_2_radio_24PA;
  fpga_0_radio_bridge_slot_2_radio_5PA_pin <= fpga_0_radio_bridge_slot_2_radio_5PA;
  fpga_0_radio_bridge_slot_2_radio_ANTSW_pin <= fpga_0_radio_bridge_slot_2_radio_ANTSW;
  fpga_0_radio_bridge_slot_2_radio_dac_PLL_LOCK <= fpga_0_radio_bridge_slot_2_radio_dac_PLL_LOCK_pin;
  fpga_0_radio_bridge_slot_2_radio_dac_RESET_pin <= fpga_0_radio_bridge_slot_2_radio_dac_RESET;
  fpga_0_radio_bridge_slot_2_radio_DIPSW <= fpga_0_radio_bridge_slot_2_radio_DIPSW_pin;
  fpga_0_radio_bridge_slot_2_radio_LD <= fpga_0_radio_bridge_slot_2_radio_LD_pin;
  fpga_0_radio_bridge_slot_2_radio_LED_pin <= fpga_0_radio_bridge_slot_2_radio_LED;
  fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_clk_pin <= fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_clk;
  fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_CLAMP_pin <= fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_CLAMP;
  fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_D <= fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_D_pin;
  fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_HIZ_pin <= fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_HIZ;
  fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_OTR <= fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_OTR_pin;
  fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_SLEEP_pin <= fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_SLEEP;
  fpga_0_radio_bridge_slot_2_radio_RX_ADC_DCS_pin <= fpga_0_radio_bridge_slot_2_radio_RX_ADC_DCS;
  fpga_0_radio_bridge_slot_2_radio_RX_ADC_DFS_pin <= fpga_0_radio_bridge_slot_2_radio_RX_ADC_DFS;
  fpga_0_radio_bridge_slot_2_radio_RX_ADC_OTRA <= fpga_0_radio_bridge_slot_2_radio_RX_ADC_OTRA_pin;
  fpga_0_radio_bridge_slot_2_radio_RX_ADC_OTRB <= fpga_0_radio_bridge_slot_2_radio_RX_ADC_OTRB_pin;
  fpga_0_radio_bridge_slot_2_radio_RX_ADC_PWDNA_pin <= fpga_0_radio_bridge_slot_2_radio_RX_ADC_PWDNA;
  fpga_0_radio_bridge_slot_2_radio_RX_ADC_PWDNB_pin <= fpga_0_radio_bridge_slot_2_radio_RX_ADC_PWDNB;
  fpga_0_radio_bridge_slot_2_radio_RxEn_pin <= fpga_0_radio_bridge_slot_2_radio_RxEn;
  fpga_0_radio_bridge_slot_2_radio_RxHP_pin <= fpga_0_radio_bridge_slot_2_radio_RxHP;
  fpga_0_radio_bridge_slot_2_radio_SHDN_pin <= fpga_0_radio_bridge_slot_2_radio_SHDN;
  fpga_0_radio_bridge_slot_2_radio_spi_clk_pin <= fpga_0_radio_bridge_slot_2_radio_spi_clk;
  fpga_0_radio_bridge_slot_2_radio_spi_cs_pin <= fpga_0_radio_bridge_slot_2_radio_spi_cs;
  fpga_0_radio_bridge_slot_2_radio_spi_data_pin <= fpga_0_radio_bridge_slot_2_radio_spi_data;
  fpga_0_radio_bridge_slot_2_radio_TxEn_pin <= fpga_0_radio_bridge_slot_2_radio_TxEn;
  fpga_0_radio_bridge_slot_2_radio_B_pin <= fpga_0_radio_bridge_slot_2_radio_B;
  fpga_0_radio_bridge_slot_2_radio_DAC_I_pin <= fpga_0_radio_bridge_slot_2_radio_DAC_I;
  fpga_0_radio_bridge_slot_2_radio_DAC_Q_pin <= fpga_0_radio_bridge_slot_2_radio_DAC_Q;
  fpga_0_radio_bridge_slot_2_radio_ADC_I <= fpga_0_radio_bridge_slot_2_radio_ADC_I_pin;
  fpga_0_radio_bridge_slot_2_radio_ADC_Q <= fpga_0_radio_bridge_slot_2_radio_ADC_Q_pin;
  fpga_0_radio_bridge_slot_3_converter_clock_out_pin <= fpga_0_radio_bridge_slot_3_converter_clock_out;
  fpga_0_radio_bridge_slot_3_dac_spi_clk_pin <= fpga_0_radio_bridge_slot_3_dac_spi_clk;
  fpga_0_radio_bridge_slot_3_dac_spi_cs_pin <= fpga_0_radio_bridge_slot_3_dac_spi_cs;
  fpga_0_radio_bridge_slot_3_dac_spi_data_pin <= fpga_0_radio_bridge_slot_3_dac_spi_data;
  fpga_0_radio_bridge_slot_3_radio_24PA_pin <= fpga_0_radio_bridge_slot_3_radio_24PA;
  fpga_0_radio_bridge_slot_3_radio_5PA_pin <= fpga_0_radio_bridge_slot_3_radio_5PA;
  fpga_0_radio_bridge_slot_3_radio_ANTSW_pin <= fpga_0_radio_bridge_slot_3_radio_ANTSW;
  fpga_0_radio_bridge_slot_3_radio_dac_PLL_LOCK <= fpga_0_radio_bridge_slot_3_radio_dac_PLL_LOCK_pin;
  fpga_0_radio_bridge_slot_3_radio_dac_RESET_pin <= fpga_0_radio_bridge_slot_3_radio_dac_RESET;
  fpga_0_radio_bridge_slot_3_radio_DIPSW <= fpga_0_radio_bridge_slot_3_radio_DIPSW_pin;
  fpga_0_radio_bridge_slot_3_radio_LD <= fpga_0_radio_bridge_slot_3_radio_LD_pin;
  fpga_0_radio_bridge_slot_3_radio_LED_pin <= fpga_0_radio_bridge_slot_3_radio_LED;
  fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_clk_pin <= fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_clk;
  fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_CLAMP_pin <= fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_CLAMP;
  fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_D <= fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_D_pin;
  fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_HIZ_pin <= fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_HIZ;
  fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_OTR <= fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_OTR_pin;
  fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_SLEEP_pin <= fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_SLEEP;
  fpga_0_radio_bridge_slot_3_radio_RX_ADC_DCS_pin <= fpga_0_radio_bridge_slot_3_radio_RX_ADC_DCS;
  fpga_0_radio_bridge_slot_3_radio_RX_ADC_DFS_pin <= fpga_0_radio_bridge_slot_3_radio_RX_ADC_DFS;
  fpga_0_radio_bridge_slot_3_radio_RX_ADC_OTRA <= fpga_0_radio_bridge_slot_3_radio_RX_ADC_OTRA_pin;
  fpga_0_radio_bridge_slot_3_radio_RX_ADC_OTRB <= fpga_0_radio_bridge_slot_3_radio_RX_ADC_OTRB_pin;
  fpga_0_radio_bridge_slot_3_radio_RX_ADC_PWDNA_pin <= fpga_0_radio_bridge_slot_3_radio_RX_ADC_PWDNA;
  fpga_0_radio_bridge_slot_3_radio_RX_ADC_PWDNB_pin <= fpga_0_radio_bridge_slot_3_radio_RX_ADC_PWDNB;
  fpga_0_radio_bridge_slot_3_radio_RxEn_pin <= fpga_0_radio_bridge_slot_3_radio_RxEn;
  fpga_0_radio_bridge_slot_3_radio_RxHP_pin <= fpga_0_radio_bridge_slot_3_radio_RxHP;
  fpga_0_radio_bridge_slot_3_radio_SHDN_pin <= fpga_0_radio_bridge_slot_3_radio_SHDN;
  fpga_0_radio_bridge_slot_3_radio_spi_clk_pin <= fpga_0_radio_bridge_slot_3_radio_spi_clk;
  fpga_0_radio_bridge_slot_3_radio_spi_cs_pin <= fpga_0_radio_bridge_slot_3_radio_spi_cs;
  fpga_0_radio_bridge_slot_3_radio_spi_data_pin <= fpga_0_radio_bridge_slot_3_radio_spi_data;
  fpga_0_radio_bridge_slot_3_radio_TxEn_pin <= fpga_0_radio_bridge_slot_3_radio_TxEn;
  fpga_0_radio_bridge_slot_3_radio_B_pin <= fpga_0_radio_bridge_slot_3_radio_B;
  fpga_0_radio_bridge_slot_3_radio_DAC_I_pin <= fpga_0_radio_bridge_slot_3_radio_DAC_I;
  fpga_0_radio_bridge_slot_3_radio_DAC_Q_pin <= fpga_0_radio_bridge_slot_3_radio_DAC_Q;
  fpga_0_radio_bridge_slot_3_radio_ADC_I <= fpga_0_radio_bridge_slot_3_radio_ADC_I_pin;
  fpga_0_radio_bridge_slot_3_radio_ADC_Q <= fpga_0_radio_bridge_slot_3_radio_ADC_Q_pin;
  fpga_0_analog_bridge_slot_4_clock_out_pin <= fpga_0_analog_bridge_slot_4_clock_out;
  fpga_0_analog_bridge_slot_4_analog_DAC1_A_pin <= fpga_0_analog_bridge_slot_4_analog_DAC1_A;
  fpga_0_analog_bridge_slot_4_analog_DAC1_B_pin <= fpga_0_analog_bridge_slot_4_analog_DAC1_B;
  fpga_0_analog_bridge_slot_4_analog_DAC2_A_pin <= fpga_0_analog_bridge_slot_4_analog_DAC2_A;
  fpga_0_analog_bridge_slot_4_analog_DAC2_B_pin <= fpga_0_analog_bridge_slot_4_analog_DAC2_B;
  fpga_0_analog_bridge_slot_4_analog_DAC1_sleep_pin <= fpga_0_analog_bridge_slot_4_analog_DAC1_sleep;
  fpga_0_analog_bridge_slot_4_analog_DAC2_sleep_pin <= fpga_0_analog_bridge_slot_4_analog_DAC2_sleep;
  fpga_0_analog_bridge_slot_4_analog_ADC_A <= fpga_0_analog_bridge_slot_4_analog_ADC_A_pin;
  fpga_0_analog_bridge_slot_4_analog_ADC_B <= fpga_0_analog_bridge_slot_4_analog_ADC_B_pin;
  fpga_0_analog_bridge_slot_4_analog_ADC_DFS_pin <= fpga_0_analog_bridge_slot_4_analog_ADC_DFS;
  fpga_0_analog_bridge_slot_4_analog_ADC_DCS_pin <= fpga_0_analog_bridge_slot_4_analog_ADC_DCS;
  fpga_0_analog_bridge_slot_4_analog_ADC_pdwnA_pin <= fpga_0_analog_bridge_slot_4_analog_ADC_pdwnA;
  fpga_0_analog_bridge_slot_4_analog_ADC_pdwnB_pin <= fpga_0_analog_bridge_slot_4_analog_ADC_pdwnB;
  fpga_0_analog_bridge_slot_4_analog_ADC_otrA <= fpga_0_analog_bridge_slot_4_analog_ADC_otrA_pin;
  fpga_0_analog_bridge_slot_4_analog_ADC_otrB <= fpga_0_analog_bridge_slot_4_analog_ADC_otrB_pin;
  fpga_0_analog_bridge_slot_4_analog_LED_pin <= fpga_0_analog_bridge_slot_4_analog_LED;
  fpga_0_LED_7SEGMENT_GPIO_d_out_pin <= fpga_0_LED_7SEGMENT_GPIO_d_out;
  fpga_0_LED_7SEGMENT_1_GPIO_d_out_pin <= fpga_0_LED_7SEGMENT_1_GPIO_d_out;
  fpga_0_LEDs_4Bit_GPIO_d_out_pin <= fpga_0_LEDs_4Bit_GPIO_d_out;
  fpga_0_Push_Buttons_4bit_GPIO_in <= fpga_0_Push_Buttons_4bit_GPIO_in_pin;
  fpga_0_rs232_RX <= fpga_0_rs232_RX_pin;
  fpga_0_rs232_TX_pin <= fpga_0_rs232_TX;
  fpga_0_Ethernet_MAC_PHY_rst_n_pin <= fpga_0_Ethernet_MAC_PHY_rst_n;
  fpga_0_Ethernet_MAC_PHY_crs <= fpga_0_Ethernet_MAC_PHY_crs_pin;
  fpga_0_Ethernet_MAC_PHY_col <= fpga_0_Ethernet_MAC_PHY_col_pin;
  fpga_0_Ethernet_MAC_PHY_tx_data_pin <= fpga_0_Ethernet_MAC_PHY_tx_data;
  fpga_0_Ethernet_MAC_PHY_tx_en_pin <= fpga_0_Ethernet_MAC_PHY_tx_en;
  fpga_0_Ethernet_MAC_PHY_tx_clk <= fpga_0_Ethernet_MAC_PHY_tx_clk_pin;
  fpga_0_Ethernet_MAC_PHY_tx_er_pin <= fpga_0_Ethernet_MAC_PHY_tx_er;
  fpga_0_Ethernet_MAC_PHY_rx_er <= fpga_0_Ethernet_MAC_PHY_rx_er_pin;
  fpga_0_Ethernet_MAC_PHY_rx_clk <= fpga_0_Ethernet_MAC_PHY_rx_clk_pin;
  fpga_0_Ethernet_MAC_PHY_dv <= fpga_0_Ethernet_MAC_PHY_dv_pin;
  fpga_0_Ethernet_MAC_PHY_rx_data <= fpga_0_Ethernet_MAC_PHY_rx_data_pin;
  fpga_0_DIPSWs_4Bit_GPIO_in <= fpga_0_DIPSWs_4Bit_GPIO_in_pin;
  fpga_0_SRAM0_ZBT_512Kx32_Mem_OEN_pin(0 to 0) <= fpga_0_SRAM0_ZBT_512Kx32_Mem_OEN(0 to 0);
  fpga_0_SRAM0_ZBT_512Kx32_Mem_ADV_LDN_pin <= fpga_0_SRAM0_ZBT_512Kx32_Mem_ADV_LDN;
  fpga_0_SRAM0_ZBT_512Kx32_Mem_CKEN_pin <= fpga_0_SRAM0_ZBT_512Kx32_Mem_CKEN;
  fpga_0_SRAM0_ZBT_512Kx32_Mem_CE_pin <= fpga_0_SRAM0_ZBT_512Kx32_Mem_CE(0);
  fpga_0_SRAM0_ZBT_512Kx32_Mem_BEN_pin <= fpga_0_SRAM0_ZBT_512Kx32_Mem_BEN;
  fpga_0_SRAM0_ZBT_512Kx32_Mem_WEN_pin <= fpga_0_SRAM0_ZBT_512Kx32_Mem_WEN;
  fpga_0_SRAM0_ZBT_512Kx32_Mem_A_pin <= fpga_0_SRAM0_ZBT_512Kx32_Mem_A;
  fpga_0_SRAM1_ZBT_512Kx32_Mem_OEN_pin(0 to 0) <= fpga_0_SRAM1_ZBT_512Kx32_Mem_OEN(0 to 0);
  fpga_0_SRAM1_ZBT_512Kx32_Mem_ADV_LDN_pin <= fpga_0_SRAM1_ZBT_512Kx32_Mem_ADV_LDN;
  fpga_0_SRAM1_ZBT_512Kx32_Mem_CKEN_pin <= fpga_0_SRAM1_ZBT_512Kx32_Mem_CKEN;
  fpga_0_SRAM1_ZBT_512Kx32_Mem_BEN_pin <= fpga_0_SRAM1_ZBT_512Kx32_Mem_BEN;
  fpga_0_SRAM1_ZBT_512Kx32_Mem_WEN_pin <= fpga_0_SRAM1_ZBT_512Kx32_Mem_WEN;
  fpga_0_SRAM1_ZBT_512Kx32_Mem_CE_pin <= fpga_0_SRAM1_ZBT_512Kx32_Mem_CE(0);
  fpga_0_SRAM1_ZBT_512Kx32_Mem_A_pin <= fpga_0_SRAM1_ZBT_512Kx32_Mem_A;
  fpga_0_SRAM0_CLOCK <= sys_clk_s;
  fpga_0_SRAM1_CLOCK <= sys_clk_s;
  dcm_clk_s <= sys_clk_pin;
  sys_rst_s <= sys_rst_pin;
  debug_chipscopetrig <= debug_chipscopetrig_pin;
  debug_GPIO_d_out_pin <= fpga_0_debug_GPIO_d_out;
  user_io_board_controller_opbw_0_cs_pin <= user_io_board_controller_opbw_0_cs;
  user_io_board_controller_opbw_0_resetlcd_pin <= user_io_board_controller_opbw_0_resetlcd;
  user_io_board_controller_opbw_0_scl_pin <= user_io_board_controller_opbw_0_scl;
  user_io_board_controller_opbw_0_sdi_pin <= user_io_board_controller_opbw_0_sdi;
  plb_PLB2OPB_rearb(1 to 1) <= B"0";
  plb_PLB2OPB_rearb(2 to 2) <= B"0";
  plb_PLB2OPB_rearb(3 to 3) <= B"0";
  plb_PLB2OPB_rearb(4 to 4) <= B"0";
  plb_PLB2OPB_rearb(5 to 5) <= B"0";
  pgassign1(6) <= Push_Buttons_4bit_IP2INTC_Irpt;
  pgassign1(5) <= rx_int_badpkt;
  pgassign1(4) <= Ethernet_MAC_IP2INTC_Irpt;
  pgassign1(3) <= tx_int_pktdone;
  pgassign1(2) <= rx_int_goodpkt;
  pgassign1(1) <= rx_int_goodheader;
  pgassign1(0) <= ofdm_timer_opbw_0_timerexpire;
  pgassign2(0) <= radio2_txStart;
  pgassign2(1) <= radio3_txStart;
  pgassign3(0) <= debug_tx_pktrunning;
  pgassign3(1) <= debug_rx_payload;
  pgassign3(2) <= rssi_pkt_detect_opbw_0_rssi_pkt_det_out;
  pgassign3(3) <= rx_int_goodpkt;
  pgassign3(4) <= rx_int_badpkt;
  pgassign3(5) <= rx_pktdetreset;
  pgassign3(6) <= debug_rx_pktdone;
  pgassign3(7) <= rx_int_goodheader;
  pgassign3(8) <= ofdm_pktDetector_mimo_opbw_0_debugbusy;
  pgassign3(9) <= ofdm_pktDetector_mimo_opbw_0_debugidledifs;
  debug <= pgassign3;
  net_gnd0 <= '0';
  net_gnd1(0 to 0) <= B"0";
  net_gnd10(0 to 9) <= B"0000000000";
  net_gnd15(0 to 14) <= B"000000000000000";
  net_gnd2(0 to 1) <= B"00";
  net_gnd3(0 to 2) <= B"000";
  net_gnd32(0 to 31) <= B"00000000000000000000000000000000";
  net_gnd4(0 to 3) <= B"0000";
  net_gnd64(0 to 63) <= B"0000000000000000000000000000000000000000000000000000000000000000";
  net_gnd7(0 to 6) <= B"0000000";
  net_gnd8(0 to 7) <= B"00000000";
  net_vcc0 <= '1';
  fpga_0_Ethernet_MAC_slew1_pin <= net_vcc0;
  fpga_0_Ethernet_MAC_slew2_pin <= net_vcc0;
  net_vcc1(0 to 0) <= B"1";
  net_vcc15(0 to 14) <= B"111111111111111";

  ppc405_0 : ppc405_0_wrapper
    port map (
      C405CPMCORESLEEPREQ => open,
      C405CPMMSRCE => open,
      C405CPMMSREE => open,
      C405CPMTIMERIRQ => open,
      C405CPMTIMERRESETREQ => open,
      C405XXXMACHINECHECK => open,
      CPMC405CLOCK => proc_clk_s,
      CPMC405CORECLKINACTIVE => net_gnd0,
      CPMC405CPUCLKEN => net_vcc0,
      CPMC405JTAGCLKEN => net_vcc0,
      CPMC405TIMERCLKEN => net_vcc0,
      CPMC405TIMERTICK => net_vcc0,
      MCBCPUCLKEN => net_vcc0,
      MCBTIMEREN => net_vcc0,
      MCPPCRST => net_vcc0,
      PLBCLK => sys_clk_s,
      DCRCLK => net_gnd0,
      C405RSTCHIPRESETREQ => C405RSTCHIPRESETREQ,
      C405RSTCORERESETREQ => C405RSTCORERESETREQ,
      C405RSTSYSRESETREQ => C405RSTSYSRESETREQ,
      RSTC405RESETCHIP => RSTC405RESETCHIP,
      RSTC405RESETCORE => RSTC405RESETCORE,
      RSTC405RESETSYS => RSTC405RESETSYS,
      C405PLBICUABUS => plb_M_ABus(32 to 63),
      C405PLBICUBE => plb_M_BE(8 to 15),
      C405PLBICURNW => plb_M_RNW(1),
      C405PLBICUABORT => plb_M_abort(1),
      C405PLBICUBUSLOCK => plb_M_busLock(1),
      C405PLBICUU0ATTR => plb_M_compress(1),
      C405PLBICUGUARDED => plb_M_guarded(1),
      C405PLBICULOCKERR => plb_M_lockErr(1),
      C405PLBICUMSIZE => plb_M_MSize(2 to 3),
      C405PLBICUORDERED => plb_M_ordered(1),
      C405PLBICUPRIORITY => plb_M_priority(2 to 3),
      C405PLBICURDBURST => plb_M_rdBurst(1),
      C405PLBICUREQUEST => plb_M_request(1),
      C405PLBICUSIZE => plb_M_size(4 to 7),
      C405PLBICUTYPE => plb_M_type(3 to 5),
      C405PLBICUWRBURST => plb_M_wrBurst(1),
      C405PLBICUWRDBUS => plb_M_wrDBus(64 to 127),
      C405PLBICUCACHEABLE => open,
      PLBC405ICUADDRACK => plb_PLB_MAddrAck(1),
      PLBC405ICUBUSY => plb_PLB_MBusy(1),
      PLBC405ICUERR => plb_PLB_MErr(1),
      PLBC405ICURDBTERM => plb_PLB_MRdBTerm(1),
      PLBC405ICURDDACK => plb_PLB_MRdDAck(1),
      PLBC405ICURDDBUS => plb_PLB_MRdDBus(64 to 127),
      PLBC405ICURDWDADDR => plb_PLB_MRdWdAddr(4 to 7),
      PLBC405ICUREARBITRATE => plb_PLB_MRearbitrate(1),
      PLBC405ICUWRBTERM => plb_PLB_MWrBTerm(1),
      PLBC405ICUWRDACK => plb_PLB_MWrDAck(1),
      PLBC405ICUSSIZE => plb_PLB_MSSize(2 to 3),
      PLBC405ICUSERR => plb_PLB_SMErr(1),
      PLBC405ICUSBUSYS => plb_PLB_SMBusy(1),
      C405PLBDCUABUS => plb_M_ABus(0 to 31),
      C405PLBDCUBE => plb_M_BE(0 to 7),
      C405PLBDCURNW => plb_M_RNW(0),
      C405PLBDCUABORT => plb_M_abort(0),
      C405PLBDCUBUSLOCK => plb_M_busLock(0),
      C405PLBDCUU0ATTR => plb_M_compress(0),
      C405PLBDCUGUARDED => plb_M_guarded(0),
      C405PLBDCULOCKERR => plb_M_lockErr(0),
      C405PLBDCUMSIZE => plb_M_MSize(0 to 1),
      C405PLBDCUORDERED => plb_M_ordered(0),
      C405PLBDCUPRIORITY => plb_M_priority(0 to 1),
      C405PLBDCURDBURST => plb_M_rdBurst(0),
      C405PLBDCUREQUEST => plb_M_request(0),
      C405PLBDCUSIZE => plb_M_size(0 to 3),
      C405PLBDCUTYPE => plb_M_type(0 to 2),
      C405PLBDCUWRBURST => plb_M_wrBurst(0),
      C405PLBDCUWRDBUS => plb_M_wrDBus(0 to 63),
      C405PLBDCUCACHEABLE => open,
      C405PLBDCUWRITETHRU => open,
      PLBC405DCUADDRACK => plb_PLB_MAddrAck(0),
      PLBC405DCUBUSY => plb_PLB_MBusy(0),
      PLBC405DCUERR => plb_PLB_MErr(0),
      PLBC405DCURDBTERM => plb_PLB_MRdBTerm(0),
      PLBC405DCURDDACK => plb_PLB_MRdDAck(0),
      PLBC405DCURDDBUS => plb_PLB_MRdDBus(0 to 63),
      PLBC405DCURDWDADDR => plb_PLB_MRdWdAddr(0 to 3),
      PLBC405DCUREARBITRATE => plb_PLB_MRearbitrate(0),
      PLBC405DCUWRBTERM => plb_PLB_MWrBTerm(0),
      PLBC405DCUWRDACK => plb_PLB_MWrDAck(0),
      PLBC405DCUSSIZE => plb_PLB_MSSize(0 to 1),
      PLBC405DCUSERR => plb_PLB_SMErr(0),
      PLBC405DCUSBUSYS => plb_PLB_SMBusy(0),
      BRAMDSOCMCLK => sys_clk_s,
      BRAMDSOCMRDDBUS => docm_BRAMDSOCMRDDBUS,
      DSARCVALUE => docm_DSARCVALUE,
      DSCNTLVALUE => docm_DSCNTLVALUE,
      DSOCMBRAMABUS => docm_M_DSOCMBRAMABUS,
      DSOCMBRAMBYTEWRITE => docm_M_DSOCMBRAMBYTEWRITE,
      DSOCMBRAMEN => docm_M_DSOCMBRAMEN,
      DSOCMBRAMWRDBUS => docm_M_DSOCMBRAMWRDBUS,
      DSOCMBUSY => docm_M_DSOCMBUSY,
      BRAMISOCMCLK => sys_clk_s,
      BRAMISOCMRDDBUS => iocm_BRAMISOCMRDDBUS,
      ISARCVALUE => iocm_ISARCVALUE,
      ISCNTLVALUE => iocm_ISCNTLVALUE,
      ISOCMBRAMEN => iocm_M_ISOCMBRAMEN,
      ISOCMBRAMEVENWRITEEN => iocm_M_ISOCMBRAMEVENWRITEEN,
      ISOCMBRAMODDWRITEEN => iocm_M_ISOCMBRAMODDWRITEEN,
      ISOCMBRAMRDABUS => iocm_M_ISOCMBRAMRDABUS,
      ISOCMBRAMWRABUS => iocm_M_ISOCMBRAMWRABUS,
      ISOCMBRAMWRDBUS => iocm_M_ISOCMBRAMWRDBUS,
      C405DCRABUS => open,
      C405DCRDBUSOUT => open,
      C405DCRREAD => open,
      C405DCRWRITE => open,
      DCRC405ACK => net_gnd0,
      DCRC405DBUSIN => net_gnd32,
      EICC405CRITINPUTIRQ => net_gnd0,
      EICC405EXTINPUTIRQ => EICC405EXTINPUTIRQ,
      C405JTGCAPTUREDR => open,
      C405JTGEXTEST => open,
      C405JTGPGMOUT => open,
      C405JTGSHIFTDR => open,
      C405JTGTDO => jtagppc_0_0_C405JTGTDO,
      C405JTGTDOEN => jtagppc_0_0_C405JTGTDOEN,
      C405JTGUPDATEDR => open,
      MCBJTAGEN => net_vcc0,
      JTGC405BNDSCANTDO => net_gnd0,
      JTGC405TCK => jtagppc_0_0_JTGC405TCK,
      JTGC405TDI => jtagppc_0_0_JTGC405TDI,
      JTGC405TMS => jtagppc_0_0_JTGC405TMS,
      JTGC405TRSTNEG => jtagppc_0_0_JTGC405TRSTNEG,
      C405DBGMSRWE => open,
      C405DBGSTOPACK => open,
      C405DBGWBCOMPLETE => open,
      C405DBGWBFULL => open,
      C405DBGWBIAR => open,
      DBGC405DEBUGHALT => net_gnd0,
      DBGC405EXTBUSHOLDACK => net_gnd0,
      DBGC405UNCONDDEBUGEVENT => net_gnd0,
      C405TRCCYCLE => open,
      C405TRCEVENEXECUTIONSTATUS => open,
      C405TRCODDEXECUTIONSTATUS => open,
      C405TRCTRACESTATUS => open,
      C405TRCTRIGGEREVENTOUT => open,
      C405TRCTRIGGEREVENTTYPE => open,
      TRCC405TRACEDISABLE => net_gnd0,
      TRCC405TRIGGEREVENTIN => net_gnd0
    );

  ppc405_1 : ppc405_1_wrapper
    port map (
      C405CPMCORESLEEPREQ => open,
      C405CPMMSRCE => open,
      C405CPMMSREE => open,
      C405CPMTIMERIRQ => open,
      C405CPMTIMERRESETREQ => open,
      C405XXXMACHINECHECK => open,
      CPMC405CLOCK => net_gnd0,
      CPMC405CORECLKINACTIVE => net_gnd0,
      CPMC405CPUCLKEN => net_vcc0,
      CPMC405JTAGCLKEN => net_vcc0,
      CPMC405TIMERCLKEN => net_vcc0,
      CPMC405TIMERTICK => net_vcc0,
      MCBCPUCLKEN => net_vcc0,
      MCBTIMEREN => net_vcc0,
      MCPPCRST => net_vcc0,
      PLBCLK => net_gnd0,
      DCRCLK => net_gnd0,
      C405RSTCHIPRESETREQ => open,
      C405RSTCORERESETREQ => open,
      C405RSTSYSRESETREQ => open,
      RSTC405RESETCHIP => net_gnd0,
      RSTC405RESETCORE => net_gnd0,
      RSTC405RESETSYS => net_gnd0,
      C405PLBICUABUS => open,
      C405PLBICUBE => open,
      C405PLBICURNW => open,
      C405PLBICUABORT => open,
      C405PLBICUBUSLOCK => open,
      C405PLBICUU0ATTR => open,
      C405PLBICUGUARDED => open,
      C405PLBICULOCKERR => open,
      C405PLBICUMSIZE => open,
      C405PLBICUORDERED => open,
      C405PLBICUPRIORITY => open,
      C405PLBICURDBURST => open,
      C405PLBICUREQUEST => open,
      C405PLBICUSIZE => open,
      C405PLBICUTYPE => open,
      C405PLBICUWRBURST => open,
      C405PLBICUWRDBUS => open,
      C405PLBICUCACHEABLE => open,
      PLBC405ICUADDRACK => net_gnd0,
      PLBC405ICUBUSY => net_gnd0,
      PLBC405ICUERR => net_gnd0,
      PLBC405ICURDBTERM => net_gnd0,
      PLBC405ICURDDACK => net_gnd0,
      PLBC405ICURDDBUS => net_gnd64,
      PLBC405ICURDWDADDR => net_gnd4,
      PLBC405ICUREARBITRATE => net_gnd0,
      PLBC405ICUWRBTERM => net_gnd0,
      PLBC405ICUWRDACK => net_gnd0,
      PLBC405ICUSSIZE => net_gnd2,
      PLBC405ICUSERR => net_gnd0,
      PLBC405ICUSBUSYS => net_gnd0,
      C405PLBDCUABUS => open,
      C405PLBDCUBE => open,
      C405PLBDCURNW => open,
      C405PLBDCUABORT => open,
      C405PLBDCUBUSLOCK => open,
      C405PLBDCUU0ATTR => open,
      C405PLBDCUGUARDED => open,
      C405PLBDCULOCKERR => open,
      C405PLBDCUMSIZE => open,
      C405PLBDCUORDERED => open,
      C405PLBDCUPRIORITY => open,
      C405PLBDCURDBURST => open,
      C405PLBDCUREQUEST => open,
      C405PLBDCUSIZE => open,
      C405PLBDCUTYPE => open,
      C405PLBDCUWRBURST => open,
      C405PLBDCUWRDBUS => open,
      C405PLBDCUCACHEABLE => open,
      C405PLBDCUWRITETHRU => open,
      PLBC405DCUADDRACK => net_gnd0,
      PLBC405DCUBUSY => net_gnd0,
      PLBC405DCUERR => net_gnd0,
      PLBC405DCURDBTERM => net_gnd0,
      PLBC405DCURDDACK => net_gnd0,
      PLBC405DCURDDBUS => net_gnd64,
      PLBC405DCURDWDADDR => net_gnd4,
      PLBC405DCUREARBITRATE => net_gnd0,
      PLBC405DCUWRBTERM => net_gnd0,
      PLBC405DCUWRDACK => net_gnd0,
      PLBC405DCUSSIZE => net_gnd2,
      PLBC405DCUSERR => net_gnd0,
      PLBC405DCUSBUSYS => net_gnd0,
      BRAMDSOCMCLK => net_gnd0,
      BRAMDSOCMRDDBUS => net_gnd32,
      DSARCVALUE => net_gnd8,
      DSCNTLVALUE => net_gnd8,
      DSOCMBRAMABUS => open,
      DSOCMBRAMBYTEWRITE => open,
      DSOCMBRAMEN => open,
      DSOCMBRAMWRDBUS => open,
      DSOCMBUSY => open,
      BRAMISOCMCLK => net_gnd0,
      BRAMISOCMRDDBUS => net_gnd64,
      ISARCVALUE => net_gnd8,
      ISCNTLVALUE => net_gnd8,
      ISOCMBRAMEN => open,
      ISOCMBRAMEVENWRITEEN => open,
      ISOCMBRAMODDWRITEEN => open,
      ISOCMBRAMRDABUS => open,
      ISOCMBRAMWRABUS => open,
      ISOCMBRAMWRDBUS => open,
      C405DCRABUS => open,
      C405DCRDBUSOUT => open,
      C405DCRREAD => open,
      C405DCRWRITE => open,
      DCRC405ACK => net_gnd0,
      DCRC405DBUSIN => net_gnd32,
      EICC405CRITINPUTIRQ => net_gnd0,
      EICC405EXTINPUTIRQ => net_gnd0,
      C405JTGCAPTUREDR => open,
      C405JTGEXTEST => open,
      C405JTGPGMOUT => open,
      C405JTGSHIFTDR => open,
      C405JTGTDO => jtagppc_0_1_C405JTGTDO,
      C405JTGTDOEN => jtagppc_0_1_C405JTGTDOEN,
      C405JTGUPDATEDR => open,
      MCBJTAGEN => net_vcc0,
      JTGC405BNDSCANTDO => net_gnd0,
      JTGC405TCK => jtagppc_0_1_JTGC405TCK,
      JTGC405TDI => jtagppc_0_1_JTGC405TDI,
      JTGC405TMS => jtagppc_0_1_JTGC405TMS,
      JTGC405TRSTNEG => jtagppc_0_1_JTGC405TRSTNEG,
      C405DBGMSRWE => open,
      C405DBGSTOPACK => open,
      C405DBGWBCOMPLETE => open,
      C405DBGWBFULL => open,
      C405DBGWBIAR => open,
      DBGC405DEBUGHALT => net_gnd0,
      DBGC405EXTBUSHOLDACK => net_gnd0,
      DBGC405UNCONDDEBUGEVENT => net_gnd0,
      C405TRCCYCLE => open,
      C405TRCEVENEXECUTIONSTATUS => open,
      C405TRCODDEXECUTIONSTATUS => open,
      C405TRCTRACESTATUS => open,
      C405TRCTRIGGEREVENTOUT => open,
      C405TRCTRIGGEREVENTTYPE => open,
      TRCC405TRACEDISABLE => net_gnd0,
      TRCC405TRIGGEREVENTIN => net_gnd0
    );

  jtagppc_0 : jtagppc_0_wrapper
    port map (
      TRSTNEG => net_vcc0,
      HALTNEG0 => net_vcc0,
      DBGC405DEBUGHALT0 => open,
      HALTNEG1 => net_vcc0,
      DBGC405DEBUGHALT1 => open,
      C405JTGTDO0 => jtagppc_0_0_C405JTGTDO,
      C405JTGTDOEN0 => jtagppc_0_0_C405JTGTDOEN,
      JTGC405TCK0 => jtagppc_0_0_JTGC405TCK,
      JTGC405TDI0 => jtagppc_0_0_JTGC405TDI,
      JTGC405TMS0 => jtagppc_0_0_JTGC405TMS,
      JTGC405TRSTNEG0 => jtagppc_0_0_JTGC405TRSTNEG,
      C405JTGTDO1 => jtagppc_0_1_C405JTGTDO,
      C405JTGTDOEN1 => jtagppc_0_1_C405JTGTDOEN,
      JTGC405TCK1 => jtagppc_0_1_JTGC405TCK,
      JTGC405TDI1 => jtagppc_0_1_JTGC405TDI,
      JTGC405TMS1 => jtagppc_0_1_JTGC405TMS,
      JTGC405TRSTNEG1 => jtagppc_0_1_JTGC405TRSTNEG
    );

  reset_block : reset_block_wrapper
    port map (
      Slowest_sync_clk => sys_clk_OPB,
      Ext_Reset_In => sys_rst_s,
      Aux_Reset_In => net_gnd0,
      Core_Reset_Req => C405RSTCORERESETREQ,
      Chip_Reset_Req => C405RSTCHIPRESETREQ,
      System_Reset_Req => C405RSTSYSRESETREQ,
      Dcm_locked => dcm_0_lock,
      Rstc405resetcore => RSTC405RESETCORE,
      Rstc405resetchip => RSTC405RESETCHIP,
      Rstc405resetsys => RSTC405RESETSYS,
      Bus_Struct_Reset => sys_bus_reset(0 to 0),
      Peripheral_Reset => pcoreReset(0 to 0)
    );

  iocm : iocm_wrapper
    port map (
      ISOCM_Clk => sys_clk_s,
      SYS_Rst => sys_bus_reset(0),
      ISOCM_Rst => iocm_ISOCM_Rst,
      M_ISOCMBRAMRDABUS => iocm_M_ISOCMBRAMRDABUS,
      M_ISOCMBRAMWRABUS => iocm_M_ISOCMBRAMWRABUS,
      M_ISOCMBRAMEN => iocm_M_ISOCMBRAMEN,
      M_ISOCMBRAMWRDBUS => iocm_M_ISOCMBRAMWRDBUS,
      M_ISOCMBRAMODDWRITEEN => iocm_M_ISOCMBRAMODDWRITEEN,
      M_ISOCMBRAMEVENWRITEEN => iocm_M_ISOCMBRAMEVENWRITEEN,
      M_ISOCMDCRBRAMODDEN => net_gnd0,
      M_ISOCMDCRBRAMEVENEN => net_gnd0,
      M_ISOCMDCRBRAMRDSELECT => net_gnd0,
      S_BRAMISOCMRDDBUS => iocm_S_BRAMISOCMRDDBUS,
      S_BRAMISOCMDCRRDDBUS => iocm_S_BRAMISOCMDCRRDDBUS,
      S_ISOCMSLAVESELECT => iocm_S_ISOCMSLAVESELECT(0 to 0),
      S_ISOCMDCRSLAVESELECT => iocm_S_ISOCMDCRSLAVESELECT(0 to 0),
      BRAMISOCMRDDBUS => iocm_BRAMISOCMRDDBUS,
      ISARCVALUE => iocm_ISARCVALUE,
      ISCNTLVALUE => iocm_ISCNTLVALUE,
      ISOCMBRAMEN => iocm_ISOCMBRAMEN,
      ISOCMBRAMWRDBUS => iocm_ISOCMBRAMWRDBUS,
      ISOCMBRAMODDWRITEEN => iocm_ISOCMBRAMODDWRITEEN,
      ISOCMBRAMEVENWRITEEN => iocm_ISOCMBRAMEVENWRITEEN,
      ISOCMBRAMRDABUS => iocm_ISOCMBRAMRDABUS,
      ISOCMBRAMWRABUS => iocm_ISOCMBRAMWRABUS,
      ISOCMDCRBRAMODDEN => iocm_ISOCMDCRBRAMODDEN,
      ISOCMDCRBRAMEVENEN => iocm_ISOCMDCRBRAMEVENEN,
      ISOCMDCRBRAMRDSELECT => iocm_ISOCMDCRBRAMRDSELECT,
      BRAMISOCMDCRRDDBUS => open
    );

  iocm_cntlr : iocm_cntlr_wrapper
    port map (
      BRAMISOCMCLK => sys_clk_s,
      ISBRAMRST => iocm_ISOCM_Rst,
      ISOCMBRAMRDABUS => iocm_ISOCMBRAMRDABUS,
      ISOCMBRAMWRABUS => iocm_ISOCMBRAMWRABUS,
      ISOCMBRAMEN => iocm_ISOCMBRAMEN,
      ISOCMBRAMWRDBUS => iocm_ISOCMBRAMWRDBUS,
      ISOCMBRAMODDWRITEEN => iocm_ISOCMBRAMODDWRITEEN,
      ISOCMBRAMEVENWRITEEN => iocm_ISOCMBRAMEVENWRITEEN,
      ISOCMDCRBRAMODDEN => iocm_ISOCMDCRBRAMODDEN,
      ISOCMDCRBRAMEVENEN => iocm_ISOCMDCRBRAMEVENEN,
      ISOCMDCRBRAMRDSELECT => iocm_ISOCMDCRBRAMRDSELECT,
      S_BRAMISOCMRDDBUS => iocm_S_BRAMISOCMRDDBUS,
      S_BRAMISOCMDCRRDDBUS => iocm_S_BRAMISOCMDCRRDDBUS,
      S_ISOCMSLAVESELECT => iocm_S_ISOCMSLAVESELECT(0),
      S_ISOCMDCRSLAVESELECT => iocm_S_ISOCMDCRSLAVESELECT(0),
      BRAM_Rst_A => isocm_porta_BRAM_Rst,
      BRAM_Clk_A => isocm_porta_BRAM_Clk,
      BRAM_Addr_A => isocm_porta_BRAM_Addr,
      BRAM_EN_A => isocm_porta_BRAM_EN,
      BRAM_WEN_A => isocm_porta_BRAM_WEN,
      BRAM_Dout_A => isocm_porta_BRAM_Dout,
      BRAM_Din_A => isocm_porta_BRAM_Din,
      BRAM_Rst_B => isocm_portb_BRAM_Rst,
      BRAM_Clk_B => isocm_portb_BRAM_Clk,
      BRAM_Addr_B => isocm_portb_BRAM_Addr,
      BRAM_EN_B => isocm_portb_BRAM_EN,
      BRAM_WEN_B => isocm_portb_BRAM_WEN,
      BRAM_Dout_B => isocm_portb_BRAM_Dout,
      BRAM_Din_B => isocm_portb_BRAM_Din
    );

  isocm_bram : isocm_bram_wrapper
    port map (
      BRAM_Rst_A => isocm_porta_BRAM_Rst,
      BRAM_Clk_A => isocm_porta_BRAM_Clk,
      BRAM_EN_A => isocm_porta_BRAM_EN,
      BRAM_WEN_A => isocm_porta_BRAM_WEN,
      BRAM_Addr_A => isocm_porta_BRAM_Addr,
      BRAM_Din_A => isocm_porta_BRAM_Din,
      BRAM_Dout_A => isocm_porta_BRAM_Dout,
      BRAM_Rst_B => isocm_portb_BRAM_Rst,
      BRAM_Clk_B => isocm_portb_BRAM_Clk,
      BRAM_EN_B => isocm_portb_BRAM_EN,
      BRAM_WEN_B => isocm_portb_BRAM_WEN,
      BRAM_Addr_B => isocm_portb_BRAM_Addr,
      BRAM_Din_B => isocm_portb_BRAM_Din,
      BRAM_Dout_B => isocm_portb_BRAM_Dout
    );

  docm : docm_wrapper
    port map (
      DSOCM_Clk => sys_clk_s,
      SYS_Rst => sys_bus_reset(0),
      DSOCM_Rst => docm_DSOCM_Rst,
      M_DSOCMBRAMABUS => docm_M_DSOCMBRAMABUS,
      M_DSOCMBRAMBYTEWRITE => docm_M_DSOCMBRAMBYTEWRITE,
      M_DSOCMBRAMEN => docm_M_DSOCMBRAMEN,
      M_DSOCMBRAMWRDBUS => docm_M_DSOCMBRAMWRDBUS,
      M_DSOCMBUSY => docm_M_DSOCMBUSY,
      M_DSOCMRDADDRVALID => net_gnd0,
      M_DSOCMWRADDRVALID => net_gnd0,
      S_BRAMDSOCMRDDBUS => docm_S_BRAMDSOCMRDDBUS,
      S_DSOCMRWCOMPLETE => docm_S_DSOCMRWCOMPLETE(0 to 0),
      S_DSOCMSLAVESELECT => docm_S_DSOCMSLAVESELECT(0 to 0),
      BRAMDSOCMRDDBUS => docm_BRAMDSOCMRDDBUS,
      DSARCVALUE => docm_DSARCVALUE,
      DSCNTLVALUE => docm_DSCNTLVALUE,
      DSOCMBRAMWRDBUS => docm_DSOCMBRAMWRDBUS,
      DSOCMBRAMEN => docm_DSOCMBRAMEN,
      DSOCMBRAMBYTEWRITE => docm_DSOCMBRAMBYTEWRITE,
      DSOCMBRAMABUS => docm_DSOCMBRAMABUS,
      DSOCMBUSY => open,
      DSOCMRDADDRVALID => open,
      DSOCMWRADDRVALID => open,
      DSOCMRWCOMPLETE => open
    );

  docm_cntlr : docm_cntlr_wrapper
    port map (
      BRAMDSOCMCLK => sys_clk_s,
      DSBRAMRST => docm_DSOCM_Rst,
      DSOCMBRAMABUS => docm_DSOCMBRAMABUS,
      DSOCMBRAMBYTEWRITE => docm_DSOCMBRAMBYTEWRITE,
      DSOCMBRAMEN => docm_DSOCMBRAMEN,
      DSOCMBRAMWRDBUS => docm_DSOCMBRAMWRDBUS,
      S_BRAMDSOCMRDDBUS => docm_S_BRAMDSOCMRDDBUS,
      S_DSOCMRWCOMPLETE => docm_S_DSOCMRWCOMPLETE(0),
      S_DSOCMSLAVESELECT => docm_S_DSOCMSLAVESELECT(0),
      BRAM_Rst_A => dsocm_porta_BRAM_Rst,
      BRAM_Clk_A => dsocm_porta_BRAM_Clk,
      BRAM_EN_A => dsocm_porta_BRAM_EN,
      BRAM_WEN_A => dsocm_porta_BRAM_WEN,
      BRAM_Addr_A => dsocm_porta_BRAM_Addr,
      BRAM_Din_A => dsocm_porta_BRAM_Din,
      BRAM_Dout_A => dsocm_porta_BRAM_Dout
    );

  dsocm_bram : dsocm_bram_wrapper
    port map (
      BRAM_Rst_A => dsocm_porta_BRAM_Rst,
      BRAM_Clk_A => dsocm_porta_BRAM_Clk,
      BRAM_EN_A => dsocm_porta_BRAM_EN,
      BRAM_WEN_A => dsocm_porta_BRAM_WEN,
      BRAM_Addr_A => dsocm_porta_BRAM_Addr,
      BRAM_Din_A => dsocm_porta_BRAM_Din,
      BRAM_Dout_A => dsocm_porta_BRAM_Dout,
      BRAM_Rst_B => net_gnd0,
      BRAM_Clk_B => net_gnd0,
      BRAM_EN_B => net_gnd0,
      BRAM_WEN_B => net_gnd4,
      BRAM_Addr_B => net_gnd32,
      BRAM_Din_B => open,
      BRAM_Dout_B => net_gnd32
    );

  plb : plb_wrapper
    port map (
      PLB_Clk => sys_clk_s,
      SYS_Rst => sys_bus_reset(0),
      PLB_Rst => plb_PLB_Rst,
      PLB_dcrAck => open,
      PLB_dcrDBus => open,
      DCR_ABus => net_gnd10,
      DCR_DBus => net_gnd32,
      DCR_Read => net_gnd0,
      DCR_Write => net_gnd0,
      M_ABus => plb_M_ABus,
      M_BE => plb_M_BE,
      M_RNW => plb_M_RNW,
      M_abort => plb_M_abort,
      M_busLock => plb_M_busLock,
      M_compress => plb_M_compress,
      M_guarded => plb_M_guarded,
      M_lockErr => plb_M_lockErr,
      M_MSize => plb_M_MSize,
      M_ordered => plb_M_ordered,
      M_priority => plb_M_priority,
      M_rdBurst => plb_M_rdBurst,
      M_request => plb_M_request,
      M_size => plb_M_size,
      M_type => plb_M_type,
      M_wrBurst => plb_M_wrBurst,
      M_wrDBus => plb_M_wrDBus,
      Sl_addrAck => plb_Sl_addrAck,
      Sl_MErr => plb_Sl_MErr,
      Sl_MBusy => plb_Sl_MBusy,
      Sl_rdBTerm => plb_Sl_rdBTerm,
      Sl_rdComp => plb_Sl_rdComp,
      Sl_rdDAck => plb_Sl_rdDAck,
      Sl_rdDBus => plb_Sl_rdDBus,
      Sl_rdWdAddr => plb_Sl_rdWdAddr,
      Sl_rearbitrate => plb_Sl_rearbitrate,
      Sl_SSize => plb_Sl_SSize,
      Sl_wait => plb_Sl_wait,
      Sl_wrBTerm => plb_Sl_wrBTerm,
      Sl_wrComp => plb_Sl_wrComp,
      Sl_wrDAck => plb_Sl_wrDAck,
      PLB_ABus => plb_PLB_ABus,
      PLB_BE => plb_PLB_BE,
      PLB_MAddrAck => plb_PLB_MAddrAck,
      PLB_MBusy => plb_PLB_MBusy,
      PLB_MErr => plb_PLB_MErr,
      PLB_MRdBTerm => plb_PLB_MRdBTerm,
      PLB_MRdDAck => plb_PLB_MRdDAck,
      PLB_MRdDBus => plb_PLB_MRdDBus,
      PLB_MRdWdAddr => plb_PLB_MRdWdAddr,
      PLB_MRearbitrate => plb_PLB_MRearbitrate,
      PLB_MWrBTerm => plb_PLB_MWrBTerm,
      PLB_MWrDAck => plb_PLB_MWrDAck,
      PLB_MSSize => plb_PLB_MSSize,
      PLB_PAValid => plb_PLB_PAValid,
      PLB_RNW => plb_PLB_RNW,
      PLB_SAValid => plb_PLB_SAValid,
      PLB_abort => plb_PLB_abort,
      PLB_busLock => plb_PLB_busLock,
      PLB_compress => plb_PLB_compress,
      PLB_guarded => plb_PLB_guarded,
      PLB_lockErr => plb_PLB_lockErr,
      PLB_masterID => plb_PLB_masterID,
      PLB_MSize => plb_PLB_MSize,
      PLB_ordered => plb_PLB_ordered,
      PLB_pendPri => plb_PLB_pendPri,
      PLB_pendReq => plb_PLB_pendReq,
      PLB_rdBurst => plb_PLB_rdBurst,
      PLB_rdPrim => plb_PLB_rdPrim,
      PLB_reqPri => plb_PLB_reqPri,
      PLB_size => plb_PLB_size,
      PLB_type => plb_PLB_type,
      PLB_wrBurst => plb_PLB_wrBurst,
      PLB_wrDBus => plb_PLB_wrDBus,
      PLB_wrPrim => plb_PLB_wrPrim,
      PLB_SaddrAck => open,
      PLB_SMErr => plb_PLB_SMErr,
      PLB_SMBusy => plb_PLB_SMBusy,
      PLB_SrdBTerm => open,
      PLB_SrdComp => open,
      PLB_SrdDAck => open,
      PLB_SrdDBus => open,
      PLB_SrdWdAddr => open,
      PLB_Srearbitrate => open,
      PLB_Sssize => open,
      PLB_Swait => open,
      PLB_SwrBTerm => open,
      PLB_SwrComp => open,
      PLB_SwrDAck => open,
      PLB2OPB_rearb => plb_PLB2OPB_rearb,
      ArbAddrVldReg => open,
      Bus_Error_Det => open
    );

  opb : opb_wrapper
    port map (
      OPB_Clk => sys_clk_OPB,
      OPB_Rst => opb_OPB_Rst,
      SYS_Rst => sys_bus_reset(0),
      Debug_SYS_Rst => net_gnd0,
      WDT_Rst => net_gnd0,
      M_ABus => opb_M_ABus,
      M_BE => opb_M_BE,
      M_beXfer => net_gnd1(0 to 0),
      M_busLock => opb_M_busLock(0 to 0),
      M_DBus => opb_M_DBus,
      M_DBusEn => net_gnd1(0 to 0),
      M_DBusEn32_63 => net_vcc1(0 to 0),
      M_dwXfer => net_gnd1(0 to 0),
      M_fwXfer => net_gnd1(0 to 0),
      M_hwXfer => net_gnd1(0 to 0),
      M_request => opb_M_request(0 to 0),
      M_RNW => opb_M_RNW(0 to 0),
      M_select => opb_M_select(0 to 0),
      M_seqAddr => opb_M_seqAddr(0 to 0),
      Sl_beAck => net_gnd15,
      Sl_DBus => opb_Sl_DBus,
      Sl_DBusEn => net_vcc15,
      Sl_DBusEn32_63 => net_vcc15,
      Sl_errAck => opb_Sl_errAck,
      Sl_dwAck => net_gnd15,
      Sl_fwAck => net_gnd15,
      Sl_hwAck => net_gnd15,
      Sl_retry => opb_Sl_retry,
      Sl_toutSup => opb_Sl_toutSup,
      Sl_xferAck => opb_Sl_xferAck,
      OPB_MRequest => open,
      OPB_ABus => opb_OPB_ABus,
      OPB_BE => opb_OPB_BE,
      OPB_beXfer => open,
      OPB_beAck => open,
      OPB_busLock => open,
      OPB_rdDBus => open,
      OPB_wrDBus => open,
      OPB_DBus => opb_OPB_DBus,
      OPB_errAck => opb_OPB_errAck,
      OPB_dwAck => open,
      OPB_dwXfer => open,
      OPB_fwAck => open,
      OPB_fwXfer => open,
      OPB_hwAck => open,
      OPB_hwXfer => open,
      OPB_MGrant => opb_OPB_MGrant(0 to 0),
      OPB_pendReq => open,
      OPB_retry => opb_OPB_retry,
      OPB_RNW => opb_OPB_RNW,
      OPB_select => opb_OPB_select,
      OPB_seqAddr => opb_OPB_seqAddr,
      OPB_timeout => opb_OPB_timeout,
      OPB_toutSup => open,
      OPB_xferAck => opb_OPB_xferAck
    );

  plb2opb : plb2opb_wrapper
    port map (
      PLB_Clk => sys_clk_s,
      OPB_Clk => sys_clk_OPB,
      PLB_Rst => plb_PLB_Rst,
      OPB_Rst => opb_OPB_Rst,
      Bus_Error_Det => open,
      BGI_Trans_Abort => open,
      BGO_dcrAck => open,
      BGO_dcrDBus => open,
      DCR_ABus => net_gnd10,
      DCR_DBus => net_gnd32,
      DCR_Read => net_gnd0,
      DCR_Write => net_gnd0,
      BGO_addrAck => plb_Sl_addrAck(0),
      BGO_MErr => plb_Sl_MErr(0 to 2),
      BGO_MBusy => plb_Sl_MBusy(0 to 2),
      BGO_rdBTerm => plb_Sl_rdBTerm(0),
      BGO_rdComp => plb_Sl_rdComp(0),
      BGO_rdDAck => plb_Sl_rdDAck(0),
      BGO_rdDBus => plb_Sl_rdDBus(0 to 63),
      BGO_rdWdAddr => plb_Sl_rdWdAddr(0 to 3),
      BGO_rearbitrate => plb_Sl_rearbitrate(0),
      BGO_SSize => plb_Sl_SSize(0 to 1),
      BGO_wait => plb_Sl_wait(0),
      BGO_wrBTerm => plb_Sl_wrBTerm(0),
      BGO_wrComp => plb_Sl_wrComp(0),
      BGO_wrDAck => plb_Sl_wrDAck(0),
      PLB_abort => plb_PLB_abort,
      PLB_ABus => plb_PLB_ABus,
      PLB_BE => plb_PLB_BE,
      PLB_busLock => plb_PLB_busLock,
      PLB_compress => plb_PLB_compress,
      PLB_guarded => plb_PLB_guarded,
      PLB_lockErr => plb_PLB_lockErr,
      PLB_masterID => plb_PLB_masterID,
      PLB_MSize => plb_PLB_MSize,
      PLB_ordered => plb_PLB_ordered,
      PLB_PAValid => plb_PLB_PAValid,
      PLB_rdBurst => plb_PLB_rdBurst,
      PLB_rdPrim => plb_PLB_rdPrim,
      PLB_RNW => plb_PLB_RNW,
      PLB_SAValid => plb_PLB_SAValid,
      PLB_size => plb_PLB_size,
      PLB_type => plb_PLB_type,
      PLB_wrBurst => plb_PLB_wrBurst,
      PLB_wrDBus => plb_PLB_wrDBus,
      PLB_wrPrim => plb_PLB_wrPrim,
      PLB2OPB_rearb => plb_PLB2OPB_rearb(0),
      BGO_ABus => opb_M_ABus,
      BGO_BE => opb_M_BE,
      BGO_busLock => opb_M_busLock(0),
      BGO_DBus => opb_M_DBus,
      BGO_request => opb_M_request(0),
      BGO_RNW => opb_M_RNW(0),
      BGO_select => opb_M_select(0),
      BGO_seqAddr => opb_M_seqAddr(0),
      OPB_DBus => opb_OPB_DBus,
      OPB_errAck => opb_OPB_errAck,
      OPB_MnGrant => opb_OPB_MGrant(0),
      OPB_retry => opb_OPB_retry,
      OPB_timeout => opb_OPB_timeout,
      OPB_xferAck => opb_OPB_xferAck
    );

  led_7segment : led_7segment_wrapper
    port map (
      OPB_ABus => opb_OPB_ABus,
      OPB_BE => opb_OPB_BE,
      OPB_Clk => sys_clk_OPB,
      OPB_DBus => opb_OPB_DBus,
      OPB_RNW => opb_OPB_RNW,
      OPB_Rst => opb_OPB_Rst,
      OPB_select => opb_OPB_select,
      OPB_seqAddr => opb_OPB_seqAddr,
      Sln_DBus => opb_Sl_DBus(0 to 31),
      Sln_errAck => opb_Sl_errAck(0),
      Sln_retry => opb_Sl_retry(0),
      Sln_toutSup => opb_Sl_toutSup(0),
      Sln_xferAck => opb_Sl_xferAck(0),
      IP2INTC_Irpt => open,
      GPIO_in => net_gnd7,
      GPIO_d_out => fpga_0_LED_7SEGMENT_GPIO_d_out,
      GPIO_t_out => open,
      GPIO2_in => net_gnd7,
      GPIO2_d_out => open,
      GPIO2_t_out => open,
      GPIO_IO_I => net_gnd7,
      GPIO_IO_O => open,
      GPIO_IO_T => open,
      GPIO2_IO_I => net_gnd7,
      GPIO2_IO_O => open,
      GPIO2_IO_T => open
    );

  led_7segment_1 : led_7segment_1_wrapper
    port map (
      OPB_ABus => opb_OPB_ABus,
      OPB_BE => opb_OPB_BE,
      OPB_Clk => sys_clk_OPB,
      OPB_DBus => opb_OPB_DBus,
      OPB_RNW => opb_OPB_RNW,
      OPB_Rst => opb_OPB_Rst,
      OPB_select => opb_OPB_select,
      OPB_seqAddr => opb_OPB_seqAddr,
      Sln_DBus => opb_Sl_DBus(32 to 63),
      Sln_errAck => opb_Sl_errAck(1),
      Sln_retry => opb_Sl_retry(1),
      Sln_toutSup => opb_Sl_toutSup(1),
      Sln_xferAck => opb_Sl_xferAck(1),
      IP2INTC_Irpt => open,
      GPIO_in => net_gnd7,
      GPIO_d_out => fpga_0_LED_7SEGMENT_1_GPIO_d_out,
      GPIO_t_out => open,
      GPIO2_in => net_gnd7,
      GPIO2_d_out => open,
      GPIO2_t_out => open,
      GPIO_IO_I => net_gnd7,
      GPIO_IO_O => open,
      GPIO_IO_T => open,
      GPIO2_IO_I => net_gnd7,
      GPIO2_IO_O => open,
      GPIO2_IO_T => open
    );

  leds_4bit : leds_4bit_wrapper
    port map (
      OPB_ABus => opb_OPB_ABus,
      OPB_BE => opb_OPB_BE,
      OPB_Clk => sys_clk_OPB,
      OPB_DBus => opb_OPB_DBus,
      OPB_RNW => opb_OPB_RNW,
      OPB_Rst => opb_OPB_Rst,
      OPB_select => opb_OPB_select,
      OPB_seqAddr => opb_OPB_seqAddr,
      Sln_DBus => opb_Sl_DBus(64 to 95),
      Sln_errAck => opb_Sl_errAck(2),
      Sln_retry => opb_Sl_retry(2),
      Sln_toutSup => opb_Sl_toutSup(2),
      Sln_xferAck => opb_Sl_xferAck(2),
      IP2INTC_Irpt => open,
      GPIO_in => net_gnd4,
      GPIO_d_out => fpga_0_LEDs_4Bit_GPIO_d_out,
      GPIO_t_out => open,
      GPIO2_in => net_gnd4,
      GPIO2_d_out => open,
      GPIO2_t_out => open,
      GPIO_IO_I => net_gnd4,
      GPIO_IO_O => open,
      GPIO_IO_T => open,
      GPIO2_IO_I => net_gnd4,
      GPIO2_IO_O => open,
      GPIO2_IO_T => open
    );

  push_buttons_4bit : push_buttons_4bit_wrapper
    port map (
      OPB_ABus => opb_OPB_ABus,
      OPB_BE => opb_OPB_BE,
      OPB_Clk => sys_clk_OPB,
      OPB_DBus => opb_OPB_DBus,
      OPB_RNW => opb_OPB_RNW,
      OPB_Rst => opb_OPB_Rst,
      OPB_select => opb_OPB_select,
      OPB_seqAddr => opb_OPB_seqAddr,
      Sln_DBus => opb_Sl_DBus(96 to 127),
      Sln_errAck => opb_Sl_errAck(3),
      Sln_retry => opb_Sl_retry(3),
      Sln_toutSup => opb_Sl_toutSup(3),
      Sln_xferAck => opb_Sl_xferAck(3),
      IP2INTC_Irpt => Push_Buttons_4bit_IP2INTC_Irpt,
      GPIO_in => fpga_0_Push_Buttons_4bit_GPIO_in,
      GPIO_d_out => open,
      GPIO_t_out => open,
      GPIO2_in => net_gnd4,
      GPIO2_d_out => open,
      GPIO2_t_out => open,
      GPIO_IO_I => net_gnd4,
      GPIO_IO_O => open,
      GPIO_IO_T => open,
      GPIO2_IO_I => net_gnd4,
      GPIO2_IO_O => open,
      GPIO2_IO_T => open
    );

  dipsws_4bit : dipsws_4bit_wrapper
    port map (
      OPB_ABus => opb_OPB_ABus,
      OPB_BE => opb_OPB_BE,
      OPB_Clk => sys_clk_OPB,
      OPB_DBus => opb_OPB_DBus,
      OPB_RNW => opb_OPB_RNW,
      OPB_Rst => opb_OPB_Rst,
      OPB_select => opb_OPB_select,
      OPB_seqAddr => opb_OPB_seqAddr,
      Sln_DBus => opb_Sl_DBus(128 to 159),
      Sln_errAck => opb_Sl_errAck(4),
      Sln_retry => opb_Sl_retry(4),
      Sln_toutSup => opb_Sl_toutSup(4),
      Sln_xferAck => opb_Sl_xferAck(4),
      IP2INTC_Irpt => open,
      GPIO_in => fpga_0_DIPSWs_4Bit_GPIO_in,
      GPIO_d_out => open,
      GPIO_t_out => open,
      GPIO2_in => net_gnd4,
      GPIO2_d_out => open,
      GPIO2_t_out => open,
      GPIO_IO_I => net_gnd4,
      GPIO_IO_O => open,
      GPIO_IO_T => open,
      GPIO2_IO_I => net_gnd4,
      GPIO2_IO_O => open,
      GPIO2_IO_T => open
    );

  rs232 : rs232_wrapper
    port map (
      OPB_Clk => sys_clk_OPB,
      OPB_Rst => opb_OPB_Rst,
      Interrupt => open,
      OPB_ABus => opb_OPB_ABus,
      OPB_BE => opb_OPB_BE,
      OPB_RNW => opb_OPB_RNW,
      OPB_select => opb_OPB_select,
      OPB_seqAddr => opb_OPB_seqAddr,
      OPB_DBus => opb_OPB_DBus,
      UART_DBus => opb_Sl_DBus(160 to 191),
      UART_errAck => opb_Sl_errAck(5),
      UART_retry => opb_Sl_retry(5),
      UART_toutSup => opb_Sl_toutSup(5),
      UART_xferAck => opb_Sl_xferAck(5),
      RX => fpga_0_rs232_RX,
      TX => fpga_0_rs232_TX
    );

  clk_board_config : clk_board_config_wrapper
    port map (
      sys_clk => fpga_0_clk_board_config_sys_clk,
      sys_rst => net_gnd0,
      cfg_radio_dat_out => fpga_0_clk_board_config_cfg_radio_dat_out,
      cfg_radio_csb_out => fpga_0_clk_board_config_cfg_radio_csb_out,
      cfg_radio_en_out => fpga_0_clk_board_config_cfg_radio_en_out,
      cfg_radio_clk_out => fpga_0_clk_board_config_cfg_radio_clk_out,
      cfg_logic_dat_out => fpga_0_clk_board_config_cfg_logic_dat_out,
      cfg_logic_csb_out => fpga_0_clk_board_config_cfg_logic_csb_out,
      cfg_logic_en_out => fpga_0_clk_board_config_cfg_logic_en_out,
      cfg_logic_clk_out => fpga_0_clk_board_config_cfg_logic_clk_out,
      config_invalid => clkBoardConfig_DCM_Reset
    );

  eeprom_controller : eeprom_controller_wrapper
    port map (
      DQ0_T => fpga_0_eeprom_controller_DQ0_T,
      DQ0_O => fpga_0_eeprom_controller_DQ0_O,
      DQ0_I => fpga_0_eeprom_controller_DQ0_I,
      DQ1_T => open,
      DQ1_O => open,
      DQ1_I => net_vcc0,
      DQ2_T => eeprom_controller_DQ2_T_radio_bridge_slot_2_user_EEPROM_IO_T,
      DQ2_O => eeprom_controller_DQ2_O_radio_bridge_slot_2_user_EEPROM_IO_O,
      DQ2_I => eeprom_controller_DQ2_I_radio_bridge_slot_2_user_EEPROM_IO_I,
      DQ3_T => eeprom_controller_DQ3_T_radio_bridge_slot_3_user_EEPROM_IO_T,
      DQ3_O => eeprom_controller_DQ3_O_radio_bridge_slot_3_user_EEPROM_IO_O,
      DQ3_I => eeprom_controller_DQ3_I_radio_bridge_slot_3_user_EEPROM_IO_I,
      DQ4_T => open,
      DQ4_O => open,
      DQ4_I => net_vcc0,
      DQ5_T => open,
      DQ5_O => open,
      DQ5_I => net_vcc0,
      DQ6_T => open,
      DQ6_O => open,
      DQ6_I => net_vcc0,
      DQ7_T => open,
      DQ7_O => open,
      DQ7_I => net_vcc0,
      OPB_Clk => sys_clk_OPB,
      OPB_Rst => opb_OPB_Rst,
      Sl_DBus => opb_Sl_DBus(192 to 223),
      Sl_errAck => opb_Sl_errAck(6),
      Sl_retry => opb_Sl_retry(6),
      Sl_toutSup => opb_Sl_toutSup(6),
      Sl_xferAck => opb_Sl_xferAck(6),
      OPB_ABus => opb_OPB_ABus,
      OPB_BE => opb_OPB_BE,
      OPB_DBus => opb_OPB_DBus,
      OPB_RNW => opb_OPB_RNW,
      OPB_select => opb_OPB_select,
      OPB_seqAddr => opb_OPB_seqAddr
    );

  ethernet_mac : ethernet_mac_wrapper
    port map (
      PHY_tx_clk => fpga_0_Ethernet_MAC_PHY_tx_clk,
      PHY_rx_clk => fpga_0_Ethernet_MAC_PHY_rx_clk,
      PHY_crs => fpga_0_Ethernet_MAC_PHY_crs,
      PHY_dv => fpga_0_Ethernet_MAC_PHY_dv,
      PHY_rx_data => fpga_0_Ethernet_MAC_PHY_rx_data,
      PHY_col => fpga_0_Ethernet_MAC_PHY_col,
      PHY_rx_er => fpga_0_Ethernet_MAC_PHY_rx_er,
      PHY_tx_en => fpga_0_Ethernet_MAC_PHY_tx_en,
      PHY_rx_en => open,
      PHY_tx_er => fpga_0_Ethernet_MAC_PHY_tx_er,
      PHY_tx_data => fpga_0_Ethernet_MAC_PHY_tx_data,
      PHY_rst_n => fpga_0_Ethernet_MAC_PHY_rst_n,
      PLB_Clk => sys_clk_s,
      PLB_Rst => plb_PLB_Rst,
      Freeze => net_gnd0,
      IP2INTC_Irpt => Ethernet_MAC_IP2INTC_Irpt,
      PLB_ABus => plb_PLB_ABus,
      PLB_PAValid => plb_PLB_PAValid,
      PLB_SAValid => plb_PLB_SAValid,
      PLB_rdPrim => plb_PLB_rdPrim,
      PLB_wrPrim => plb_PLB_wrPrim,
      PLB_masterID => plb_PLB_masterID,
      PLB_abort => plb_PLB_abort,
      PLB_busLock => plb_PLB_busLock,
      PLB_RNW => plb_PLB_RNW,
      PLB_BE => plb_PLB_BE,
      PLB_MSize => plb_PLB_MSize,
      PLB_size => plb_PLB_size,
      PLB_type => plb_PLB_type,
      PLB_compress => plb_PLB_compress,
      PLB_guarded => plb_PLB_guarded,
      PLB_ordered => plb_PLB_ordered,
      PLB_lockErr => plb_PLB_lockErr,
      PLB_wrDBus => plb_PLB_wrDBus,
      PLB_wrBurst => plb_PLB_wrBurst,
      PLB_rdBurst => plb_PLB_rdBurst,
      PLB_pendReq => plb_PLB_pendReq,
      PLB_pendPri => plb_PLB_pendPri,
      PLB_reqPri => plb_PLB_reqPri,
      Sl_addrAck => plb_Sl_addrAck(2),
      Sl_SSize => plb_Sl_SSize(4 to 5),
      Sl_wait => plb_Sl_wait(2),
      Sl_rearbitrate => plb_Sl_rearbitrate(2),
      Sl_wrDAck => plb_Sl_wrDAck(2),
      Sl_wrComp => plb_Sl_wrComp(2),
      Sl_wrBTerm => plb_Sl_wrBTerm(2),
      Sl_rdDBus => plb_Sl_rdDBus(128 to 191),
      Sl_rdWdAddr => plb_Sl_rdWdAddr(8 to 11),
      Sl_rdDAck => plb_Sl_rdDAck(2),
      Sl_rdComp => plb_Sl_rdComp(2),
      Sl_rdBTerm => plb_Sl_rdBTerm(2),
      Sl_MBusy => plb_Sl_MBusy(6 to 8),
      Sl_MErr => plb_Sl_MErr(6 to 8),
      PLB_MAddrAck => plb_PLB_MAddrAck(2),
      PLB_MSSize => plb_PLB_MSSize(4 to 5),
      PLB_MRearbitrate => plb_PLB_MRearbitrate(2),
      PLB_MBusy => plb_PLB_MBusy(2),
      PLB_MErr => plb_PLB_MErr(2),
      PLB_MWrDAck => plb_PLB_MWrDAck(2),
      PLB_MRdDBus => plb_PLB_MRdDBus(128 to 191),
      PLB_MRdWdAddr => plb_PLB_MRdWdAddr(8 to 11),
      PLB_MRdDAck => plb_PLB_MRdDAck(2),
      PLB_MRdBTerm => plb_PLB_MRdBTerm(2),
      PLB_MWrBTerm => plb_PLB_MWrBTerm(2),
      M_request => plb_M_request(2),
      M_priority => plb_M_priority(4 to 5),
      M_buslock => plb_M_busLock(2),
      M_RNW => plb_M_RNW(2),
      M_BE => plb_M_BE(16 to 23),
      M_MSize => plb_M_MSize(4 to 5),
      M_size => plb_M_size(8 to 11),
      M_type => plb_M_type(6 to 8),
      M_compress => plb_M_compress(2),
      M_guarded => plb_M_guarded(2),
      M_ordered => plb_M_ordered(2),
      M_lockErr => plb_M_lockErr(2),
      M_abort => plb_M_abort(2),
      M_ABus => plb_M_ABus(64 to 95),
      M_wrDBus => plb_M_wrDBus(128 to 191),
      M_wrBurst => plb_M_wrBurst(2),
      M_rdBurst => plb_M_rdBurst(2),
      PHY_Mii_clk_I => fpga_0_Ethernet_MAC_PHY_Mii_clk_I,
      PHY_Mii_clk_O => fpga_0_Ethernet_MAC_PHY_Mii_clk_O,
      PHY_Mii_clk_T => fpga_0_Ethernet_MAC_PHY_Mii_clk_T,
      PHY_Mii_data_I => fpga_0_Ethernet_MAC_PHY_Mii_data_I,
      PHY_Mii_data_O => fpga_0_Ethernet_MAC_PHY_Mii_data_O,
      PHY_Mii_data_T => fpga_0_Ethernet_MAC_PHY_Mii_data_T
    );

  radio_controller_0 : radio_controller_0_wrapper
    port map (
      OPB_Clk => sys_clk_OPB,
      OPB_Rst => opb_OPB_Rst,
      Sl_DBus => opb_Sl_DBus(224 to 255),
      Sl_errAck => opb_Sl_errAck(7),
      Sl_retry => opb_Sl_retry(7),
      Sl_toutSup => opb_Sl_toutSup(7),
      Sl_xferAck => opb_Sl_xferAck(7),
      OPB_ABus => opb_OPB_ABus,
      OPB_BE => opb_OPB_BE,
      OPB_DBus => opb_OPB_DBus,
      OPB_RNW => opb_OPB_RNW,
      OPB_select => opb_OPB_select,
      OPB_seqAddr => opb_OPB_seqAddr,
      spi_clk => radio_bridge_slot_2_controller_spi_clk_radio_bridge_slot_3_controller_spi_clk_radio_controller_0_spi_clk,
      data_out => radio_bridge_slot_2_controller_spi_data_radio_bridge_slot_3_controller_spi_data_radio_controller_0_data_out,
      radio1_cs => open,
      radio2_cs => radio_bridge_slot_2_controller_radio_cs_radio_controller_0_radio2_cs,
      radio3_cs => radio_bridge_slot_3_controller_radio_cs_radio_controller_0_radio3_cs,
      radio4_cs => open,
      dac1_cs => open,
      dac2_cs => radio_bridge_slot_2_controller_dac_cs_radio_controller_0_dac2_cs,
      dac3_cs => radio_bridge_slot_3_controller_dac_cs_radio_controller_0_dac3_cs,
      dac4_cs => open,
      radio1_SHDN => open,
      radio1_TxEn => open,
      radio1_RxEn => open,
      radio1_RxHP => open,
      radio1_LD => net_gnd0,
      radio1_24PA => open,
      radio1_5PA => open,
      radio1_ANTSW => open,
      radio1_LED => open,
      radio1_ADC_RX_DCS => open,
      radio1_ADC_RX_DFS => open,
      radio1_ADC_RX_OTRA => net_gnd0,
      radio1_ADC_RX_OTRB => net_gnd0,
      radio1_ADC_RX_PWDNA => open,
      radio1_ADC_RX_PWDNB => open,
      radio1_DIPSW => net_gnd4,
      radio1_RSSI_ADC_CLAMP => open,
      radio1_RSSI_ADC_HIZ => open,
      radio1_RSSI_ADC_OTR => net_gnd0,
      radio1_RSSI_ADC_SLEEP => open,
      radio1_RSSI_ADC_D => net_gnd10,
      radio1_TX_DAC_PLL_LOCK => net_gnd0,
      radio1_TX_DAC_RESET => open,
      radio1_SHDN_external => net_gnd0,
      radio1_TxEn_external => net_gnd0,
      radio1_RxEn_external => net_gnd0,
      radio1_RxHP_external => net_gnd0,
      radio1_TxGain => open,
      radio1_TxStart => open,
      radio2_SHDN => radio_bridge_slot_2_controller_SHDN_radio_controller_0_radio2_SHDN,
      radio2_TxEn => radio_bridge_slot_2_controller_TxEn_radio_controller_0_radio2_TxEn,
      radio2_RxEn => radio_bridge_slot_2_controller_RxEn_radio_controller_0_radio2_RxEn,
      radio2_RxHP => radio_bridge_slot_2_controller_RxHP_radio_controller_0_radio2_RxHP,
      radio2_LD => radio_bridge_slot_2_controller_LD_radio_controller_0_radio2_LD,
      radio2_24PA => radio_bridge_slot_2_controller_24PA_radio_controller_0_radio2_24PA,
      radio2_5PA => radio_bridge_slot_2_controller_5PA_radio_controller_0_radio2_5PA,
      radio2_ANTSW => radio_bridge_slot_2_controller_ANTSW_radio_controller_0_radio2_ANTSW,
      radio2_LED => radio_bridge_slot_2_controller_LED_radio_controller_0_radio2_LED,
      radio2_ADC_RX_DCS => radio_bridge_slot_2_controller_RX_ADC_DCS_radio_controller_0_radio2_ADC_RX_DCS,
      radio2_ADC_RX_DFS => radio_bridge_slot_2_controller_RX_ADC_DFS_radio_controller_0_radio2_ADC_RX_DFS,
      radio2_ADC_RX_OTRA => radio_bridge_slot_2_controller_RX_ADC_OTRA_radio_controller_0_radio2_ADC_RX_OTRA,
      radio2_ADC_RX_OTRB => radio_bridge_slot_2_controller_RX_ADC_OTRB_radio_controller_0_radio2_ADC_RX_OTRB,
      radio2_ADC_RX_PWDNA => radio_bridge_slot_2_controller_RX_ADC_PWDNA_radio_controller_0_radio2_ADC_RX_PWDNA,
      radio2_ADC_RX_PWDNB => radio_bridge_slot_2_controller_RX_ADC_PWDNB_radio_controller_0_radio2_ADC_RX_PWDNB,
      radio2_DIPSW => radio_bridge_slot_2_controller_DIPSW_radio_controller_0_radio2_DIPSW,
      radio2_RSSI_ADC_CLAMP => radio_bridge_slot_2_controller_RSSI_ADC_CLAMP_radio_controller_0_radio2_RSSI_ADC_CLAMP,
      radio2_RSSI_ADC_HIZ => radio_bridge_slot_2_controller_RSSI_ADC_HIZ_radio_controller_0_radio2_RSSI_ADC_HIZ,
      radio2_RSSI_ADC_OTR => radio_bridge_slot_2_controller_RSSI_ADC_OTR_radio_controller_0_radio2_RSSI_ADC_OTR,
      radio2_RSSI_ADC_SLEEP => radio_bridge_slot_2_controller_RSSI_ADC_SLEEP_radio_controller_0_radio2_RSSI_ADC_SLEEP,
      radio2_RSSI_ADC_D => radio_bridge_slot_2_controller_RSSI_ADC_D_radio_controller_0_radio2_RSSI_ADC_D,
      radio2_TX_DAC_PLL_LOCK => radio_bridge_slot_2_controller_dac_PLL_LOCK_radio_controller_0_radio2_TX_DAC_PLL_LOCK,
      radio2_TX_DAC_RESET => radio_bridge_slot_2_controller_dac_RESET_radio_controller_0_radio2_TX_DAC_RESET,
      radio2_SHDN_external => radio_bridge_slot_2_controller_SHDN_external_radio_controller_0_radio2_SHDN_external,
      radio2_TxEn_external => radio_bridge_slot_2_controller_TxEn_external_radio_controller_0_radio2_TxEn_external,
      radio2_RxEn_external => radio_bridge_slot_2_controller_RxEn_external_radio_controller_0_radio2_RxEn_external,
      radio2_RxHP_external => radio_bridge_slot_2_controller_RxHP_external_radio_controller_0_radio2_RxHP_external,
      radio2_TxGain => radio_bridge_slot_2_user_Tx_gain_radio_controller_0_radio2_TxGain,
      radio2_TxStart => radio_bridge_slot_2_controller_TxStart_radio_controller_0_radio2_TxStart,
      radio3_SHDN => radio_bridge_slot_3_controller_SHDN_radio_controller_0_radio3_SHDN,
      radio3_TxEn => radio_bridge_slot_3_controller_TxEn_radio_controller_0_radio3_TxEn,
      radio3_RxEn => radio_bridge_slot_3_controller_RxEn_radio_controller_0_radio3_RxEn,
      radio3_RxHP => radio_bridge_slot_3_controller_RxHP_radio_controller_0_radio3_RxHP,
      radio3_LD => radio_bridge_slot_3_controller_LD_radio_controller_0_radio3_LD,
      radio3_24PA => radio_bridge_slot_3_controller_24PA_radio_controller_0_radio3_24PA,
      radio3_5PA => radio_bridge_slot_3_controller_5PA_radio_controller_0_radio3_5PA,
      radio3_ANTSW => radio_bridge_slot_3_controller_ANTSW_radio_controller_0_radio3_ANTSW,
      radio3_LED => radio_bridge_slot_3_controller_LED_radio_controller_0_radio3_LED,
      radio3_ADC_RX_DCS => radio_bridge_slot_3_controller_RX_ADC_DCS_radio_controller_0_radio3_ADC_RX_DCS,
      radio3_ADC_RX_DFS => radio_bridge_slot_3_controller_RX_ADC_DFS_radio_controller_0_radio3_ADC_RX_DFS,
      radio3_ADC_RX_OTRA => radio_bridge_slot_3_controller_RX_ADC_OTRA_radio_controller_0_radio3_ADC_RX_OTRA,
      radio3_ADC_RX_OTRB => radio_bridge_slot_3_controller_RX_ADC_OTRB_radio_controller_0_radio3_ADC_RX_OTRB,
      radio3_ADC_RX_PWDNA => radio_bridge_slot_3_controller_RX_ADC_PWDNA_radio_controller_0_radio3_ADC_RX_PWDNA,
      radio3_ADC_RX_PWDNB => radio_bridge_slot_3_controller_RX_ADC_PWDNB_radio_controller_0_radio3_ADC_RX_PWDNB,
      radio3_DIPSW => radio_bridge_slot_3_controller_DIPSW_radio_controller_0_radio3_DIPSW,
      radio3_RSSI_ADC_CLAMP => radio_bridge_slot_3_controller_RSSI_ADC_CLAMP_radio_controller_0_radio3_RSSI_ADC_CLAMP,
      radio3_RSSI_ADC_HIZ => radio_bridge_slot_3_controller_RSSI_ADC_HIZ_radio_controller_0_radio3_RSSI_ADC_HIZ,
      radio3_RSSI_ADC_OTR => radio_bridge_slot_3_controller_RSSI_ADC_OTR_radio_controller_0_radio3_RSSI_ADC_OTR,
      radio3_RSSI_ADC_SLEEP => radio_bridge_slot_3_controller_RSSI_ADC_SLEEP_radio_controller_0_radio3_RSSI_ADC_SLEEP,
      radio3_RSSI_ADC_D => radio_bridge_slot_3_controller_RSSI_ADC_D_radio_controller_0_radio3_RSSI_ADC_D,
      radio3_TX_DAC_PLL_LOCK => radio_bridge_slot_3_controller_dac_PLL_LOCK_radio_controller_0_radio3_TX_DAC_PLL_LOCK,
      radio3_TX_DAC_RESET => radio_bridge_slot_3_controller_dac_RESET_radio_controller_0_radio3_TX_DAC_RESET,
      radio3_SHDN_external => radio_bridge_slot_3_controller_SHDN_external_radio_controller_0_radio3_SHDN_external,
      radio3_TxEn_external => radio_bridge_slot_3_controller_TxEn_external_radio_controller_0_radio3_TxEn_external,
      radio3_RxEn_external => radio_bridge_slot_3_controller_RxEn_external_radio_controller_0_radio3_RxEn_external,
      radio3_RxHP_external => radio_bridge_slot_3_controller_RxHP_external_radio_controller_0_radio3_RxHP_external,
      radio3_TxGain => radio_bridge_slot_3_user_Tx_gain_radio_controller_0_radio3_TxGain,
      radio3_TxStart => radio_bridge_slot_3_controller_TxStart_radio_controller_0_radio3_TxStart,
      radio4_SHDN => open,
      radio4_TxEn => open,
      radio4_RxEn => open,
      radio4_RxHP => open,
      radio4_LD => net_gnd0,
      radio4_24PA => open,
      radio4_5PA => open,
      radio4_ANTSW => open,
      radio4_LED => open,
      radio4_ADC_RX_DCS => open,
      radio4_ADC_RX_DFS => open,
      radio4_ADC_RX_OTRA => net_gnd0,
      radio4_ADC_RX_OTRB => net_gnd0,
      radio4_ADC_RX_PWDNA => open,
      radio4_ADC_RX_PWDNB => open,
      radio4_DIPSW => net_gnd4,
      radio4_RSSI_ADC_CLAMP => open,
      radio4_RSSI_ADC_HIZ => open,
      radio4_RSSI_ADC_OTR => net_gnd0,
      radio4_RSSI_ADC_SLEEP => open,
      radio4_RSSI_ADC_D => net_gnd10,
      radio4_TX_DAC_PLL_LOCK => net_gnd0,
      radio4_TX_DAC_RESET => open,
      radio4_SHDN_external => net_gnd0,
      radio4_TxEn_external => net_gnd0,
      radio4_RxEn_external => net_gnd0,
      radio4_RxHP_external => net_gnd0,
      radio4_TxGain => open,
      radio4_TxStart => open
    );

  radio_bridge_slot_2 : radio_bridge_slot_2_wrapper
    port map (
      user_ADC_I => radio_bridge_slot_2_user_ADC_I,
      user_ADC_Q => radio_bridge_slot_2_user_ADC_Q,
      user_DAC_I => radio_bridge_slot_2_user_DAC_I,
      user_DAC_Q => radio_bridge_slot_2_user_DAC_Q,
      user_RxRF_gain => agc_g_rf_a,
      user_RxBB_gain => agc_g_bb_a,
      user_Tx_gain => radio_bridge_slot_2_user_Tx_gain_radio_controller_0_radio2_TxGain,
      user_TxModelStart => radio2_txStart,
      user_RSSI_ADC_clk => rssi_pkt_detect_opbw_0_rssi_clk_out,
      user_RSSI_ADC_D => radio_bridge_slot_2_user_RSSI_ADC_D,
      user_EEPROM_IO_T => eeprom_controller_DQ2_T_radio_bridge_slot_2_user_EEPROM_IO_T,
      user_EEPROM_IO_O => eeprom_controller_DQ2_O_radio_bridge_slot_2_user_EEPROM_IO_O,
      user_EEPROM_IO_I => eeprom_controller_DQ2_I_radio_bridge_slot_2_user_EEPROM_IO_I,
      user_SHDN_external => net_gnd0,
      user_RxEn_external => net_gnd0,
      user_TxEn_external => net_gnd0,
      user_RxHP_external => agc_rxhp_a,
      converter_clock_in => sys_clk_OPB,
      converter_clock_out => fpga_0_radio_bridge_slot_2_converter_clock_out,
      radio_RSSI_ADC_clk => fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_clk,
      radio_DAC_I => fpga_0_radio_bridge_slot_2_radio_DAC_I,
      radio_DAC_Q => fpga_0_radio_bridge_slot_2_radio_DAC_Q,
      radio_ADC_I => fpga_0_radio_bridge_slot_2_radio_ADC_I,
      radio_ADC_Q => fpga_0_radio_bridge_slot_2_radio_ADC_Q,
      radio_B => fpga_0_radio_bridge_slot_2_radio_B,
      radio_ANTSW => fpga_0_radio_bridge_slot_2_radio_ANTSW,
      radio_LED => fpga_0_radio_bridge_slot_2_radio_LED,
      radio_DIPSW => fpga_0_radio_bridge_slot_2_radio_DIPSW,
      radio_RSSI_ADC_D => fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_D,
      radio_EEPROM_IO => fpga_0_radio_bridge_slot_2_radio_EEPROM_IO,
      radio_spi_clk => fpga_0_radio_bridge_slot_2_radio_spi_clk,
      radio_spi_data => fpga_0_radio_bridge_slot_2_radio_spi_data,
      radio_spi_cs => fpga_0_radio_bridge_slot_2_radio_spi_cs,
      radio_SHDN => fpga_0_radio_bridge_slot_2_radio_SHDN,
      radio_TxEn => fpga_0_radio_bridge_slot_2_radio_TxEn,
      radio_RxEn => fpga_0_radio_bridge_slot_2_radio_RxEn,
      radio_RxHP => fpga_0_radio_bridge_slot_2_radio_RxHP,
      radio_24PA => fpga_0_radio_bridge_slot_2_radio_24PA,
      radio_5PA => fpga_0_radio_bridge_slot_2_radio_5PA,
      radio_RX_ADC_DCS => fpga_0_radio_bridge_slot_2_radio_RX_ADC_DCS,
      radio_RX_ADC_DFS => fpga_0_radio_bridge_slot_2_radio_RX_ADC_DFS,
      radio_RX_ADC_PWDNA => fpga_0_radio_bridge_slot_2_radio_RX_ADC_PWDNA,
      radio_RX_ADC_PWDNB => fpga_0_radio_bridge_slot_2_radio_RX_ADC_PWDNB,
      radio_RSSI_ADC_CLAMP => fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_CLAMP,
      radio_RSSI_ADC_HIZ => fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_HIZ,
      radio_RSSI_ADC_SLEEP => fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_SLEEP,
      radio_LD => fpga_0_radio_bridge_slot_2_radio_LD,
      radio_RX_ADC_OTRA => fpga_0_radio_bridge_slot_2_radio_RX_ADC_OTRA,
      radio_RX_ADC_OTRB => fpga_0_radio_bridge_slot_2_radio_RX_ADC_OTRB,
      radio_RSSI_ADC_OTR => fpga_0_radio_bridge_slot_2_radio_RSSI_ADC_OTR,
      radio_DAC_PLL_LOCK => fpga_0_radio_bridge_slot_2_radio_dac_PLL_LOCK,
      radio_DAC_RESET => fpga_0_radio_bridge_slot_2_radio_dac_RESET,
      controller_spi_clk => radio_bridge_slot_2_controller_spi_clk_radio_bridge_slot_3_controller_spi_clk_radio_controller_0_spi_clk,
      controller_spi_data => radio_bridge_slot_2_controller_spi_data_radio_bridge_slot_3_controller_spi_data_radio_controller_0_data_out,
      controller_radio_cs => radio_bridge_slot_2_controller_radio_cs_radio_controller_0_radio2_cs,
      controller_dac_cs => radio_bridge_slot_2_controller_dac_cs_radio_controller_0_dac2_cs,
      controller_SHDN => radio_bridge_slot_2_controller_SHDN_radio_controller_0_radio2_SHDN,
      controller_TxEn => radio_bridge_slot_2_controller_TxEn_radio_controller_0_radio2_TxEn,
      controller_RxEn => radio_bridge_slot_2_controller_RxEn_radio_controller_0_radio2_RxEn,
      controller_RxHP => radio_bridge_slot_2_controller_RxHP_radio_controller_0_radio2_RxHP,
      controller_24PA => radio_bridge_slot_2_controller_24PA_radio_controller_0_radio2_24PA,
      controller_5PA => radio_bridge_slot_2_controller_5PA_radio_controller_0_radio2_5PA,
      controller_ANTSW => radio_bridge_slot_2_controller_ANTSW_radio_controller_0_radio2_ANTSW,
      controller_LED => radio_bridge_slot_2_controller_LED_radio_controller_0_radio2_LED,
      controller_RX_ADC_DCS => radio_bridge_slot_2_controller_RX_ADC_DCS_radio_controller_0_radio2_ADC_RX_DCS,
      controller_RX_ADC_DFS => radio_bridge_slot_2_controller_RX_ADC_DFS_radio_controller_0_radio2_ADC_RX_DFS,
      controller_RX_ADC_PWDNA => radio_bridge_slot_2_controller_RX_ADC_PWDNA_radio_controller_0_radio2_ADC_RX_PWDNA,
      controller_RX_ADC_PWDNB => radio_bridge_slot_2_controller_RX_ADC_PWDNB_radio_controller_0_radio2_ADC_RX_PWDNB,
      controller_RSSI_ADC_CLAMP => radio_bridge_slot_2_controller_RSSI_ADC_CLAMP_radio_controller_0_radio2_RSSI_ADC_CLAMP,
      controller_RSSI_ADC_HIZ => radio_bridge_slot_2_controller_RSSI_ADC_HIZ_radio_controller_0_radio2_RSSI_ADC_HIZ,
      controller_RSSI_ADC_SLEEP => radio_bridge_slot_2_controller_RSSI_ADC_SLEEP_radio_controller_0_radio2_RSSI_ADC_SLEEP,
      controller_DIPSW => radio_bridge_slot_2_controller_DIPSW_radio_controller_0_radio2_DIPSW,
      controller_RSSI_ADC_D => radio_bridge_slot_2_controller_RSSI_ADC_D_radio_controller_0_radio2_RSSI_ADC_D,
      controller_LD => radio_bridge_slot_2_controller_LD_radio_controller_0_radio2_LD,
      controller_RX_ADC_OTRA => radio_bridge_slot_2_controller_RX_ADC_OTRA_radio_controller_0_radio2_ADC_RX_OTRA,
      controller_RX_ADC_OTRB => radio_bridge_slot_2_controller_RX_ADC_OTRB_radio_controller_0_radio2_ADC_RX_OTRB,
      controller_RSSI_ADC_OTR => radio_bridge_slot_2_controller_RSSI_ADC_OTR_radio_controller_0_radio2_RSSI_ADC_OTR,
      controller_DAC_PLL_LOCK => radio_bridge_slot_2_controller_dac_PLL_LOCK_radio_controller_0_radio2_TX_DAC_PLL_LOCK,
      controller_DAC_RESET => radio_bridge_slot_2_controller_dac_RESET_radio_controller_0_radio2_TX_DAC_RESET,
      controller_TxStart => radio_bridge_slot_2_controller_TxStart_radio_controller_0_radio2_TxStart,
      dac_spi_data => fpga_0_radio_bridge_slot_2_dac_spi_data,
      dac_spi_cs => fpga_0_radio_bridge_slot_2_dac_spi_cs,
      dac_spi_clk => fpga_0_radio_bridge_slot_2_dac_spi_clk,
      controller_SHDN_external => radio_bridge_slot_2_controller_SHDN_external_radio_controller_0_radio2_SHDN_external,
      controller_RxEn_external => radio_bridge_slot_2_controller_RxEn_external_radio_controller_0_radio2_RxEn_external,
      controller_TxEn_external => radio_bridge_slot_2_controller_TxEn_external_radio_controller_0_radio2_TxEn_external,
      controller_RxHP_external => radio_bridge_slot_2_controller_RxHP_external_radio_controller_0_radio2_RxHP_external
    );

  radio_bridge_slot_3 : radio_bridge_slot_3_wrapper
    port map (
      user_ADC_I => radio_bridge_slot_3_user_ADC_I,
      user_ADC_Q => radio_bridge_slot_3_user_ADC_Q,
      user_DAC_I => radio_bridge_slot_3_user_DAC_I,
      user_DAC_Q => radio_bridge_slot_3_user_DAC_Q,
      user_RxRF_gain => agc_g_rf_b,
      user_RxBB_gain => agc_g_bb_b,
      user_Tx_gain => radio_bridge_slot_3_user_Tx_gain_radio_controller_0_radio3_TxGain,
      user_TxModelStart => radio3_txStart,
      user_RSSI_ADC_clk => rssi_pkt_detect_opbw_0_rssi_clk_out,
      user_RSSI_ADC_D => radio_bridge_slot_3_user_RSSI_ADC_D,
      user_EEPROM_IO_T => eeprom_controller_DQ3_T_radio_bridge_slot_3_user_EEPROM_IO_T,
      user_EEPROM_IO_O => eeprom_controller_DQ3_O_radio_bridge_slot_3_user_EEPROM_IO_O,
      user_EEPROM_IO_I => eeprom_controller_DQ3_I_radio_bridge_slot_3_user_EEPROM_IO_I,
      user_SHDN_external => net_gnd0,
      user_RxEn_external => net_gnd0,
      user_TxEn_external => net_gnd0,
      user_RxHP_external => agc_rxhp_b,
      converter_clock_in => sys_clk_OPB,
      converter_clock_out => fpga_0_radio_bridge_slot_3_converter_clock_out,
      radio_RSSI_ADC_clk => fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_clk,
      radio_DAC_I => fpga_0_radio_bridge_slot_3_radio_DAC_I,
      radio_DAC_Q => fpga_0_radio_bridge_slot_3_radio_DAC_Q,
      radio_ADC_I => fpga_0_radio_bridge_slot_3_radio_ADC_I,
      radio_ADC_Q => fpga_0_radio_bridge_slot_3_radio_ADC_Q,
      radio_B => fpga_0_radio_bridge_slot_3_radio_B,
      radio_ANTSW => fpga_0_radio_bridge_slot_3_radio_ANTSW,
      radio_LED => fpga_0_radio_bridge_slot_3_radio_LED,
      radio_DIPSW => fpga_0_radio_bridge_slot_3_radio_DIPSW,
      radio_RSSI_ADC_D => fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_D,
      radio_EEPROM_IO => fpga_0_radio_bridge_slot_3_radio_EEPROM_IO,
      radio_spi_clk => fpga_0_radio_bridge_slot_3_radio_spi_clk,
      radio_spi_data => fpga_0_radio_bridge_slot_3_radio_spi_data,
      radio_spi_cs => fpga_0_radio_bridge_slot_3_radio_spi_cs,
      radio_SHDN => fpga_0_radio_bridge_slot_3_radio_SHDN,
      radio_TxEn => fpga_0_radio_bridge_slot_3_radio_TxEn,
      radio_RxEn => fpga_0_radio_bridge_slot_3_radio_RxEn,
      radio_RxHP => fpga_0_radio_bridge_slot_3_radio_RxHP,
      radio_24PA => fpga_0_radio_bridge_slot_3_radio_24PA,
      radio_5PA => fpga_0_radio_bridge_slot_3_radio_5PA,
      radio_RX_ADC_DCS => fpga_0_radio_bridge_slot_3_radio_RX_ADC_DCS,
      radio_RX_ADC_DFS => fpga_0_radio_bridge_slot_3_radio_RX_ADC_DFS,
      radio_RX_ADC_PWDNA => fpga_0_radio_bridge_slot_3_radio_RX_ADC_PWDNA,
      radio_RX_ADC_PWDNB => fpga_0_radio_bridge_slot_3_radio_RX_ADC_PWDNB,
      radio_RSSI_ADC_CLAMP => fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_CLAMP,
      radio_RSSI_ADC_HIZ => fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_HIZ,
      radio_RSSI_ADC_SLEEP => fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_SLEEP,
      radio_LD => fpga_0_radio_bridge_slot_3_radio_LD,
      radio_RX_ADC_OTRA => fpga_0_radio_bridge_slot_3_radio_RX_ADC_OTRA,
      radio_RX_ADC_OTRB => fpga_0_radio_bridge_slot_3_radio_RX_ADC_OTRB,
      radio_RSSI_ADC_OTR => fpga_0_radio_bridge_slot_3_radio_RSSI_ADC_OTR,
      radio_DAC_PLL_LOCK => fpga_0_radio_bridge_slot_3_radio_dac_PLL_LOCK,
      radio_DAC_RESET => fpga_0_radio_bridge_slot_3_radio_dac_RESET,
      controller_spi_clk => radio_bridge_slot_2_controller_spi_clk_radio_bridge_slot_3_controller_spi_clk_radio_controller_0_spi_clk,
      controller_spi_data => radio_bridge_slot_2_controller_spi_data_radio_bridge_slot_3_controller_spi_data_radio_controller_0_data_out,
      controller_radio_cs => radio_bridge_slot_3_controller_radio_cs_radio_controller_0_radio3_cs,
      controller_dac_cs => radio_bridge_slot_3_controller_dac_cs_radio_controller_0_dac3_cs,
      controller_SHDN => radio_bridge_slot_3_controller_SHDN_radio_controller_0_radio3_SHDN,
      controller_TxEn => radio_bridge_slot_3_controller_TxEn_radio_controller_0_radio3_TxEn,
      controller_RxEn => radio_bridge_slot_3_controller_RxEn_radio_controller_0_radio3_RxEn,
      controller_RxHP => radio_bridge_slot_3_controller_RxHP_radio_controller_0_radio3_RxHP,
      controller_24PA => radio_bridge_slot_3_controller_24PA_radio_controller_0_radio3_24PA,
      controller_5PA => radio_bridge_slot_3_controller_5PA_radio_controller_0_radio3_5PA,
      controller_ANTSW => radio_bridge_slot_3_controller_ANTSW_radio_controller_0_radio3_ANTSW,
      controller_LED => radio_bridge_slot_3_controller_LED_radio_controller_0_radio3_LED,
      controller_RX_ADC_DCS => radio_bridge_slot_3_controller_RX_ADC_DCS_radio_controller_0_radio3_ADC_RX_DCS,
      controller_RX_ADC_DFS => radio_bridge_slot_3_controller_RX_ADC_DFS_radio_controller_0_radio3_ADC_RX_DFS,
      controller_RX_ADC_PWDNA => radio_bridge_slot_3_controller_RX_ADC_PWDNA_radio_controller_0_radio3_ADC_RX_PWDNA,
      controller_RX_ADC_PWDNB => radio_bridge_slot_3_controller_RX_ADC_PWDNB_radio_controller_0_radio3_ADC_RX_PWDNB,
      controller_RSSI_ADC_CLAMP => radio_bridge_slot_3_controller_RSSI_ADC_CLAMP_radio_controller_0_radio3_RSSI_ADC_CLAMP,
      controller_RSSI_ADC_HIZ => radio_bridge_slot_3_controller_RSSI_ADC_HIZ_radio_controller_0_radio3_RSSI_ADC_HIZ,
      controller_RSSI_ADC_SLEEP => radio_bridge_slot_3_controller_RSSI_ADC_SLEEP_radio_controller_0_radio3_RSSI_ADC_SLEEP,
      controller_DIPSW => radio_bridge_slot_3_controller_DIPSW_radio_controller_0_radio3_DIPSW,
      controller_RSSI_ADC_D => radio_bridge_slot_3_controller_RSSI_ADC_D_radio_controller_0_radio3_RSSI_ADC_D,
      controller_LD => radio_bridge_slot_3_controller_LD_radio_controller_0_radio3_LD,
      controller_RX_ADC_OTRA => radio_bridge_slot_3_controller_RX_ADC_OTRA_radio_controller_0_radio3_ADC_RX_OTRA,
      controller_RX_ADC_OTRB => radio_bridge_slot_3_controller_RX_ADC_OTRB_radio_controller_0_radio3_ADC_RX_OTRB,
      controller_RSSI_ADC_OTR => radio_bridge_slot_3_controller_RSSI_ADC_OTR_radio_controller_0_radio3_RSSI_ADC_OTR,
      controller_DAC_PLL_LOCK => radio_bridge_slot_3_controller_dac_PLL_LOCK_radio_controller_0_radio3_TX_DAC_PLL_LOCK,
      controller_DAC_RESET => radio_bridge_slot_3_controller_dac_RESET_radio_controller_0_radio3_TX_DAC_RESET,
      controller_TxStart => radio_bridge_slot_3_controller_TxStart_radio_controller_0_radio3_TxStart,
      dac_spi_data => fpga_0_radio_bridge_slot_3_dac_spi_data,
      dac_spi_cs => fpga_0_radio_bridge_slot_3_dac_spi_cs,
      dac_spi_clk => fpga_0_radio_bridge_slot_3_dac_spi_clk,
      controller_SHDN_external => radio_bridge_slot_3_controller_SHDN_external_radio_controller_0_radio3_SHDN_external,
      controller_RxEn_external => radio_bridge_slot_3_controller_RxEn_external_radio_controller_0_radio3_RxEn_external,
      controller_TxEn_external => radio_bridge_slot_3_controller_TxEn_external_radio_controller_0_radio3_TxEn_external,
      controller_RxHP_external => radio_bridge_slot_3_controller_RxHP_external_radio_controller_0_radio3_RxHP_external
    );

  analog_bridge_slot_4 : analog_bridge_slot_4_wrapper
    port map (
      user_DAC1_A => ofdm_rx_debug_eq_i,
      user_DAC1_B => ofdm_rx_debug_eq_q,
      user_DAC2_A => rx_debug_phasecorrect,
      user_DAC2_B => rx_debug_cfophasediff,
      user_DAC1_sleep => net_gnd0,
      user_DAC2_sleep => net_gnd0,
      user_ADC_A => open,
      user_ADC_B => open,
      user_ADC_DFS => net_vcc0,
      user_ADC_DCS => net_gnd0,
      user_ADC_pdwnA => net_gnd0,
      user_ADC_pdwnB => net_gnd0,
      user_ADC_otrA => open,
      user_ADC_otrB => open,
      user_LED => net_gnd3,
      clock_in => sys_clk_OPB,
      clock_out => fpga_0_analog_bridge_slot_4_clock_out,
      analog_DAC1_A => fpga_0_analog_bridge_slot_4_analog_DAC1_A,
      analog_DAC1_B => fpga_0_analog_bridge_slot_4_analog_DAC1_B,
      analog_DAC2_A => fpga_0_analog_bridge_slot_4_analog_DAC2_A,
      analog_DAC2_B => fpga_0_analog_bridge_slot_4_analog_DAC2_B,
      analog_DAC1_sleep => fpga_0_analog_bridge_slot_4_analog_DAC1_sleep,
      analog_DAC2_sleep => fpga_0_analog_bridge_slot_4_analog_DAC2_sleep,
      analog_ADC_A => fpga_0_analog_bridge_slot_4_analog_ADC_A,
      analog_ADC_B => fpga_0_analog_bridge_slot_4_analog_ADC_B,
      analog_ADC_DFS => fpga_0_analog_bridge_slot_4_analog_ADC_DFS,
      analog_ADC_DCS => fpga_0_analog_bridge_slot_4_analog_ADC_DCS,
      analog_ADC_pdwnA => fpga_0_analog_bridge_slot_4_analog_ADC_pdwnA,
      analog_ADC_pdwnB => fpga_0_analog_bridge_slot_4_analog_ADC_pdwnB,
      analog_ADC_otrA => fpga_0_analog_bridge_slot_4_analog_ADC_otrA,
      analog_ADC_otrB => fpga_0_analog_bridge_slot_4_analog_ADC_otrB,
      analog_LED => fpga_0_analog_bridge_slot_4_analog_LED
    );

  sram0_zbt_512kx32 : sram0_zbt_512kx32_wrapper
    port map (
      PLB_Clk => sys_clk_s,
      PLB_Rst => plb_PLB_Rst,
      PLB_abort => plb_PLB_abort,
      PLB_ABus => plb_PLB_ABus,
      PLB_BE => plb_PLB_BE,
      PLB_busLock => plb_PLB_busLock,
      PLB_compress => plb_PLB_compress,
      PLB_guarded => plb_PLB_guarded,
      PLB_lockErr => plb_PLB_lockErr,
      PLB_masterID => plb_PLB_masterID,
      PLB_MSize => plb_PLB_MSize,
      PLB_ordered => plb_PLB_ordered,
      PLB_PAValid => plb_PLB_PAValid,
      PLB_RNW => plb_PLB_RNW,
      PLB_size => plb_PLB_size,
      PLB_type => plb_PLB_type,
      Sl_addrAck => plb_Sl_addrAck(1),
      Sl_MBusy => plb_Sl_MBusy(3 to 5),
      Sl_MErr => plb_Sl_MErr(3 to 5),
      Sl_rearbitrate => plb_Sl_rearbitrate(1),
      Sl_SSize => plb_Sl_SSize(2 to 3),
      Sl_wait => plb_Sl_wait(1),
      PLB_rdPrim => plb_PLB_rdPrim,
      PLB_SAValid => plb_PLB_SAValid,
      PLB_wrPrim => plb_PLB_wrPrim,
      PLB_wrBurst => plb_PLB_wrBurst,
      PLB_wrDBus => plb_PLB_wrDBus,
      Sl_wrBTerm => plb_Sl_wrBTerm(1),
      Sl_wrComp => plb_Sl_wrComp(1),
      Sl_wrDAck => plb_Sl_wrDAck(1),
      PLB_rdBurst => plb_PLB_rdBurst,
      Sl_rdBTerm => plb_Sl_rdBTerm(1),
      Sl_rdComp => plb_Sl_rdComp(1),
      Sl_rdDAck => plb_Sl_rdDAck(1),
      Sl_rdDBus => plb_Sl_rdDBus(64 to 127),
      Sl_rdWdAddr => plb_Sl_rdWdAddr(4 to 7),
      PLB_pendReq => plb_PLB_pendReq,
      PLB_pendPri => plb_PLB_pendPri,
      PLB_reqPri => plb_PLB_reqPri,
      Mem_A => fpga_0_SRAM0_ZBT_512Kx32_Mem_A_split,
      Mem_CEN => open,
      Mem_OEN => fpga_0_SRAM0_ZBT_512Kx32_Mem_OEN(0 to 0),
      Mem_WEN => fpga_0_SRAM0_ZBT_512Kx32_Mem_WEN,
      Mem_QWEN => open,
      Mem_BEN => fpga_0_SRAM0_ZBT_512Kx32_Mem_BEN,
      Mem_RPN => open,
      Mem_CE => fpga_0_SRAM0_ZBT_512Kx32_Mem_CE(0 to 0),
      Mem_ADV_LDN => fpga_0_SRAM0_ZBT_512Kx32_Mem_ADV_LDN,
      Mem_LBON => open,
      Mem_CKEN => fpga_0_SRAM0_ZBT_512Kx32_Mem_CKEN,
      Mem_RNW => open,
      Mem_DQ_I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I,
      Mem_DQ_O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O,
      Mem_DQ_T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T
    );

  sram1_zbt_512kx32 : sram1_zbt_512kx32_wrapper
    port map (
      PLB_Clk => sys_clk_s,
      PLB_Rst => plb_PLB_Rst,
      PLB_abort => plb_PLB_abort,
      PLB_ABus => plb_PLB_ABus,
      PLB_BE => plb_PLB_BE,
      PLB_busLock => plb_PLB_busLock,
      PLB_compress => plb_PLB_compress,
      PLB_guarded => plb_PLB_guarded,
      PLB_lockErr => plb_PLB_lockErr,
      PLB_masterID => plb_PLB_masterID,
      PLB_MSize => plb_PLB_MSize,
      PLB_ordered => plb_PLB_ordered,
      PLB_PAValid => plb_PLB_PAValid,
      PLB_RNW => plb_PLB_RNW,
      PLB_size => plb_PLB_size,
      PLB_type => plb_PLB_type,
      Sl_addrAck => plb_Sl_addrAck(3),
      Sl_MBusy => plb_Sl_MBusy(9 to 11),
      Sl_MErr => plb_Sl_MErr(9 to 11),
      Sl_rearbitrate => plb_Sl_rearbitrate(3),
      Sl_SSize => plb_Sl_SSize(6 to 7),
      Sl_wait => plb_Sl_wait(3),
      PLB_rdPrim => plb_PLB_rdPrim,
      PLB_SAValid => plb_PLB_SAValid,
      PLB_wrPrim => plb_PLB_wrPrim,
      PLB_wrBurst => plb_PLB_wrBurst,
      PLB_wrDBus => plb_PLB_wrDBus,
      Sl_wrBTerm => plb_Sl_wrBTerm(3),
      Sl_wrComp => plb_Sl_wrComp(3),
      Sl_wrDAck => plb_Sl_wrDAck(3),
      PLB_rdBurst => plb_PLB_rdBurst,
      Sl_rdBTerm => plb_Sl_rdBTerm(3),
      Sl_rdComp => plb_Sl_rdComp(3),
      Sl_rdDAck => plb_Sl_rdDAck(3),
      Sl_rdDBus => plb_Sl_rdDBus(192 to 255),
      Sl_rdWdAddr => plb_Sl_rdWdAddr(12 to 15),
      PLB_pendReq => plb_PLB_pendReq,
      PLB_pendPri => plb_PLB_pendPri,
      PLB_reqPri => plb_PLB_reqPri,
      Mem_A => fpga_0_SRAM1_ZBT_512Kx32_Mem_A_split,
      Mem_CEN => open,
      Mem_OEN => fpga_0_SRAM1_ZBT_512Kx32_Mem_OEN(0 to 0),
      Mem_WEN => fpga_0_SRAM1_ZBT_512Kx32_Mem_WEN,
      Mem_QWEN => open,
      Mem_BEN => fpga_0_SRAM1_ZBT_512Kx32_Mem_BEN,
      Mem_RPN => open,
      Mem_CE => fpga_0_SRAM1_ZBT_512Kx32_Mem_CE(0 to 0),
      Mem_ADV_LDN => fpga_0_SRAM1_ZBT_512Kx32_Mem_ADV_LDN,
      Mem_LBON => open,
      Mem_CKEN => fpga_0_SRAM1_ZBT_512Kx32_Mem_CKEN,
      Mem_RNW => open,
      Mem_DQ_I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I,
      Mem_DQ_O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O,
      Mem_DQ_T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T
    );

  plb_bram_if_cntlr_1 : plb_bram_if_cntlr_1_wrapper
    port map (
      plb_clk => sys_clk_s,
      plb_rst => plb_PLB_Rst,
      plb_abort => plb_PLB_abort,
      plb_abus => plb_PLB_ABus,
      plb_be => plb_PLB_BE,
      plb_buslock => plb_PLB_busLock,
      plb_compress => plb_PLB_compress,
      plb_guarded => plb_PLB_guarded,
      plb_lockerr => plb_PLB_lockErr,
      plb_masterid => plb_PLB_masterID,
      plb_msize => plb_PLB_MSize,
      plb_ordered => plb_PLB_ordered,
      plb_pavalid => plb_PLB_PAValid,
      plb_rnw => plb_PLB_RNW,
      plb_size => plb_PLB_size,
      plb_type => plb_PLB_type,
      sl_addrack => plb_Sl_addrAck(4),
      sl_mbusy => plb_Sl_MBusy(12 to 14),
      sl_merr => plb_Sl_MErr(12 to 14),
      sl_rearbitrate => plb_Sl_rearbitrate(4),
      sl_ssize => plb_Sl_SSize(8 to 9),
      sl_wait => plb_Sl_wait(4),
      plb_rdprim => plb_PLB_rdPrim,
      plb_savalid => plb_PLB_SAValid,
      plb_wrprim => plb_PLB_wrPrim,
      plb_wrburst => plb_PLB_wrBurst,
      plb_wrdbus => plb_PLB_wrDBus,
      sl_wrbterm => plb_Sl_wrBTerm(4),
      sl_wrcomp => plb_Sl_wrComp(4),
      sl_wrdack => plb_Sl_wrDAck(4),
      plb_rdburst => plb_PLB_rdBurst,
      sl_rdbterm => plb_Sl_rdBTerm(4),
      sl_rdcomp => plb_Sl_rdComp(4),
      sl_rddack => plb_Sl_rdDAck(4),
      sl_rddbus => plb_Sl_rdDBus(256 to 319),
      sl_rdwdaddr => plb_Sl_rdWdAddr(16 to 19),
      plb_pendreq => plb_PLB_pendReq,
      plb_pendpri => plb_PLB_pendPri,
      plb_reqpri => plb_PLB_reqPri,
      bram_rst => plb_bram_if_cntlr_1_port_BRAM_Rst,
      bram_clk => plb_bram_if_cntlr_1_port_BRAM_Clk,
      bram_en => plb_bram_if_cntlr_1_port_BRAM_EN,
      bram_wen => plb_bram_if_cntlr_1_port_BRAM_WEN,
      bram_addr => plb_bram_if_cntlr_1_port_BRAM_Addr,
      bram_din => plb_bram_if_cntlr_1_port_BRAM_Din,
      bram_dout => plb_bram_if_cntlr_1_port_BRAM_Dout
    );

  plb_bram_if_cntlr_1_bram : plb_bram_if_cntlr_1_bram_wrapper
    port map (
      BRAM_Rst_A => plb_bram_if_cntlr_1_port_BRAM_Rst,
      BRAM_Clk_A => plb_bram_if_cntlr_1_port_BRAM_Clk,
      BRAM_EN_A => plb_bram_if_cntlr_1_port_BRAM_EN,
      BRAM_WEN_A => plb_bram_if_cntlr_1_port_BRAM_WEN,
      BRAM_Addr_A => plb_bram_if_cntlr_1_port_BRAM_Addr,
      BRAM_Din_A => plb_bram_if_cntlr_1_port_BRAM_Din,
      BRAM_Dout_A => plb_bram_if_cntlr_1_port_BRAM_Dout,
      BRAM_Rst_B => net_gnd0,
      BRAM_Clk_B => net_gnd0,
      BRAM_EN_B => net_gnd0,
      BRAM_WEN_B => net_gnd8,
      BRAM_Addr_B => net_gnd32,
      BRAM_Din_B => open,
      BRAM_Dout_B => net_gnd64
    );

  opb_intc_0 : opb_intc_0_wrapper
    port map (
      OPB_Clk => sys_clk_OPB,
      Intr => pgassign1,
      OPB_Rst => opb_OPB_Rst,
      OPB_ABus => opb_OPB_ABus,
      OPB_BE => opb_OPB_BE,
      OPB_RNW => opb_OPB_RNW,
      OPB_select => opb_OPB_select,
      OPB_seqAddr => opb_OPB_seqAddr,
      OPB_DBus => opb_OPB_DBus,
      IntC_DBus => opb_Sl_DBus(256 to 287),
      IntC_errAck => opb_Sl_errAck(8),
      IntC_retry => opb_Sl_retry(8),
      IntC_toutSup => opb_Sl_toutSup(8),
      IntC_xferAck => opb_Sl_xferAck(8),
      Irq => EICC405EXTINPUTIRQ
    );

  sram0_zbt_512kx32_util_bus_split_0 : sram0_zbt_512kx32_util_bus_split_0_wrapper
    port map (
      Sig => fpga_0_SRAM0_ZBT_512Kx32_Mem_A_split,
      Out1 => fpga_0_SRAM0_ZBT_512Kx32_Mem_A,
      Out2 => open
    );

  sram1_zbt_512kx32_util_bus_split_1 : sram1_zbt_512kx32_util_bus_split_1_wrapper
    port map (
      Sig => fpga_0_SRAM1_ZBT_512Kx32_Mem_A_split,
      Out1 => fpga_0_SRAM1_ZBT_512Kx32_Mem_A,
      Out2 => open
    );

  dcm_0 : dcm_0_wrapper
    port map (
      RST => clkBoardConfig_DCM_Reset,
      CLKIN => dcm_clk_s,
      CLKFB => sys_clk_OPB,
      PSEN => net_gnd0,
      PSINCDEC => net_gnd0,
      PSCLK => net_gnd0,
      DSSEN => net_gnd0,
      CLK0 => sys_clk_OPB,
      CLK90 => open,
      CLK180 => open,
      CLK270 => open,
      CLKDV => open,
      CLK2X => sys_clk_s,
      CLK2X180 => open,
      CLKFX => proc_clk_s,
      CLKFX180 => open,
      STATUS => open,
      LOCKED => dcm_0_lock,
      PSDONE => open
    );

  ofdm_timer_opbw_0 : ofdm_timer_opbw_0_wrapper
    port map (
      ce => net_vcc0,
      idlefordifs => ofdm_pktDetector_mimo_opbw_0_idlefordifs,
      opb_abus => opb_OPB_ABus,
      opb_be => opb_OPB_BE,
      opb_clk => sys_clk_OPB,
      opb_dbus => opb_OPB_DBus,
      opb_rnw => opb_OPB_RNW,
      opb_rst => opb_OPB_Rst,
      opb_select => opb_OPB_select,
      opb_seqaddr => opb_OPB_seqAddr,
      sgp_dbus => opb_Sl_DBus(288 to 319),
      sgp_errack => opb_Sl_errAck(9),
      sgp_retry => opb_Sl_retry(9),
      sgp_toutsup => opb_Sl_toutSup(9),
      sgp_xferack => opb_Sl_xferAck(9),
      timerexpire => ofdm_timer_opbw_0_timerexpire
    );

  ofdm_pktdetector_mimo_opbw_0 : ofdm_pktdetector_mimo_opbw_0_wrapper
    port map (
      ce => net_vcc0,
      opb_abus => opb_OPB_ABus,
      opb_be => opb_OPB_BE,
      opb_clk => sys_clk_OPB,
      opb_dbus => opb_OPB_DBus,
      opb_rnw => opb_OPB_RNW,
      opb_rst => opb_OPB_Rst,
      opb_select => opb_OPB_select,
      opb_seqaddr => opb_OPB_seqAddr,
      reset => rx_pktdetreset,
      rssi1 => radio_bridge_slot_2_user_RSSI_ADC_D,
      rssi2 => radio_bridge_slot_3_user_RSSI_ADC_D,
      rssi3 => net_gnd10,
      rssi4 => net_gnd10,
      avgrssi1 => open,
      avgrssi2 => open,
      avgrssi3 => open,
      avgrssi4 => open,
      debugbusy => ofdm_pktDetector_mimo_opbw_0_debugbusy,
      debugidledifs => ofdm_pktDetector_mimo_opbw_0_debugidledifs,
      idlefordifs => ofdm_pktDetector_mimo_opbw_0_idlefordifs,
      mediumbusy => open,
      pktdet => rssi_pkt_detect_opbw_0_rssi_pkt_det_out,
      rssi_clk_out => rssi_pkt_detect_opbw_0_rssi_clk_out,
      sgp_dbus => opb_Sl_DBus(320 to 351),
      sgp_errack => opb_Sl_errAck(10),
      sgp_retry => opb_Sl_retry(10),
      sgp_toutsup => opb_Sl_toutSup(10),
      sgp_xferack => opb_Sl_xferAck(10)
    );

  ofdm_txrx_mimo_opbw_0 : ofdm_txrx_mimo_opbw_0_wrapper
    port map (
      bram_addr => ofdm_TxRxPLB_BRAM_port_BRAM_Addr,
      bram_datain => ofdm_TxRxPLB_BRAM_port_BRAM_Din,
      bram_dout => ofdm_TxRxPLB_BRAM_port_BRAM_Dout,
      bram_reset => ofdm_TxRxPLB_BRAM_port_BRAM_Rst,
      bram_wen => ofdm_TxRxPLB_BRAM_port_BRAM_WEN,
      ce => net_vcc0,
      debug_chipscopetrig1 => debug_chipscopetrig,
      opb_abus => opb_OPB_ABus,
      opb_be => opb_OPB_BE,
      opb_clk => sys_clk_OPB,
      opb_dbus => opb_OPB_DBus,
      opb_rnw => opb_OPB_RNW,
      opb_rst => opb_OPB_Rst,
      opb_select => opb_OPB_select,
      opb_seqaddr => opb_OPB_seqAddr,
      rx_anta_adci_dv4 => ofdmRx_antA_ADC_I,
      rx_anta_adcq_dv4 => ofdmRx_antA_ADC_Q,
      rx_anta_agc_done => agc_done_a,
      rx_anta_gainbb => agc_g_bb_a,
      rx_anta_gainrf => agc_g_rf_a,
      rx_antb_adci_dv4 => ofdmRx_antB_ADC_I,
      rx_antb_adcq_dv4 => ofdmRx_antB_ADC_Q,
      rx_antb_agc_done => agc_done_b,
      rx_antb_gainbb => agc_g_bb_b,
      rx_antb_gainrf => agc_g_rf_b,
      rx_extpktdet => rssi_pkt_detect_opbw_0_rssi_pkt_det_out,
      rx_reset => pcoreReset(0),
      tx_reset => pcoreReset(0),
      tx_starttransmit => txPHYStart,
      rx_debug_antsel => open,
      rx_debug_eq_i => ofdm_rx_debug_eq_i,
      rx_debug_eq_q => ofdm_rx_debug_eq_q,
      rx_debug_payload => debug_rx_payload,
      rx_debug_phasecorrect => rx_debug_phasecorrect,
      rx_debug_phaseerror => open,
      rx_debug_cfophasediff => rx_debug_cfophasediff,
      rx_debug_pktdone => debug_rx_pktdone,
      rx_int_badpkt => rx_int_badpkt,
      rx_int_goodpkt => rx_int_goodpkt,
      rx_int_goodheader => rx_int_goodheader,
      tx_int_pktdone => tx_int_pktdone,
      rx_pktdetreset => rx_pktdetreset,
      sgp_dbus => opb_Sl_DBus(352 to 383),
      sgp_errack => opb_Sl_errAck(11),
      sgp_retry => opb_Sl_retry(11),
      sgp_toutsup => opb_Sl_toutSup(11),
      sgp_xferack => opb_Sl_xferAck(11),
      tx_anta_dac_i => radio_bridge_slot_2_user_DAC_I,
      tx_anta_dac_q => radio_bridge_slot_2_user_DAC_Q,
      tx_antb_dac_i => radio_bridge_slot_3_user_DAC_I,
      tx_antb_dac_q => radio_bridge_slot_3_user_DAC_Q,
      tx_debug_pktrunning => debug_tx_pktrunning
    );

  ofdm_agc_mimo_opbw_0 : ofdm_agc_mimo_opbw_0_wrapper
    port map (
      ce => net_vcc0,
      i_in_a => radio_bridge_slot_2_user_ADC_I,
      i_in_b => radio_bridge_slot_3_user_ADC_I,
      opb_abus => opb_OPB_ABus,
      opb_be => opb_OPB_BE,
      opb_clk => sys_clk_OPB,
      opb_dbus => opb_OPB_DBus,
      opb_rnw => opb_OPB_RNW,
      opb_rst => opb_OPB_Rst,
      opb_select => opb_OPB_select,
      opb_seqaddr => opb_OPB_seqAddr,
      packet_in => rssi_pkt_detect_opbw_0_rssi_pkt_det_out,
      q_in_a => radio_bridge_slot_2_user_ADC_Q,
      q_in_b => radio_bridge_slot_3_user_ADC_Q,
      reset_in => rx_pktdetreset,
      rssi_in_a => radio_bridge_slot_2_user_RSSI_ADC_D,
      rssi_in_b => radio_bridge_slot_3_user_RSSI_ADC_D,
      done_a => agc_done_a,
      done_b => agc_done_b,
      g_bb_a => agc_g_bb_a,
      g_bb_b => agc_g_bb_b,
      g_rf_a => agc_g_rf_a,
      g_rf_b => agc_g_rf_b,
      i_out_a => ofdmRx_antA_ADC_I,
      i_out_b => ofdmRx_antB_ADC_I,
      q_out_a => ofdmRx_antA_ADC_Q,
      q_out_b => ofdmRx_antB_ADC_Q,
      rxhp_a => agc_rxhp_a,
      rxhp_b => agc_rxhp_b,
      sgp_dbus => opb_Sl_DBus(384 to 415),
      sgp_errack => opb_Sl_errAck(12),
      sgp_retry => opb_Sl_retry(12),
      sgp_toutsup => opb_Sl_toutSup(12),
      sgp_xferack => opb_Sl_xferAck(12)
    );

  plb_bram_if_cntlr_2 : plb_bram_if_cntlr_2_wrapper
    port map (
      plb_clk => sys_clk_s,
      plb_rst => plb_PLB_Rst,
      plb_abort => plb_PLB_abort,
      plb_abus => plb_PLB_ABus,
      plb_be => plb_PLB_BE,
      plb_buslock => plb_PLB_busLock,
      plb_compress => plb_PLB_compress,
      plb_guarded => plb_PLB_guarded,
      plb_lockerr => plb_PLB_lockErr,
      plb_masterid => plb_PLB_masterID,
      plb_msize => plb_PLB_MSize,
      plb_ordered => plb_PLB_ordered,
      plb_pavalid => plb_PLB_PAValid,
      plb_rnw => plb_PLB_RNW,
      plb_size => plb_PLB_size,
      plb_type => plb_PLB_type,
      sl_addrack => plb_Sl_addrAck(5),
      sl_mbusy => plb_Sl_MBusy(15 to 17),
      sl_merr => plb_Sl_MErr(15 to 17),
      sl_rearbitrate => plb_Sl_rearbitrate(5),
      sl_ssize => plb_Sl_SSize(10 to 11),
      sl_wait => plb_Sl_wait(5),
      plb_rdprim => plb_PLB_rdPrim,
      plb_savalid => plb_PLB_SAValid,
      plb_wrprim => plb_PLB_wrPrim,
      plb_wrburst => plb_PLB_wrBurst,
      plb_wrdbus => plb_PLB_wrDBus,
      sl_wrbterm => plb_Sl_wrBTerm(5),
      sl_wrcomp => plb_Sl_wrComp(5),
      sl_wrdack => plb_Sl_wrDAck(5),
      plb_rdburst => plb_PLB_rdBurst,
      sl_rdbterm => plb_Sl_rdBTerm(5),
      sl_rdcomp => plb_Sl_rdComp(5),
      sl_rddack => plb_Sl_rdDAck(5),
      sl_rddbus => plb_Sl_rdDBus(320 to 383),
      sl_rdwdaddr => plb_Sl_rdWdAddr(20 to 23),
      plb_pendreq => plb_PLB_pendReq,
      plb_pendpri => plb_PLB_pendPri,
      plb_reqpri => plb_PLB_reqPri,
      bram_rst => plb_bram_if_cntlr_2_port_BRAM_Rst,
      bram_clk => plb_bram_if_cntlr_2_port_BRAM_Clk,
      bram_en => plb_bram_if_cntlr_2_port_BRAM_EN,
      bram_wen => plb_bram_if_cntlr_2_port_BRAM_WEN,
      bram_addr => plb_bram_if_cntlr_2_port_BRAM_Addr,
      bram_din => plb_bram_if_cntlr_2_port_BRAM_Din,
      bram_dout => plb_bram_if_cntlr_2_port_BRAM_Dout
    );

  plb_bram_if_cntlr_2_bram : plb_bram_if_cntlr_2_bram_wrapper
    port map (
      BRAM_Rst_A => plb_bram_if_cntlr_2_port_BRAM_Rst,
      BRAM_Clk_A => plb_bram_if_cntlr_2_port_BRAM_Clk,
      BRAM_EN_A => plb_bram_if_cntlr_2_port_BRAM_EN,
      BRAM_WEN_A => plb_bram_if_cntlr_2_port_BRAM_WEN,
      BRAM_Addr_A => plb_bram_if_cntlr_2_port_BRAM_Addr,
      BRAM_Din_A => plb_bram_if_cntlr_2_port_BRAM_Din,
      BRAM_Dout_A => plb_bram_if_cntlr_2_port_BRAM_Dout,
      BRAM_Rst_B => ofdm_TxRxPLB_BRAM_port_BRAM_Rst,
      BRAM_Clk_B => sys_clk_OPB,
      BRAM_EN_B => net_vcc0,
      BRAM_WEN_B => ofdm_TxRxPLB_BRAM_port_BRAM_WEN,
      BRAM_Addr_B => ofdm_TxRxPLB_BRAM_port_BRAM_Addr,
      BRAM_Din_B => ofdm_TxRxPLB_BRAM_port_BRAM_Din,
      BRAM_Dout_B => ofdm_TxRxPLB_BRAM_port_BRAM_Dout
    );

  debugoutputs : debugoutputs_wrapper
    port map (
      OPB_ABus => opb_OPB_ABus,
      OPB_BE => opb_OPB_BE,
      OPB_Clk => sys_clk_OPB,
      OPB_DBus => opb_OPB_DBus,
      OPB_RNW => opb_OPB_RNW,
      OPB_Rst => opb_OPB_Rst,
      OPB_select => opb_OPB_select,
      OPB_seqAddr => opb_OPB_seqAddr,
      Sln_DBus => opb_Sl_DBus(416 to 447),
      Sln_errAck => opb_Sl_errAck(13),
      Sln_retry => opb_Sl_retry(13),
      Sln_toutSup => opb_Sl_toutSup(13),
      Sln_xferAck => opb_Sl_xferAck(13),
      IP2INTC_Irpt => open,
      GPIO_in => net_gnd4,
      GPIO_d_out => fpga_0_debug_GPIO_d_out,
      GPIO_t_out => open,
      GPIO2_in => net_gnd4,
      GPIO2_d_out => open,
      GPIO2_t_out => open,
      GPIO_IO_I => net_gnd4,
      GPIO_IO_O => open,
      GPIO_IO_T => open,
      GPIO2_IO_I => net_gnd4,
      GPIO2_IO_O => open,
      GPIO2_IO_T => open
    );

  util_reduced_logic_0 : util_reduced_logic_0_wrapper
    port map (
      Op1 => pgassign2,
      Res => txPHYStart
    );

  user_io_board_controller_opbw_0 : user_io_board_controller_opbw_0_wrapper
    port map (
      ce => net_vcc0,
      opb_abus => opb_OPB_ABus,
      opb_be => opb_OPB_BE,
      opb_clk => sys_clk_OPB,
      opb_dbus => opb_OPB_DBus,
      opb_rnw => opb_OPB_RNW,
      opb_rst => opb_OPB_Rst,
      opb_select => opb_OPB_select,
      opb_seqaddr => opb_OPB_seqAddr,
      reset => pcoreReset(0),
      cs => user_io_board_controller_opbw_0_cs,
      resetlcd => user_io_board_controller_opbw_0_resetlcd,
      scl => user_io_board_controller_opbw_0_scl,
      sdi => user_io_board_controller_opbw_0_sdi,
      sgp_dbus => opb_Sl_DBus(448 to 479),
      sgp_errack => opb_Sl_errAck(14),
      sgp_retry => opb_Sl_retry(14),
      sgp_toutsup => opb_Sl_toutSup(14),
      sgp_xferack => opb_Sl_xferAck(14)
    );

  iobuf_0 : IOBUF
    port map (
      I => fpga_0_eeprom_controller_DQ0_O,
      IO => fpga_0_eeprom_controller_DQ0_pin,
      O => fpga_0_eeprom_controller_DQ0_I,
      T => fpga_0_eeprom_controller_DQ0_T
    );

  iobuf_1 : IOBUF
    port map (
      I => fpga_0_Ethernet_MAC_PHY_Mii_clk_O,
      IO => fpga_0_Ethernet_MAC_PHY_Mii_clk_pin,
      O => fpga_0_Ethernet_MAC_PHY_Mii_clk_I,
      T => fpga_0_Ethernet_MAC_PHY_Mii_clk_T
    );

  iobuf_2 : IOBUF
    port map (
      I => fpga_0_Ethernet_MAC_PHY_Mii_data_O,
      IO => fpga_0_Ethernet_MAC_PHY_Mii_data_pin,
      O => fpga_0_Ethernet_MAC_PHY_Mii_data_I,
      T => fpga_0_Ethernet_MAC_PHY_Mii_data_T
    );

  iobuf_3 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(0),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(0),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(0),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(0)
    );

  iobuf_4 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(1),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(1),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(1),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(1)
    );

  iobuf_5 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(2),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(2),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(2),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(2)
    );

  iobuf_6 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(3),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(3),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(3),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(3)
    );

  iobuf_7 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(4),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(4),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(4),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(4)
    );

  iobuf_8 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(5),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(5),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(5),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(5)
    );

  iobuf_9 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(6),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(6),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(6),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(6)
    );

  iobuf_10 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(7),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(7),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(7),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(7)
    );

  iobuf_11 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(8),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(8),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(8),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(8)
    );

  iobuf_12 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(9),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(9),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(9),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(9)
    );

  iobuf_13 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(10),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(10),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(10),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(10)
    );

  iobuf_14 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(11),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(11),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(11),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(11)
    );

  iobuf_15 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(12),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(12),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(12),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(12)
    );

  iobuf_16 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(13),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(13),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(13),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(13)
    );

  iobuf_17 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(14),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(14),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(14),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(14)
    );

  iobuf_18 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(15),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(15),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(15),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(15)
    );

  iobuf_19 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(16),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(16),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(16),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(16)
    );

  iobuf_20 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(17),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(17),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(17),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(17)
    );

  iobuf_21 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(18),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(18),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(18),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(18)
    );

  iobuf_22 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(19),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(19),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(19),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(19)
    );

  iobuf_23 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(20),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(20),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(20),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(20)
    );

  iobuf_24 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(21),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(21),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(21),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(21)
    );

  iobuf_25 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(22),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(22),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(22),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(22)
    );

  iobuf_26 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(23),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(23),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(23),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(23)
    );

  iobuf_27 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(24),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(24),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(24),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(24)
    );

  iobuf_28 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(25),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(25),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(25),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(25)
    );

  iobuf_29 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(26),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(26),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(26),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(26)
    );

  iobuf_30 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(27),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(27),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(27),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(27)
    );

  iobuf_31 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(28),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(28),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(28),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(28)
    );

  iobuf_32 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(29),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(29),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(29),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(29)
    );

  iobuf_33 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(30),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(30),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(30),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(30)
    );

  iobuf_34 : IOBUF
    port map (
      I => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_O(31),
      IO => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_pin(31),
      O => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_I(31),
      T => fpga_0_SRAM0_ZBT_512Kx32_Mem_DQ_T(31)
    );

  iobuf_35 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(0),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(0),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(0),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(0)
    );

  iobuf_36 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(1),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(1),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(1),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(1)
    );

  iobuf_37 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(2),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(2),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(2),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(2)
    );

  iobuf_38 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(3),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(3),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(3),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(3)
    );

  iobuf_39 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(4),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(4),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(4),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(4)
    );

  iobuf_40 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(5),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(5),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(5),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(5)
    );

  iobuf_41 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(6),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(6),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(6),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(6)
    );

  iobuf_42 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(7),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(7),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(7),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(7)
    );

  iobuf_43 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(8),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(8),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(8),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(8)
    );

  iobuf_44 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(9),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(9),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(9),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(9)
    );

  iobuf_45 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(10),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(10),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(10),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(10)
    );

  iobuf_46 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(11),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(11),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(11),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(11)
    );

  iobuf_47 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(12),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(12),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(12),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(12)
    );

  iobuf_48 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(13),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(13),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(13),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(13)
    );

  iobuf_49 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(14),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(14),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(14),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(14)
    );

  iobuf_50 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(15),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(15),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(15),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(15)
    );

  iobuf_51 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(16),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(16),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(16),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(16)
    );

  iobuf_52 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(17),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(17),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(17),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(17)
    );

  iobuf_53 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(18),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(18),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(18),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(18)
    );

  iobuf_54 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(19),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(19),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(19),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(19)
    );

  iobuf_55 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(20),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(20),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(20),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(20)
    );

  iobuf_56 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(21),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(21),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(21),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(21)
    );

  iobuf_57 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(22),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(22),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(22),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(22)
    );

  iobuf_58 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(23),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(23),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(23),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(23)
    );

  iobuf_59 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(24),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(24),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(24),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(24)
    );

  iobuf_60 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(25),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(25),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(25),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(25)
    );

  iobuf_61 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(26),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(26),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(26),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(26)
    );

  iobuf_62 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(27),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(27),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(27),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(27)
    );

  iobuf_63 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(28),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(28),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(28),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(28)
    );

  iobuf_64 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(29),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(29),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(29),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(29)
    );

  iobuf_65 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(30),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(30),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(30),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(30)
    );

  iobuf_66 : IOBUF
    port map (
      I => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_O(31),
      IO => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_pin(31),
      O => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_I(31),
      T => fpga_0_SRAM1_ZBT_512Kx32_Mem_DQ_T(31)
    );

end architecture STRUCTURE;

